
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16L
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : long, width
;(s)scanf features        : long, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16L
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _meny=R6
	.DEF _sek=R5
	.DEF _chislo=R8
	.DEF _mesec=R7
	.DEF _god=R10
	.DEF _den_nedeli=R9
	.DEF _bud_temp=R12
	.DEF _stroka=R11
	.DEF _button=R14
	.DEF _but_pause=R13

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  _timer2_comp_isr
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  _timer1_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _ana_comp_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer0_comp_isr
	JMP  0x00

_den_nedeli_txt:
	.DB  0x19,0x18,0x17,0xF,0xE,0xF,0x15,0x26
	.DB  0x17,0x12,0x14,0xFF,0xC,0x1C,0x18,0x1A
	.DB  0x17,0x12,0x14,0xFF,0x0,0x0,0x0,0x0
	.DB  0x1B,0x1A,0xF,0xE,0xA,0xFF,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x21,0xF,0x1C,0xC
	.DB  0xF,0x1A,0xD,0xFF,0x0,0x0,0x0,0x0
	.DB  0x19,0x29,0x1C,0x17,0x12,0x20,0xA,0xFF
	.DB  0x0,0x0,0x0,0x0,0x1B,0x1D,0xB,0xB
	.DB  0x18,0x1C,0xA,0xFF,0x0,0x0,0x0,0x0
	.DB  0xC,0x18,0x1B,0x14,0x1A,0xF,0x1B,0xF
	.DB  0x17,0x26,0xF,0xFF
_den_nedeli_letter:
	.DB  0x19,0x17,0xC,0x1C,0x1B,0x1A,0x21,0x1C
	.DB  0x19,0x1C,0x1B,0xB,0xC,0x1B
_name_mesec_txt:
	.DB  0x29,0x17,0xC,0xA,0x1A,0x29,0xFF,0x0
	.DB  0x0,0x1E,0xF,0xC,0x1A,0xA,0x15,0x29
	.DB  0xFF,0x0,0x16,0xA,0x1A,0x1C,0xA,0xFF
	.DB  0x0,0x0,0x0,0xA,0x19,0x1A,0xF,0x15
	.DB  0x29,0xFF,0x0,0x0,0x16,0xA,0x29,0xFF
	.DB  0x0,0x0,0x0,0x0,0x0,0x12,0x28,0x17
	.DB  0x29,0xFF,0x0,0x0,0x0,0x0,0x12,0x28
	.DB  0x15,0x29,0xFF,0x0,0x0,0x0,0x0,0xA
	.DB  0xC,0xD,0x1D,0x1B,0x1C,0xA,0xFF,0x0
	.DB  0x1B,0xF,0x17,0x1C,0x29,0xB,0x1A,0x29
	.DB  0xFF,0x18,0x14,0x1C,0x29,0xB,0x1A,0x29
	.DB  0xFF,0x0,0x17,0x18,0x29,0xB,0x1A,0x29
	.DB  0xFF,0x0,0x0,0xE,0xF,0x14,0xA,0xB
	.DB  0x1A,0x29,0xFF,0x0
_simvol_0:
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E
_simvol_1:
	.DB  0x7F,0x7F,0x41,0x7F,0x7F,0x0,0x0,0x7F
	.DB  0x7F,0x0,0x61,0x71,0x59,0x4F,0x47,0x41
	.DB  0x49,0x49,0x7F,0x7F,0x1F,0x1F,0x10,0x7F
	.DB  0x7F,0x4F,0x4F,0x49,0x79,0x79,0x7F,0x7F
	.DB  0x49,0x79,0x79,0x1,0x71,0x79,0xF,0x7
	.DB  0x7F,0x7F,0x49,0x7F,0x7F,0x5F,0x5F,0x51
	.DB  0x7F,0x7F
_simvol_2:
	.DB  0x7F,0x7F,0x41,0x7F,0x7F,0x0,0x1,0x7F
	.DB  0x7F,0x0,0x63,0x73,0x59,0x4F,0x47,0x63
	.DB  0x63,0x49,0x7F,0x77,0x1F,0x1F,0x10,0x7F
	.DB  0x7F,0x6F,0x6F,0x49,0x79,0x79,0x7F,0x7F
	.DB  0x49,0x7B,0x7B,0x3,0x73,0x79,0xF,0x7
	.DB  0x77,0x7F,0x49,0x7F,0x77,0x6F,0x6F,0x49
	.DB  0x7F,0x7F
_simvol_3:
	.DB  0x7F,0x41,0x41,0x7F,0x7F,0x0,0x0,0x7F
	.DB  0x7F,0x0,0x61,0x71,0x59,0x4F,0x47,0x41
	.DB  0x49,0x49,0x7F,0x7F,0x1F,0x10,0x10,0x7F
	.DB  0x7F,0x4F,0x49,0x49,0x79,0x79,0x7F,0x49
	.DB  0x49,0x79,0x79,0x1,0x1,0x1,0x7F,0x7F
	.DB  0x7F,0x49,0x49,0x7F,0x7F,0x1F,0x11,0x11
	.DB  0x7F,0x7F
_simvol_4:
	.DB  0x7F,0x41,0x41,0x7F,0x7F,0x0,0x1,0x7F
	.DB  0x7F,0x0,0x63,0x71,0x59,0x4F,0x47,0x63
	.DB  0x41,0x49,0x7F,0x7F,0x1F,0x10,0x10,0x7F
	.DB  0x7F,0x6F,0x49,0x49,0x79,0x79,0x7F,0x49
	.DB  0x49,0x7B,0x7B,0x3,0x1,0x1,0x7F,0x7F
	.DB  0x7F,0x49,0x49,0x7F,0x7F,0x1F,0x11,0x11
	.DB  0x7F,0x7F
_simvol_5:
	.DB  0x3E,0x7F,0x41,0x7F,0x3E,0x0,0x2,0x7F
	.DB  0x7F,0x0,0x62,0x73,0x59,0x4F,0x46,0x22
	.DB  0x63,0x49,0x7F,0x36,0x18,0x14,0x12,0x7F
	.DB  0x7F,0x2F,0x6F,0x45,0x7D,0x39,0x3E,0x7F
	.DB  0x49,0x7B,0x32,0x3,0x73,0x79,0xF,0x7
	.DB  0x36,0x7F,0x49,0x7F,0x36,0x2E,0x6F,0x49
	.DB  0x7F,0x3E
_simvol_6:
	.DB  0x3E,0x41,0x41,0x7F,0x3E,0x0,0x2,0x7F
	.DB  0x7F,0x0,0x62,0x71,0x59,0x4F,0x46,0x22
	.DB  0x41,0x49,0x7F,0x36,0x18,0x14,0x12,0x7F
	.DB  0x7F,0x2F,0x45,0x45,0x7D,0x39,0x3E,0x49
	.DB  0x49,0x7B,0x32,0x3,0x71,0x79,0xF,0x7
	.DB  0x36,0x49,0x49,0x7F,0x36,0x26,0x49,0x49
	.DB  0x7F,0x3E
_simvol_buk:
	.DB  0x7C,0x12,0x12,0x7C,0xAA,0x7E,0x4A,0x4A
	.DB  0x32,0xAA,0x7E,0x4A,0x4A,0x34,0xAA,0x7E
	.DB  0x2,0x2,0xAA,0x0,0x60,0x3C,0x22,0x3E
	.DB  0x60,0x7E,0x4A,0x4A,0xAA,0x0,0x24,0x42
	.DB  0x4A,0x34,0x0,0x66,0x18,0x7E,0x18,0x66
	.DB  0x7E,0x10,0x8,0x7E,0xAA,0x7C,0x11,0x9
	.DB  0x7C,0xAA,0x7E,0x18,0x24,0x42,0xAA,0x78
	.DB  0x4,0x2,0x7E,0xAA,0x7E,0x4,0x8,0x4
	.DB  0x7E,0x7E,0x8,0x8,0x7E,0xAA,0x3C,0x42
	.DB  0x42,0x3C,0xAA,0x7E,0x2,0x2,0x7E,0xAA
	.DB  0x7E,0x12,0x12,0xC,0xAA,0x3C,0x42,0x42
	.DB  0x24,0xAA,0x2,0x7E,0x2,0xAA,0x0,0x4E
	.DB  0x50,0x50,0x3E,0xAA,0xC,0x12,0x7E,0x12
	.DB  0xC,0x66,0x18,0x18,0x66,0xAA,0x7E,0x40
	.DB  0x40,0x7E,0xC0,0xE,0x10,0x10,0x7E,0xAA
	.DB  0x7E,0x40,0x7E,0x40,0x7E,0x7E,0x40,0x7E
	.DB  0x40,0xFE,0x2,0x7E,0x48,0x30,0xAA,0x7E
	.DB  0x48,0x30,0x0,0x7E,0x7E,0x48,0x30,0xAA
	.DB  0x0,0x24,0x42,0x4A,0x3C,0xAA,0x7E,0x8
	.DB  0x3C,0x42,0x3C,0x4C,0x32,0x12,0x7E,0xAA
	.DB  0x0,0x0,0xAA,0xAA,0x0,0x40,0xAA,0xAA
	.DB  0xAA,0x0,0xAA,0xAA,0xAA,0xAA,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x8,0x8,0x8,0x8
	.DB  0x8,0x8,0x8,0x3E,0x8,0x8,0x6,0x9
	.DB  0x9,0x6,0xAA,0x3E,0x41,0x41,0x41,0x22
	.DB  0x4,0x3F,0x44,0x20,0xAA,0x8,0x8,0x8
	.DB  0xAA,0x0,0x3F,0x40,0x40,0x3F,0x0,0x0
	.DB  0xAA,0xAA,0xAA,0xAA
_dnei_v_mesc:
	.DB  0x1F,0x1D,0x1F,0x1E,0x1F,0x1E,0x1F,0x1F
	.DB  0x1E,0x1F,0x1E,0x1F
_bit_mask_G100:
	.DB  0xF8,0xFF,0xFC,0xFF,0xFE,0xFF,0xFF,0xFF

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x4800
	.DW  0x0000

;DATA STACK END MARKER INITIALIZATION
__DSTACK_END_INIT:
	.DB  'D','S','T','A','C','K','E','N','D',0

;HARDWARE STACK END MARKER INITIALIZATION
__HSTACK_END_INIT:
	.DB  'H','S','T','A','C','K','E','N','D',0

_0x3:
	.DB  0x1
_0x4:
	.DB  0xB,0x1D,0xE,0x12,0x15,0x26,0x17,0x12
	.DB  0x14,0x2A,0xFF
_0x5:
	.DB  0x14,0x18,0x1A,0x1A,0xF,0x14,0x20,0x12
	.DB  0x29,0x2A,0x2A,0xFF
_0x6:
	.DB  0x1D,0x1B,0x1C,0xA,0x17,0x18,0xC,0x14
	.DB  0x12,0x2A,0xFF
_0x7:
	.DB  0x17,0xA,0x1B,0x1C,0x1A,0x18,0x13,0x14
	.DB  0xA,0x2A,0xFF
_0x8:
	.DB  0x1B,0x14,0x18,0x1A,0x18,0x1B,0x1C,0x26
	.DB  0x2A,0xB,0xF,0xD,0x1D,0x23,0xF,0x13
	.DB  0x2A,0x1B,0x1C,0x1A,0x18,0x14,0x12,0x2A
	.DB  0xFF
_0x9:
	.DB  0x19,0xF,0x1A,0xF,0x17,0xA,0x10,0x17
	.DB  0xA,0x21,0xF,0x17,0x12,0xF,0x2A,0xE
	.DB  0xA,0x1C,0x21,0x12,0x14,0x18,0xC,0x2A
	.DB  0xFF
_0xA:
	.DB  0x1B,0x1A,0xA,0xB,0xA,0x1C,0x25,0xC
	.DB  0xA,0x1C,0x26,0x2A,0xFF
_0xB:
	.DB  0x12,0x17,0x1C,0xF,0x1A,0xC,0xA,0x15
	.DB  0x2A,0xB,0xF,0xD,0x1D,0x23,0xF,0x13
	.DB  0x2A,0x1B,0x1C,0x1A,0x18,0x14,0x12,0x2A
	.DB  0xFF
_0xC:
	.DB  0x0,0x1,0x2,0x3,0x4,0x5,0x6,0x7
	.DB  0x8,0x9,0x2A,0xFF
_0xD:
	.DB  0xD0,0x2
_0xE:
	.DB  0xA,0x0,0x14,0x0,0x1E,0x0,0x28,0x0
	.DB  0x32,0x0,0x3C,0x0,0x46,0x0,0x50,0x0
	.DB  0x5A,0x0,0x64,0x0,0x6E,0x0,0x78,0x0
	.DB  0x82,0x0,0x8C
_0x321:
	.DB  0x0,0xA,0xB,0x4,0x0,0xC,0x0,0x0
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x03
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x09
	.DW  __SRAM_START
	.DW  __DSTACK_END_INIT*2

	.DW  0x09
	.DW  0x42A
	.DW  __HSTACK_END_INIT*2

	.DW  0x01
	.DW  _flg_korr
	.DW  _0x3*2

	.DW  0x0B
	.DW  _budilnik_txt
	.DW  _0x4*2

	.DW  0x0C
	.DW  _korekt_txt
	.DW  _0x5*2

	.DW  0x0B
	.DW  _nastroiki_txt
	.DW  _0x6*2

	.DW  0x0B
	.DW  _nastr_stroki_txt
	.DW  _0x7*2

	.DW  0x19
	.DW  _speed_txt
	.DW  _0x8*2

	.DW  0x19
	.DW  _perenazna_datchik
	.DW  _0x9*2

	.DW  0x0D
	.DW  _budilnik_raz_txt
	.DW  _0xA*2

	.DW  0x19
	.DW  _interval_txt
	.DW  _0xB*2

	.DW  0x0C
	.DW  _font_zifr_txt
	.DW  _0xC*2

	.DW  0x02
	.DW  _time
	.DW  _0xD*2

	.DW  0x1B
	.DW  _temperature_G000
	.DW  _0xE*2

	.DW  0x09
	.DW  0x05
	.DW  _0x321*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/***********************************************************************************************
;   -  ATmega16/16L/32A/32L    (       3  )
;  - 8,000000 MHz
;**********************************************************************************************/
;//    4-11-12 _____ 1.08 O-LED
;//*********************************************************************************************/
;//     
;#define   ATMEGA16          1
;#define   ATMEGA32          0
;//*********************************************************************************************/
;//     
;#define   OK                1         //    ""  (  5, 2, 7, 1, 12, 8, 14, 9  )
;#define   OA                0        //    ""  (  5, 2, 7, 1, 12, 8, 14, 9   )
;//*********************************************************************************************/
;//  FONT      ( 0  6)
;#define   FONT              5         //   
;//*********************************************************************************************/
;//**********************************************************************************************/
;#define   RET_CLOCK        60      //        ( )
;//*********************************************************************************************/
;#define   DLITEL_ZVONKA     10      //     ( )
;//**********************************************************************************************/
;
;# if ATMEGA16
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;# endif
;# if ATMEGA32
;#include <mega32.h>
;# endif
;
;#include <1wire.h>
;#include <ds18b20_.h>
;#include <delay.h>
;
;#define   BUT_OK      button==1
;#define   BUT_STEP    button==2
;#define   POWER       power
;#define   ON          1
;#define   OFF         0
;//*********************************************************************************************/
;
;bit                 mig, mig_vrem, flg_min=0,  mig1,/* mig_05,*/ bud_flg=0, budilnik=0,enable_date=0 ,enable_write_buf=0,but_flg=0, zv_kn=0,  full_str=0, zv_chs=1, but_on=0, line=0, power=1, temp5=0, flg_adch, flg_ds18b20;
;unsigned char       meny=10, sek=0, chislo=4, mesec=11, god=12, den_nedeli,  bud_temp, stroka, button, but_pause=0,  z, z1, bud, temp, temp1=0,
;                    temp2=0, t, flg_korr=1,  foto_r=0,str_sec=0,font_, sek0=0 ,  mig1_pause=0,

	.DSEG
;
;                    ekran            [24],           //   
;                    beg_info         [150],          //     
;                    rom_code         [2][9],         //      DS18B20
;                    budilnik_Install [9],            //   
;                    budilnik_raz[4];                 //     
;unsigned   int      budilnik_time    [9];            //    
;
; const unsigned char
;        budilnik_txt          []= {11,29,14,18,21,38,23,18,20,42,255},       //  ""
;        korekt_txt            []= {20,24,26,26,15,20,32,18,41,42,42,255},    //  ""
;        nastroiki_txt         []= {29,27,28,10,23,24,12,20,18,42,255},       //  ""
;        nastr_stroki_txt      []= {23,10,27,28,26,24,19,20,10,42,255},       //  ""
;        speed_txt             []= {27,20,24,26,24,27,28,38,42,11,15,13,29,35,15,19,42,27,28,26,24,20,18,42,255},  //  "  "
;        perenazna_datchik     []= {25,15,26,15,23,10,16,23,10,33,15,23,18,15,42,14,10,28,33,18,20,24,12,42,255},  //  " "
;        budilnik_raz_txt      []= {27,26,10,11,10,28,37,12,10,28,38,42,255},                                      //  ""
;        interval_txt          []= {18,23,28,15,26,12,10,21,42,11,15,13,29,35,15,19,42,27,28,26,24,20,18,42,255},  //  "  "
;        font_zifr_txt         []= {0,1,2,3,4,5,6,7,8,9,42,255};                  //  "0123456789"
;flash const unsigned char
;        den_nedeli_txt  [7][12]= {{25,24,23,15,14,15,21,38,23,18,20,255},   //      //    
;                                 {12,28,24,26,23,18,20,255},                //          //
;                                 {27,26,15,14,10,255},                      //            //
;                                 {33,15,28,12,15,26,13,255},                //          //
;                                 {25,41,28,23,18,32,10,255},                //          //
;                                 {27,29,11,11,24,28,10,255},                //          //
;                                 {12,24,27,20,26,15,27,15,23,38,15,255}},   //      //
;        den_nedeli_letter[7][2]= {{25,23},                                  //               //     
;                                 {12,28},                                   //               //
;                                 {27,26},                                   //               //
;                                 {33,28},                                   //               //
;                                 {25,28},                                   //               //
;                                 {27,11},                                   //               //
;                                 {12,27}},                                  //               //
;        name_mesec_txt  [12][9]= {{41,23,12,10,26,41,255},                  // 
;                                 {30,15,12,26,10,21,41,255},                // 
;                                 {22,10,26,28,10,255},                      // 
;                                 {10,25,26,15,21,41,255},                   // 
;                                 {22,10,41,255},                            // 
;                                 {18,40,23,41,255},                         // 
;                                 {18,40,21,41,255},                         // 
;                                 {10,12,13,29,27,28,10,255},                // 
;                                 {27,15,23,28,41,11,26,41,255},             // 
;                                 {24,20,28,41,11,26,41,255},                // 
;                                 {23,24,41,11,26,41,255},                   // 
;                                 {14,15,20,10,11,26,41,255}};               // 
;
;flash  const unsigned char // simvol [][5]=
;   // {
;
;simvol_0 [][5]=
;{
;   // # if FONT==0    //    0
;    { 0x3E, 0x51, 0x49, 0x45, 0x3E },  // 0
;    { 0x00, 0x42, 0x7F, 0x40, 0x00 },  // 1
;    { 0x42, 0x61, 0x51, 0x49, 0x46 },  // 2
;    { 0x21, 0x41, 0x45, 0x4B, 0x31 },  // 3
;    { 0x18, 0x14, 0x12, 0x7F, 0x10 },  // 4
;    { 0x27, 0x45, 0x45, 0x45, 0x39 },  // 5
;    { 0x3C, 0x4A, 0x49, 0x49, 0x30 },  // 6
;    { 0x01, 0x71, 0x09, 0x05, 0x03 },  // 7
;    { 0x36, 0x49, 0x49, 0x49, 0x36 },  // 8
;    { 0x06, 0x49, 0x49, 0x29, 0x1E },  // 9
;   // # endif
;
;    },
;        simvol_1 [][5] =
;        {
;    //# if FONT==1    //    1
;    { 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x00, 0x7F, 0x7F, 0x00 },
;    { 0x61, 0x71, 0x59, 0x4F, 0x47 },
;    { 0x41, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
;    { 0x4F, 0x4F, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x7F, 0x49, 0x79, 0x79 },
;    { 0x01, 0x71, 0x79, 0x0F, 0x07 },
;    { 0x7F, 0x7F, 0x49, 0x7F, 0x7F },
;    { 0x5F, 0x5F, 0x51, 0x7F, 0x7F },
;   // # endif
;
;    },
;
;     simvol_2 [][5]=
;     {
;    // # if FONT==2    //    2
;    { 0x7F, 0x7F, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x01, 0x7F, 0x7F, 0x00 },
;    { 0x63, 0x73, 0x59, 0x4F, 0x47 },
;    { 0x63, 0x63, 0x49, 0x7F, 0x77 },
;    { 0x1F, 0x1F, 0x10, 0x7F, 0x7F },
;    { 0x6F, 0x6F, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x7F, 0x49, 0x7B, 0x7B },
;    { 0x03, 0x73, 0x79, 0x0F, 0x07 },
;    { 0x77, 0x7F, 0x49, 0x7F, 0x77 },
;    { 0x6F, 0x6F, 0x49, 0x7F, 0x7F },
;    // # endif
;
;
;    },
;
;     simvol_3 [][5]=
;     {
;    // # if FONT==3    //    3
;    { 0x7F, 0x41, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x00, 0x7F, 0x7F, 0x00 },
;    { 0x61, 0x71, 0x59, 0x4F, 0x47 },
;    { 0x41, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x10, 0x10, 0x7F, 0x7F },
;    { 0x4F, 0x49, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x49, 0x49, 0x79, 0x79 },
;    { 0x01, 0x01, 0x01, 0x7F, 0x7F },
;    { 0x7F, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x11, 0x11, 0x7F, 0x7F },
;    //# endif
;
;    },
;
;     simvol_4 [][5]=
;     {
;    // # if FONT==4    //    4
;    { 0x7F, 0x41, 0x41, 0x7F, 0x7F },
;    { 0x00, 0x01, 0x7F, 0x7F, 0x00 },
;    { 0x63, 0x71, 0x59, 0x4F, 0x47 },
;    { 0x63, 0x41, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x10, 0x10, 0x7F, 0x7F },
;    { 0x6F, 0x49, 0x49, 0x79, 0x79 },
;    { 0x7F, 0x49, 0x49, 0x7B, 0x7B },
;    { 0x03, 0x01, 0x01, 0x7F, 0x7F },
;    { 0x7F, 0x49, 0x49, 0x7F, 0x7F },
;    { 0x1F, 0x11, 0x11, 0x7F, 0x7F },
;    //# endif
;
;
;    },
;    simvol_5 [][5]=
;    {
;      //  FONT==5    //    5
;    { 0x3E, 0x7F, 0x41, 0x7F, 0x3E },
;    { 0x00, 0x02, 0x7F, 0x7F, 0x00 },
;    { 0x62, 0x73, 0x59, 0x4F, 0x46 },
;    { 0x22, 0x63, 0x49, 0x7F, 0x36 },
;    { 0x18, 0x14, 0x12, 0x7F, 0x7F },
;    { 0x2F, 0x6F, 0x45, 0x7D, 0x39 },
;    { 0x3E, 0x7F, 0x49, 0x7B, 0x32 },
;    { 0x03, 0x73, 0x79, 0x0F, 0x07 },
;    { 0x36, 0x7F, 0x49, 0x7F, 0x36 },
;    { 0x2E, 0x6F, 0x49, 0x7F, 0x3E },
;
;
;
;    },
;
;simvol_6 [][5]=
;    {
;   //     # if FONT==6    //    6
;    { 0x3E, 0x41, 0x41, 0x7F, 0x3E },
;    { 0x00, 0x02, 0x7F, 0x7F, 0x00 },
;    { 0x62, 0x71, 0x59, 0x4F, 0x46 },
;    { 0x22, 0x41, 0x49, 0x7F, 0x36 },
;    { 0x18, 0x14, 0x12, 0x7F, 0x7F },
;    { 0x2F, 0x45, 0x45, 0x7D, 0x39 },
;    { 0x3E, 0x49, 0x49, 0x7B, 0x32 },
;    { 0x03, 0x71, 0x79, 0x0F, 0x07 },
;    { 0x36, 0x49, 0x49, 0x7F, 0x36 },
;    { 0x26, 0x49, 0x49, 0x7F, 0x3E },
;  },
;  simvol_buk [][5]=
;  {
;	{ 0x7C, 0x12, 0x12, 0x7C, 0xAA },  //   10
;	{ 0x7E, 0x4A, 0x4A, 0x32, 0xAA },  //   11
;	{ 0x7E, 0x4A, 0x4A, 0x34, 0xAA },  //   12
;	{ 0x7E, 0x02, 0x02, 0xAA, 0x00 },  //   13
;	{ 0x60, 0x3C, 0x22, 0x3E, 0x60 },  //   14
;	{ 0x7E, 0x4A, 0x4A, 0xAA, 0x00 },  //   15
;	{ 0x24, 0x42, 0x4A, 0x34, 0x00 },  //   16
;	{ 0x66, 0x18, 0x7E, 0x18, 0x66 },  //   17
;	{ 0x7E, 0x10, 0x08, 0x7E, 0xAA },  //   18
;	{ 0x7C, 0x11, 0x09, 0x7C, 0xAA },  //   19
;	{ 0x7E, 0x18, 0x24, 0x42, 0xAA },  //   20
;	{ 0x78, 0x04, 0x02, 0x7E, 0xAA },  //   21
;	{ 0x7E, 0x04, 0x08, 0x04, 0x7E },  //   22
;	{ 0x7E, 0x08, 0x08, 0x7E, 0xAA },  //   23
;	{ 0x3C, 0x42, 0x42, 0x3C, 0xAA },  //   24
;	{ 0x7E, 0x02, 0x02, 0x7E, 0xAA },  //   25
;	{ 0x7E, 0x12, 0x12, 0x0C, 0xAA },  //   26
;	{ 0x3C, 0x42, 0x42, 0x24, 0xAA },  //   27
;	{ 0x02, 0x7E, 0x02, 0xAA, 0x00 },  //   28
;	{ 0x4E, 0x50, 0x50, 0x3E, 0xAA },  //   29
;	{ 0x0C, 0x12, 0x7E, 0x12, 0x0C },  //   30
;	{ 0x66, 0x18, 0x18, 0x66, 0xAA },  //   31
;	{ 0x7E, 0x40, 0x40, 0x7E, 0xC0 },  //   32
;	{ 0x0E, 0x10, 0x10, 0x7E, 0xAA },  //   33
;	{ 0x7E, 0x40, 0x7E, 0x40, 0x7E },  //   34
;	{ 0x7E, 0x40, 0x7E, 0x40, 0xFE },  //   35
;	{ 0x02, 0x7E, 0x48, 0x30, 0xAA },  //   36
;	{ 0x7E, 0x48, 0x30, 0x00, 0x7E },  //   37
;	{ 0x7E, 0x48, 0x30, 0xAA, 0x00 },  //   38
;	{ 0x24, 0x42, 0x4A, 0x3C, 0xAA },  //   39
;	{ 0x7E, 0x08, 0x3C, 0x42, 0x3C },  //   40
;	{ 0x4C, 0x32, 0x12, 0x7E, 0xAA },  //   41
;	{ 0x00, 0x00, 0xAA, 0xAA, 0x00 },  //               42
;    { 0x40, 0xAA, 0xAA, 0xAA, 0x00 },  //                43
;    { 0xAA, 0xAA, 0xAA, 0xAA, 0x00 },  //      44
;    { 0x00, 0x00, 0x00, 0x00, 0x00 },  // ""      45
;    { 0x08, 0x08, 0x08, 0x08, 0x08 },  //                46
;	{ 0x08, 0x08, 0x3E, 0x08, 0x08 },  //                 47
;	{ 0x06, 0x09, 0x09, 0x06, 0xAA },  //          48
;    { 0x3E, 0x41, 0x41, 0x41, 0x22 },  //  C           49
;    { 0x04, 0x3F, 0x44, 0x20, 0xAA },  //  t         50
;    { 0x08, 0x08, 0x08, 0xAA, 0x00 },  //       51
;    { 0x3F, 0x40, 0x40, 0x3f, 0x00 },  //   V        52
;    { 0x00, 0xAA, 0xAA, 0xAA, 0xAA },  //   _       53
;    },
;
;
;
;dnei_v_mesc     []= {31,29,31,30,31,30,31,31,30,31,30,31};           //    
;unsigned   int          time=720 , Interval , Interval_2, data1, time_meny;
;float                   temperature_temp;
;eeprom signed int       korr_den, brigh_up_time, brigh_down_time,str_period, td10, tu10,speed,font_epp, sek_ind=1,ds1820_d, ds1820_y;
;eeprom unsigned char    brigh_up, str=0x1B;
;static unsigned char    devices, i;
;static  signed   int    temperature [14]={10,20,30,40,50,60,70,80,90,100,110,120,130,140};
;unsigned char  error_ds18b20[2],simvol [55][5];
;
;
;
;//___________________________   _____________________________________
;signed int abs (signed int x)
; 0000 0112 {

	.CSEG
_abs:
; 0000 0113 if (x<0) x=(x*(-1));
;	x -> Y+0
	LDD  R26,Y+1
	TST  R26
	BRPL _0xF
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R26,LOW(65535)
	LDI  R27,HIGH(65535)
	CALL __MULW12
	ST   Y,R30
	STD  Y+1,R31
; 0000 0114 return x;
_0xF:
	LD   R30,Y
	LDD  R31,Y+1
	ADIW R28,2
	RET
; 0000 0115 }
;
;//______    (  DANKO c  "" )))  )_________
;unsigned char Day_week (void)
; 0000 0119 {
_Day_week:
; 0000 011A unsigned char y, m, myday;
; 0000 011B 
; 0000 011C    y = god;
	CALL __SAVELOCR4
;	y -> R17
;	m -> R16
;	myday -> R19
	MOV  R17,R10
; 0000 011D    m = mesec;
	MOV  R16,R7
; 0000 011E 
; 0000 011F    if (m > 2) { m -= 2;       }
	CPI  R16,3
	BRLO _0x10
	CALL SUBOPT_0x0
	SBIW R30,2
	MOV  R16,R30
; 0000 0120    else       { m += 10; y--; }
	RJMP _0x11
_0x10:
	SUBI R16,-LOW(10)
	SUBI R17,1
_0x11:
; 0000 0121 
; 0000 0122    myday = ((chislo + y + (y>>2) + ((31 * m) / 12)) % 7);
	MOV  R26,R8
	CLR  R27
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	CALL SUBOPT_0x1
	CALL __ASRW2
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	LDI  R26,LOW(31)
	MUL  R16,R26
	MOVW R30,R0
	MOVW R26,R30
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CALL __DIVW21
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CALL __MODW21
	MOV  R19,R30
; 0000 0123 
; 0000 0124    if (myday)  return myday-1;  else  return  6;
	CPI  R19,0
	BREQ _0x12
	MOV  R30,R19
	CALL SUBOPT_0x2
	RJMP _0x2020006
_0x12:
	LDI  R30,LOW(6)
; 0000 0125 }
_0x2020006:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;
;//___________________________________________ ___________________________________________
;void correkt (void)
; 0000 0129 {
_correkt:
; 0000 012A         if(korr_den<0) {TCNT2=255+((korr_den%10)*25); sek=59+((korr_den%600)/10);
	CALL SUBOPT_0x3
	BRPL _0x14
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
	SUBI R30,-LOW(255)
	OUT  0x24,R30
	CALL SUBOPT_0x4
	CALL SUBOPT_0x6
	SUBI R30,-LOW(59)
	MOV  R5,R30
; 0000 012B                            if (sek==60) {sek=0;}
	LDI  R30,LOW(60)
	CP   R30,R5
	BRNE _0x15
	CLR  R5
; 0000 012C                             time=1439;
_0x15:
	LDI  R30,LOW(1439)
	LDI  R31,HIGH(1439)
	STS  _time,R30
	STS  _time+1,R31
; 0000 012D                         }
; 0000 012E         else {TCNT2=25*(korr_den%10); sek=((korr_den%600)/10);}
	RJMP _0x16
_0x14:
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
	OUT  0x24,R30
	CALL SUBOPT_0x4
	CALL SUBOPT_0x6
	MOV  R5,R30
_0x16:
; 0000 012F }
	RET
;
;
;//____________________________ . (  )________________________________
;interrupt [TIM0_COMP] void timer0_comp_isr(void)
; 0000 0134 {
_timer0_comp_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0135 PORTA=0;     //        
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0136 PORTB&=0xFC; //           /---/
	IN   R30,0x18
	ANDI R30,LOW(0xFC)
	OUT  0x18,R30
; 0000 0137 PORTC=0;     //           /---/
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 0138 PORTD=0;     //           /---/
	OUT  0x12,R30
; 0000 0139 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;//________ .          _______________
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 013D {
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 013E 
; 0000 013F //flg_din=1;
; 0000 0140 
; 0000 0141         stroka >>= 1;  if (stroka==0)  stroka=0b10000000;    //    
	MOV  R30,R11
	LDI  R31,0
	ASR  R31
	ROR  R30
	MOV  R11,R30
	TST  R11
	BRNE _0x17
	LDI  R30,LOW(128)
	MOV  R11,R30
; 0000 0142         if (stroka==0b00000001)  PORTB.7= 1;  else  PORTB.7=0;
_0x17:
	LDI  R30,LOW(1)
	CP   R30,R11
	BRNE _0x18
	SBI  0x18,7
	RJMP _0x1B
_0x18:
	CBI  0x18,7
; 0000 0143 
; 0000 0144         PORTB.6=1;    //
_0x1B:
	SBI  0x18,6
; 0000 0145 
; 0000 0146         //*********** ***************************
; 0000 0147         if(flg_adch)                    //       
	SBRS R4,0
	RJMP _0x20
; 0000 0148         {
; 0000 0149         flg_adch=0;                     //  ""  
	CLT
	BLD  R4,0
; 0000 014A         PORTA.7=0; DDRA.7=0;            //  .7   ,         ,
	CBI  0x1B,7
	CBI  0x1A,7
; 0000 014B         ADCSRA=0b11000011;              //   (   )
	LDI  R30,LOW(195)
	OUT  0x6,R30
; 0000 014C         while (ADCSRA&0b01000000){}     //     
_0x25:
	SBIC 0x6,6
	RJMP _0x25
; 0000 014D         DDRA.7=1;                       //  .7   
	SBI  0x1A,7
; 0000 014E         }
; 0000 014F         //***********************************************************
; 0000 0150 
; 0000 0151 
; 0000 0152         # if  OK
; 0000 0153         PORTC.3 = (ekran [0] & stroka);
_0x20:
	MOV  R30,R11
	LDS  R26,_ekran
	AND  R30,R26
	BRNE _0x2A
	CBI  0x15,3
	RJMP _0x2B
_0x2A:
	SBI  0x15,3
_0x2B:
; 0000 0154         PORTC.0 = (ekran [1] & stroka);
	__GETB1MN _ekran,1
	AND  R30,R11
	BRNE _0x2C
	CBI  0x15,0
	RJMP _0x2D
_0x2C:
	SBI  0x15,0
_0x2D:
; 0000 0155         PORTD.7 = (ekran [2] & stroka);
	__GETB1MN _ekran,2
	AND  R30,R11
	BRNE _0x2E
	CBI  0x12,7
	RJMP _0x2F
_0x2E:
	SBI  0x12,7
_0x2F:
; 0000 0156         PORTC.5 = (ekran [3] & stroka);
	__GETB1MN _ekran,3
	AND  R30,R11
	BRNE _0x30
	CBI  0x15,5
	RJMP _0x31
_0x30:
	SBI  0x15,5
_0x31:
; 0000 0157         PORTD.6 = (ekran [4] & stroka);
	__GETB1MN _ekran,4
	AND  R30,R11
	BRNE _0x32
	CBI  0x12,6
	RJMP _0x33
_0x32:
	SBI  0x12,6
_0x33:
; 0000 0158         PORTC.4 = (ekran [5] & stroka);
	__GETB1MN _ekran,5
	AND  R30,R11
	BRNE _0x34
	CBI  0x15,4
	RJMP _0x35
_0x34:
	SBI  0x15,4
_0x35:
; 0000 0159         PORTC.2 = (ekran [6] & stroka);
	__GETB1MN _ekran,6
	AND  R30,R11
	BRNE _0x36
	CBI  0x15,2
	RJMP _0x37
_0x36:
	SBI  0x15,2
_0x37:
; 0000 015A         PORTC.1 = (ekran [7] & stroka);
	__GETB1MN _ekran,7
	AND  R30,R11
	BRNE _0x38
	CBI  0x15,1
	RJMP _0x39
_0x38:
	SBI  0x15,1
_0x39:
; 0000 015B         PORTA.5 = (ekran [8] & stroka);
	__GETB1MN _ekran,8
	AND  R30,R11
	BRNE _0x3A
	CBI  0x1B,5
	RJMP _0x3B
_0x3A:
	SBI  0x1B,5
_0x3B:
; 0000 015C         PORTD.5 = (ekran [9] & stroka);
	__GETB1MN _ekran,9
	AND  R30,R11
	BRNE _0x3C
	CBI  0x12,5
	RJMP _0x3D
_0x3C:
	SBI  0x12,5
_0x3D:
; 0000 015D         PORTD.4 = (ekran [10] & stroka);
	__GETB1MN _ekran,10
	AND  R30,R11
	BRNE _0x3E
	CBI  0x12,4
	RJMP _0x3F
_0x3E:
	SBI  0x12,4
_0x3F:
; 0000 015E         PORTA.3 = (ekran [11] & stroka);
	__GETB1MN _ekran,11
	AND  R30,R11
	BRNE _0x40
	CBI  0x1B,3
	RJMP _0x41
_0x40:
	SBI  0x1B,3
_0x41:
; 0000 015F         PORTD.3 = (ekran [12] & stroka);
	__GETB1MN _ekran,12
	AND  R30,R11
	BRNE _0x42
	CBI  0x12,3
	RJMP _0x43
_0x42:
	SBI  0x12,3
_0x43:
; 0000 0160         PORTA.4 = (ekran [13] & stroka);
	__GETB1MN _ekran,13
	AND  R30,R11
	BRNE _0x44
	CBI  0x1B,4
	RJMP _0x45
_0x44:
	SBI  0x1B,4
_0x45:
; 0000 0161         PORTA.6 = (ekran [14] & stroka);
	__GETB1MN _ekran,14
	AND  R30,R11
	BRNE _0x46
	CBI  0x1B,6
	RJMP _0x47
_0x46:
	SBI  0x1B,6
_0x47:
; 0000 0162         PORTA.7 = (ekran [15] & stroka);
	__GETB1MN _ekran,15
	AND  R30,R11
	BRNE _0x48
	CBI  0x1B,7
	RJMP _0x49
_0x48:
	SBI  0x1B,7
_0x49:
; 0000 0163         PORTA.0 = (ekran [16] & stroka);
	__GETB1MN _ekran,16
	AND  R30,R11
	BRNE _0x4A
	CBI  0x1B,0
	RJMP _0x4B
_0x4A:
	SBI  0x1B,0
_0x4B:
; 0000 0164         PORTD.2 = (ekran [17] & stroka);
	__GETB1MN _ekran,17
	AND  R30,R11
	BRNE _0x4C
	CBI  0x12,2
	RJMP _0x4D
_0x4C:
	SBI  0x12,2
_0x4D:
; 0000 0165         PORTD.1 = (ekran [18] & stroka);
	__GETB1MN _ekran,18
	AND  R30,R11
	BRNE _0x4E
	CBI  0x12,1
	RJMP _0x4F
_0x4E:
	SBI  0x12,1
_0x4F:
; 0000 0166         PORTB.1 = (ekran [19] & stroka);
	__GETB1MN _ekran,19
	AND  R30,R11
	BRNE _0x50
	CBI  0x18,1
	RJMP _0x51
_0x50:
	SBI  0x18,1
_0x51:
; 0000 0167         PORTD.0 = (ekran [20] & stroka);
	__GETB1MN _ekran,20
	AND  R30,R11
	BRNE _0x52
	CBI  0x12,0
	RJMP _0x53
_0x52:
	SBI  0x12,0
_0x53:
; 0000 0168         PORTB.0 = (ekran [21] & stroka);
	__GETB1MN _ekran,21
	AND  R30,R11
	BRNE _0x54
	CBI  0x18,0
	RJMP _0x55
_0x54:
	SBI  0x18,0
_0x55:
; 0000 0169         PORTA.1 = (ekran [22] & stroka);
	__GETB1MN _ekran,22
	AND  R30,R11
	BRNE _0x56
	CBI  0x1B,1
	RJMP _0x57
_0x56:
	SBI  0x1B,1
_0x57:
; 0000 016A         PORTA.2 = (ekran [23] & stroka);
	__GETB1MN _ekran,23
	AND  R30,R11
	BRNE _0x58
	CBI  0x1B,2
	RJMP _0x59
_0x58:
	SBI  0x1B,2
_0x59:
; 0000 016B         # endif
; 0000 016C         # if OA
; 0000 016D         PORTC.1 = (ekran [0] & stroka);   //0
; 0000 016E         PORTC.3 = (ekran [1] & stroka);   //1
; 0000 016F         PORTD.5 = (ekran [2] & stroka);   //2
; 0000 0170         PORTC.2 = (ekran [3] & stroka);   //3
; 0000 0171         PORTD.3 = (ekran [4] & stroka);   //4
; 0000 0172         PORTD.6 = (ekran [5] & stroka);   //5
; 0000 0173         PORTD.4 = (ekran [6] & stroka);   //6
; 0000 0174         PORTD.7 = (ekran [7] & stroka);   //7
; 0000 0175         PORTD.1 = (ekran [8] & stroka);   //8
; 0000 0176         PORTD.2 = (ekran [9] & stroka);   //9
; 0000 0177         PORTA.3 = (ekran [10] & stroka);  //10
; 0000 0178         PORTD.0 = (ekran [11] & stroka);  //11
; 0000 0179         PORTB.1 = (ekran [12] & stroka);  //12
; 0000 017A         PORTA.2 = (ekran [13] & stroka);  //13
; 0000 017B         PORTB.0 = (ekran [14] & stroka);  //14
; 0000 017C         PORTA.0 = (ekran [15] & stroka);  //15
; 0000 017D         PORTA.1 = (ekran [16] & stroka);  //16
; 0000 017E         PORTA.4 = (ekran [17] & stroka);  //17
; 0000 017F         PORTC.0 = (ekran [18] & stroka);  //18
; 0000 0180         PORTA.7 = (ekran [19] & stroka);  //19
; 0000 0181         PORTA.5 = (ekran [20] & stroka);  //20
; 0000 0182         PORTC.4 = (ekran [21] & stroka);  //21
; 0000 0183         PORTA.6 = (ekran [22] & stroka);  //22
; 0000 0184         PORTC.5 = (ekran [23] & stroka);  //23
; 0000 0185         # endif
; 0000 0186 
; 0000 0187 
; 0000 0188 
; 0000 0189         PORTB.6=0;
	CBI  0x18,6
; 0000 018A 
; 0000 018B 
; 0000 018C         but_pause++;  if (but_pause==100)      { but_pause=0; but_on=1; }                         //         0,3  -    
	INC  R13
	LDI  R30,LOW(100)
	CP   R30,R13
	BRNE _0x5C
	CLR  R13
	SET
	BLD  R3,4
; 0000 018D         if ((but_pause==50)&&(but_flg))        { but_flg=0; PORTB.5=0; TIMSK&=0xEF;}              //  ""      //but_pause==50   
_0x5C:
	LDI  R30,LOW(50)
	CP   R30,R13
	BRNE _0x5E
	SBRC R3,0
	RJMP _0x5F
_0x5E:
	RJMP _0x5D
_0x5F:
	CLT
	BLD  R3,0
	CBI  0x18,5
	IN   R30,0x39
	ANDI R30,0xEF
	OUT  0x39,R30
; 0000 018E         mig1_pause++;if (mig1_pause==165)      { mig1_pause=0;  if (mig1==0)mig1=1;else mig1=0;}  //         
_0x5D:
	LDS  R30,_mig1_pause
	SUBI R30,-LOW(1)
	STS  _mig1_pause,R30
	LDS  R26,_mig1_pause
	CPI  R26,LOW(0xA5)
	BRNE _0x62
	LDI  R30,LOW(0)
	STS  _mig1_pause,R30
	SBRC R2,3
	RJMP _0x63
	SET
	RJMP _0x2F1
_0x63:
	CLT
_0x2F1:
	BLD  R2,3
; 0000 018F         Interval++;   Interval_2++;                                                               //         
_0x62:
	LDI  R26,LOW(_Interval)
	LDI  R27,HIGH(_Interval)
	CALL SUBOPT_0x7
	LDI  R26,LOW(_Interval_2)
	LDI  R27,HIGH(_Interval_2)
	CALL SUBOPT_0x7
; 0000 0190 
; 0000 0191 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;//___________________________________  _______________________________________________
;unsigned char  button_read (void)
; 0000 0195 {
_button_read:
; 0000 0196 button=0;
	CLR  R14
; 0000 0197 
; 0000 0198 if ( (PINB.2==0) && (but_on))
	LDI  R26,0
	SBIC 0x16,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x66
	SBRC R3,4
	RJMP _0x67
_0x66:
	RJMP _0x65
_0x67:
; 0000 0199 {
; 0000 019A but_on=0;  but_pause=0;
	CLT
	BLD  R3,4
	CLR  R13
; 0000 019B 
; 0000 019C     switch (stroka)
	MOV  R30,R11
	LDI  R31,0
; 0000 019D         {
; 0000 019E         case 0b10000000: button=2;                             //  
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x6B
	LDI  R30,LOW(2)
	RJMP _0x2F2
; 0000 019F         break;
; 0000 01A0         case 0b00000001: button=1;
_0x6B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x6A
	LDI  R30,LOW(1)
_0x2F2:
	MOV  R14,R30
; 0000 01A1         break;
; 0000 01A2         }
_0x6A:
; 0000 01A3 time_meny=0;mig1_pause=0;mig1=0;
	CALL SUBOPT_0x8
	LDI  R30,LOW(0)
	STS  _mig1_pause,R30
	CLT
	BLD  R2,3
; 0000 01A4 if (zv_kn) {but_flg=1; TIMSK|=0x10;}//    -       .
	SBRS R3,1
	RJMP _0x6D
	SET
	BLD  R3,0
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
; 0000 01A5 if (bud_flg) {bud_flg=0; button=0;                                   //  (  )  .             .
_0x6D:
	SBRS R2,4
	RJMP _0x6E
	CLT
	BLD  R2,4
	CLR  R14
; 0000 01A6 
; 0000 01A7                  for (bud_temp=0; bud_temp<3; bud_temp++)
	CLR  R12
_0x70:
	LDI  R30,LOW(3)
	CP   R12,R30
	BRSH _0x71
; 0000 01A8         {
; 0000 01A9         //______________________ 
; 0000 01AA                 if ( time==budilnik_time[bud_temp])    //    ""  ( 1  15 )
	CALL SUBOPT_0x9
	BRNE _0x72
; 0000 01AB                 {
; 0000 01AC                 if ((bud_temp<3)&&(budilnik_raz[bud_temp]==0))  {budilnik_Install[bud_temp] = 0;}                  //     "" ( 1-3),      .
	LDI  R30,LOW(3)
	CP   R12,R30
	BRSH _0x74
	CALL SUBOPT_0xA
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LD   R26,Z
	CPI  R26,LOW(0x0)
	BREQ _0x75
_0x74:
	RJMP _0x73
_0x75:
	CALL SUBOPT_0xA
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 01AD                 }
_0x73:
; 0000 01AE 
; 0000 01AF         }
_0x72:
	INC  R12
	RJMP _0x70
_0x71:
; 0000 01B0                 }
; 0000 01B1 
; 0000 01B2 bud_flg=0;
_0x6E:
	CLT
	BLD  R2,4
; 0000 01B3 }
; 0000 01B4 return  button;
_0x65:
	MOV  R30,R14
	RET
; 0000 01B5 }
;
;//______  (        )______
;interrupt [ANA_COMP] void ana_comp_isr(void)
; 0000 01B9 {
_ana_comp_isr:
	CALL SUBOPT_0xB
; 0000 01BA         if(ACSR&0x20)                //    
	SBIS 0x8,5
	RJMP _0x76
; 0000 01BB         {
; 0000 01BC         POWER = OFF;                 //      
	CLT
	BLD  R3,6
; 0000 01BD         # if  ATMEGA16
; 0000 01BE         MCUCR=0b01110000;            //      SLEEP ( 16)
	LDI  R30,LOW(112)
	OUT  0x35,R30
; 0000 01BF         # endif
; 0000 01C0         # if  (ATMEGA32)
; 0000 01C1         MCUCR=0b10110000;            //      SLEEP ( 32)
; 0000 01C2         # endif
; 0000 01C3         TCCR0=0x00;                  //  /0
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 01C4         ADCSRA=0x00;                 //  
	OUT  0x6,R30
; 0000 01C5         TIMSK&=0x7f;                 //     2
	IN   R30,0x39
	ANDI R30,0x7F
	OUT  0x39,R30
; 0000 01C6         ADMUX= 0b00100111;           //    
	LDI  R30,LOW(39)
	OUT  0x7,R30
; 0000 01C7         PORTA=0;  DDRB=0b11110111;   //      
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	LDI  R30,LOW(247)
	OUT  0x17,R30
; 0000 01C8         PORTB=0; PORTC=0; PORTD=0;
	LDI  R30,LOW(0)
	OUT  0x18,R30
	OUT  0x15,R30
	OUT  0x12,R30
; 0000 01C9         }
; 0000 01CA         else                         //      
	RJMP _0x77
_0x76:
; 0000 01CB         {
; 0000 01CC         devices=w1_search(0xf0,rom_code);//    "" /  DS18B20,      ""
	CALL SUBOPT_0xC
; 0000 01CD         POWER = ON;                  //    
	SET
	BLD  R3,6
; 0000 01CE         MCUCR=0b00110000;            //       SLEEP
	LDI  R30,LOW(48)
	OUT  0x35,R30
; 0000 01CF         DDRB=0xE3;                   //      
	LDI  R30,LOW(227)
	OUT  0x17,R30
; 0000 01D0         TCCR0=0x03;                  //  /0
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 01D1         ADCSRA=0b10000011;           //  
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 01D2         TIMSK|=0x80;                 //     2
	IN   R30,0x39
	ORI  R30,0x80
	OUT  0x39,R30
; 0000 01D3         ADMUX= 0b01100111;           //    
	LDI  R30,LOW(103)
	OUT  0x7,R30
; 0000 01D4        if (devices==1){if (ds1820_d!=0)ds1820_d=0; if(ds1820_y!=1)ds1820_y=1;}
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRNE _0x78
	CALL SUBOPT_0xD
	SBIW R30,0
	BREQ _0x79
	CALL SUBOPT_0xE
_0x79:
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ _0x7A
	CALL SUBOPT_0x10
_0x7A:
; 0000 01D5        if (devices==2)
_0x78:
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRNE _0x7B
; 0000 01D6                       {if (ds1820_d<0 || ds1820_d>255) ds1820_d=0; if(ds1820_y<0 || ds1820_y>255)ds1820_y=1; }
	LDI  R26,LOW(_ds1820_d+1)
	LDI  R27,HIGH(_ds1820_d+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x7D
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x7C
_0x7D:
	CALL SUBOPT_0xE
_0x7C:
	LDI  R26,LOW(_ds1820_y+1)
	LDI  R27,HIGH(_ds1820_y+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x80
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x7F
_0x80:
	CALL SUBOPT_0x10
_0x7F:
; 0000 01D7         }
_0x7B:
_0x77:
; 0000 01D8 }
	RJMP _0x320
;
;//__________________________________________ __________________________________________________
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 01DC {
_timer1_compa_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01DD static char dl_1=0,dl_2=0;
; 0000 01DE dl_2++; if (dl_2>=150) {dl_2=0; dl_1++;  if (dl_1>=5) dl_1=0; }
	LDS  R30,_dl_2_S0000007000
	SUBI R30,-LOW(1)
	STS  _dl_2_S0000007000,R30
	LDS  R26,_dl_2_S0000007000
	CPI  R26,LOW(0x96)
	BRLO _0x82
	LDI  R30,LOW(0)
	STS  _dl_2_S0000007000,R30
	LDS  R30,_dl_1_S0000007000
	SUBI R30,-LOW(1)
	STS  _dl_1_S0000007000,R30
	LDS  R26,_dl_1_S0000007000
	CPI  R26,LOW(0x5)
	BRLO _0x83
	LDI  R30,LOW(0)
	STS  _dl_1_S0000007000,R30
_0x83:
; 0000 01DF if (but_flg) OCR1A=20;      //   ""   ,  ""   
_0x82:
	SBRS R3,0
	RJMP _0x84
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP _0x2F3
; 0000 01E0 else  OCR1A = dl_1+3;      //   "" ,   ""
_0x84:
	LDS  R30,_dl_1_S0000007000
	LDI  R31,0
	ADIW R30,3
_0x2F3:
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 01E1 PORTB ^= (1 << 5);
	IN   R30,0x18
	LDI  R26,LOW(32)
	EOR  R30,R26
	OUT  0x18,R30
; 0000 01E2 
; 0000 01E3 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;//____________________________  ________________________________
;interrupt [TIM2_COMP] void timer2_comp_isr(void)
; 0000 01E7 {
_timer2_comp_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01E8 
; 0000 01E9 if (foto_r)                           //   
	LDS  R30,_foto_r
	CPI  R30,0
	BRNE PC+3
	JMP _0x86
; 0000 01EA     {
; 0000 01EB     flg_adch=1;                       //   
	SET
	BLD  R4,0
; 0000 01EC 
; 0000 01ED         /*if(OCR0 <(ADCH*255/brigh_up))
; 0000 01EE                  {if((OCR0 -(ADCH*255/brigh_up))<5) {OCR0=ADCH*255/brigh_up;} else   OCR0-=5 ;}
; 0000 01EF              else
; 0000 01F0                  {if((OCR0 +(ADCH*255/brigh_up))<5) {OCR0=ADCH*255/brigh_up;} else   OCR0+=5 ;};
; 0000 01F1          */
; 0000 01F2             if(ADCH>50){
	IN   R30,0x5
	CPI  R30,LOW(0x33)
	BRLO _0x87
; 0000 01F3                          if(OCR0 < ADCH ) { if((ADCH-OCR0)<10) { if (OCR0<10) {OCR0=10;}else  OCR0=ADCH;} else   if (OCR0<245){OCR0+=10;};}      //    .
	IN   R30,0x3C
	MOV  R26,R30
	IN   R30,0x5
	CP   R26,R30
	BRSH _0x88
	CALL SUBOPT_0x11
	CALL SUBOPT_0x12
	SBIW R26,10
	BRGE _0x89
	IN   R30,0x3C
	CPI  R30,LOW(0xA)
	BRSH _0x8A
	LDI  R30,LOW(10)
	RJMP _0x2F4
_0x8A:
	IN   R30,0x5
_0x2F4:
	OUT  0x3C,R30
	RJMP _0x8C
_0x89:
	IN   R30,0x3C
	CPI  R30,LOW(0xF5)
	BRSH _0x8D
	IN   R30,0x3C
	SUBI R30,-LOW(10)
	OUT  0x3C,R30
_0x8D:
_0x8C:
; 0000 01F4                          if(OCR0 > ADCH ) { if((OCR0-ADCH)<10) { if (OCR0<10) {OCR0=10;}else  OCR0=ADCH;} else   if (OCR0>20){ OCR0-=10;};}     //    .
_0x88:
	IN   R30,0x3C
	MOV  R26,R30
	IN   R30,0x5
	CP   R30,R26
	BRSH _0x8E
	CALL SUBOPT_0x13
	MOVW R26,R30
	CALL SUBOPT_0x11
	SUB  R26,R30
	SBC  R27,R31
	SBIW R26,10
	BRGE _0x8F
	IN   R30,0x3C
	CPI  R30,LOW(0xA)
	BRSH _0x90
	LDI  R30,LOW(10)
	RJMP _0x2F5
_0x90:
	IN   R30,0x5
_0x2F5:
	OUT  0x3C,R30
	RJMP _0x92
_0x8F:
	IN   R30,0x3C
	CPI  R30,LOW(0x15)
	BRLO _0x93
	CALL SUBOPT_0x13
	SBIW R30,10
	OUT  0x3C,R30
_0x93:
_0x92:
; 0000 01F5                        }
_0x8E:
; 0000 01F6                 else   {
	RJMP _0x94
_0x87:
; 0000 01F7                           if(OCR0 < ADCH ) { if((ADCH-OCR0)<5) { if (OCR0<10) {OCR0=10;}else  OCR0=ADCH;} else   if (OCR0<250){OCR0+=5;};}      //    .
	IN   R30,0x3C
	MOV  R26,R30
	IN   R30,0x5
	CP   R26,R30
	BRSH _0x95
	CALL SUBOPT_0x11
	CALL SUBOPT_0x12
	SBIW R26,5
	BRGE _0x96
	IN   R30,0x3C
	CPI  R30,LOW(0xA)
	BRSH _0x97
	LDI  R30,LOW(10)
	RJMP _0x2F6
_0x97:
	IN   R30,0x5
_0x2F6:
	OUT  0x3C,R30
	RJMP _0x99
_0x96:
	IN   R30,0x3C
	CPI  R30,LOW(0xFA)
	BRSH _0x9A
	IN   R30,0x3C
	SUBI R30,-LOW(5)
	OUT  0x3C,R30
_0x9A:
_0x99:
; 0000 01F8                           if(OCR0 > ADCH ) { if((OCR0-ADCH)<5) { if (OCR0<10) {OCR0=10;}else  OCR0=ADCH;} else   if (OCR0>15){ OCR0-=5;};}     //    .
_0x95:
	IN   R30,0x3C
	MOV  R26,R30
	IN   R30,0x5
	CP   R30,R26
	BRSH _0x9B
	CALL SUBOPT_0x13
	MOVW R26,R30
	CALL SUBOPT_0x11
	SUB  R26,R30
	SBC  R27,R31
	SBIW R26,5
	BRGE _0x9C
	IN   R30,0x3C
	CPI  R30,LOW(0xA)
	BRSH _0x9D
	LDI  R30,LOW(10)
	RJMP _0x2F7
_0x9D:
	IN   R30,0x5
_0x2F7:
	OUT  0x3C,R30
	RJMP _0x9F
_0x9C:
	IN   R30,0x3C
	CPI  R30,LOW(0x10)
	BRLO _0xA0
	CALL SUBOPT_0x13
	SBIW R30,5
	OUT  0x3C,R30
_0xA0:
_0x9F:
; 0000 01F9                        }
_0x9B:
_0x94:
; 0000 01FA         //OCR0=ADCH;                    //    .
; 0000 01FB       //  if (OCR0<10) OCR0=10;         //   ,         0
; 0000 01FC         TIMSK|=0x02;                  //     0
	RJMP _0x2F8
; 0000 01FD 
; 0000 01FE     }
; 0000 01FF else                                  //    
_0x86:
; 0000 0200     {
; 0000 0201     if (brigh_down_time<brigh_up_time)//     ""    ( )
	CALL SUBOPT_0x14
	MOVW R0,R30
	CALL SUBOPT_0x15
	CP   R0,R30
	CPC  R1,R31
	BRGE _0xA2
; 0000 0202         {
; 0000 0203         if ( (time>=brigh_down_time)&&(time<brigh_up_time) )//
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
	BRLO _0xA4
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
	BRLO _0xA5
_0xA4:
	RJMP _0xA3
_0xA5:
; 0000 0204             {
; 0000 0205             OCR0=(brigh_up*23)+1;     //    .
	CALL SUBOPT_0x17
; 0000 0206             TIMSK|=0x02;              //     0
	IN   R30,0x39
	ORI  R30,2
	RJMP _0x2F9
; 0000 0207             }
; 0000 0208         else                          //
_0xA3:
; 0000 0209             {
; 0000 020A             TIMSK&=0xFD;              //      (     )
	IN   R30,0x39
	ANDI R30,0xFD
_0x2F9:
	OUT  0x39,R30
; 0000 020B             }
; 0000 020C         }
; 0000 020D     else                              //     ""    ( )
	RJMP _0xA7
_0xA2:
; 0000 020E         {
; 0000 020F         if ( (time<brigh_down_time)&&(time>=brigh_up_time) )//
	CALL SUBOPT_0x14
	CALL SUBOPT_0x16
	BRSH _0xA9
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
	BRSH _0xAA
_0xA9:
	RJMP _0xA8
_0xAA:
; 0000 0210             {
; 0000 0211             TIMSK&=0xFD;              //      (     )
	IN   R30,0x39
	ANDI R30,0xFD
	RJMP _0x2FA
; 0000 0212             }
; 0000 0213         else                          //
_0xA8:
; 0000 0214             {
; 0000 0215             OCR0=(brigh_up*23)+1;     //    .
	CALL SUBOPT_0x17
; 0000 0216             TIMSK|=0x02;              //     0
_0x2F8:
	IN   R30,0x39
	ORI  R30,2
_0x2FA:
	OUT  0x39,R30
; 0000 0217             }
; 0000 0218         }
_0xA7:
; 0000 0219     }
; 0000 021A 
; 0000 021B 
; 0000 021C  if(!mig_vrem) time_meny++;  else  time_meny=0;             //          
	SBRC R2,1
	RJMP _0xAC
	LDI  R26,LOW(_time_meny)
	LDI  R27,HIGH(_time_meny)
	CALL SUBOPT_0x7
	RJMP _0xAD
_0xAC:
	CALL SUBOPT_0x8
; 0000 021D  if(str_sec==str_period+1) str_sec=0; else str_sec++;                                              //       
_0xAD:
	CALL SUBOPT_0x18
	ADIW R30,1
	CALL SUBOPT_0x19
	BRNE _0xAE
	LDI  R30,LOW(0)
	RJMP _0x2FB
_0xAE:
	LDS  R30,_str_sec
	SUBI R30,-LOW(1)
_0x2FB:
	STS  _str_sec,R30
; 0000 021E //_______________________________________________________________________________
; 0000 021F flg_ds18b20=1; //        
	SET
	BLD  R4,1
; 0000 0220 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;//____________________________________________ ________________________________________________
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0224 
; 0000 0225 {
_timer2_ovf_isr:
	CALL SUBOPT_0xB
; 0000 0226 mig++;
	LDI  R30,LOW(1)
	EOR  R2,R30
; 0000 0227 sek++;     //   
	INC  R5
; 0000 0228 
; 0000 0229 if (sek==60)
	LDI  R30,LOW(60)
	CP   R30,R5
	BREQ PC+3
	JMP _0xB0
; 0000 022A         {sek=0; time++; flg_min=1;
	CLR  R5
	LDI  R26,LOW(_time)
	LDI  R27,HIGH(_time)
	CALL SUBOPT_0x7
	SET
	BLD  R2,2
; 0000 022B          if (time==1440)
	CALL SUBOPT_0x1A
	CPI  R26,LOW(0x5A0)
	LDI  R30,HIGH(0x5A0)
	CPC  R27,R30
	BRNE _0xB1
; 0000 022C                 {
; 0000 022D                 if(flg_korr)  {correkt(); flg_korr=0;  if(korr_den<0) goto m2;}  //   00-00,       -  .
	LDS  R30,_flg_korr
	CPI  R30,0
	BREQ _0xB2
	RCALL _correkt
	LDI  R30,LOW(0)
	STS  _flg_korr,R30
	CALL SUBOPT_0x3
	BRMI _0xB4
; 0000 022E                 time=0;  chislo++; if (chislo > dnei_v_mesc[mesec-1])
_0xB2:
	LDI  R30,LOW(0)
	STS  _time,R30
	STS  _time+1,R30
	INC  R8
	MOV  R30,R7
	CALL SUBOPT_0x2
	SUBI R30,LOW(-_dnei_v_mesc*2)
	SBCI R31,HIGH(-_dnei_v_mesc*2)
	LPM  R30,Z
	CP   R30,R8
	BRSH _0xB5
; 0000 022F                         {chislo=1; mesec++; if (mesec==13)
	LDI  R30,LOW(1)
	MOV  R8,R30
	INC  R7
	LDI  R30,LOW(13)
	CP   R30,R7
	BRNE _0xB6
; 0000 0230                                 {mesec=1; god++;
	LDI  R30,LOW(1)
	MOV  R7,R30
	INC  R10
; 0000 0231                                 }
; 0000 0232                         }
_0xB6:
; 0000 0233                 if ( (god%4) && (mesec==2) && (chislo==29) )  {mesec=3; chislo=1;}      //   ,  29.02>>>>>01.03
_0xB5:
	MOV  R26,R10
	CLR  R27
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL __MODW21
	SBIW R30,0
	BREQ _0xB8
	LDI  R30,LOW(2)
	CP   R30,R7
	BRNE _0xB8
	LDI  R30,LOW(29)
	CP   R30,R8
	BREQ _0xB9
_0xB8:
	RJMP _0xB7
_0xB9:
	LDI  R30,LOW(3)
	MOV  R7,R30
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 0234                 flg_korr=1;
_0xB7:
	LDI  R30,LOW(1)
	STS  _flg_korr,R30
; 0000 0235                 m2:
_0xB4:
; 0000 0236                 }
; 0000 0237 
; 0000 0238         }
_0xB1:
; 0000 0239 
; 0000 023A 
; 0000 023B }
_0xB0:
_0x320:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;
;
;
;//______________________     +    _________________________
;  void ekran_cifri (unsigned  int data)
; 0000 0242 {
_ekran_cifri:
; 0000 0243     unsigned char           x,x1,x2,x3,y,y1,y2,y3,temp;
; 0000 0244     static unsigned char    Shift_zn;
; 0000 0245 
; 0000 0246 
; 0000 0247 
; 0000 0248 
; 0000 0249 
; 0000 024A x  =  data/600;              // 
	SBIW R28,3
	CALL __SAVELOCR6
;	data -> Y+9
;	x -> R17
;	x1 -> R16
;	x2 -> R19
;	x3 -> R18
;	y -> R21
;	y1 -> R20
;	y2 -> Y+8
;	y3 -> Y+7
;	temp -> Y+6
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x1B
	MOV  R17,R30
; 0000 024B x1 =  (data%600)/60;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x1C
	MOV  R16,R30
; 0000 024C x2 =  (data%60)/10;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x1D
	MOV  R19,R30
; 0000 024D x3 =  data%10;
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0x1E
	MOV  R18,R30
; 0000 024E 
; 0000 024F y  =  data1/600;
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1B
	MOV  R21,R30
; 0000 0250 y1 =  (data1%600)/60;
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1C
	MOV  R20,R30
; 0000 0251 y2 =  (data1%60)/10;
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1D
	STD  Y+8,R30
; 0000 0252 y3 =  data1%10;
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1E
	STD  Y+7,R30
; 0000 0253 
; 0000 0254 if ((budilnik_Install[0] & 0x80) | (budilnik_Install[1] & 0x80)                                                    //    
; 0000 0255                  | (budilnik_Install[2] & 0x80) | (budilnik_Install[3] & 0x80) | (budilnik_Install[4] & 0x80)
; 0000 0256                  | (budilnik_Install[5] & 0x80) | (budilnik_Install[6] & 0x80)| (budilnik_Install[7] & 0x80)
; 0000 0257                  | (budilnik_Install[8] & 0x80) ) {  budilnik=1;   }
	LDS  R30,_budilnik_Install
	ANDI R30,LOW(0x80)
	MOV  R26,R30
	__GETB1MN _budilnik_Install,1
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,2
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,3
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,4
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,5
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,6
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,7
	ANDI R30,LOW(0x80)
	OR   R30,R26
	MOV  R26,R30
	__GETB1MN _budilnik_Install,8
	ANDI R30,LOW(0x80)
	OR   R30,R26
	BREQ _0xBA
	SET
	RJMP _0x2FC
; 0000 0258                       else  {  budilnik=0;  }
_0xBA:
	CLT
_0x2FC:
	BLD  R2,5
; 0000 0259 
; 0000 025A if(mig_vrem) {      if (mig)  {ekran [12]=128;  ekran [11]=0;}
	SBRS R2,1
	RJMP _0xBC
	SBRS R2,0
	RJMP _0xBD
	LDI  R30,LOW(128)
	__PUTB1MN _ekran,12
	LDI  R30,LOW(0)
	RJMP _0x2FD
; 0000 025B                                         else  {ekran [12]=0;  ekran [11]=128;}                                 //     
_0xBD:
	LDI  R30,LOW(0)
	__PUTB1MN _ekran,12
	LDI  R30,LOW(128)
_0x2FD:
	__PUTB1MN _ekran,11
; 0000 025C 
; 0000 025D                 }
; 0000 025E 
; 0000 025F 
; 0000 0260 if (data != data1)                                                                                             //     -  
_0xBC:
	LDS  R30,_data1
	LDS  R31,_data1+1
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CP   R30,R26
	CPC  R31,R27
	BRNE PC+3
	JMP _0xBF
; 0000 0261 {
; 0000 0262     if (Interval_2>40){Interval_2=0; Shift_zn++;  if(Shift_zn==8) {Shift_zn=0;data1=data;}   }
	LDS  R26,_Interval_2
	LDS  R27,_Interval_2+1
	SBIW R26,41
	BRLO _0xC0
	LDI  R30,LOW(0)
	STS  _Interval_2,R30
	STS  _Interval_2+1,R30
	LDS  R30,_Shift_zn_S000000A000
	SUBI R30,-LOW(1)
	STS  _Shift_zn_S000000A000,R30
	LDS  R26,_Shift_zn_S000000A000
	CPI  R26,LOW(0x8)
	BRNE _0xC1
	LDI  R30,LOW(0)
	STS  _Shift_zn_S000000A000,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0x20
_0xC1:
; 0000 0263     {    mig_vrem=0;
_0xC0:
	CLT
	BLD  R2,1
; 0000 0264 
; 0000 0265     for (temp=0; temp<5; temp++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
_0xC3:
	LDD  R26,Y+6
	CPI  R26,LOW(0x5)
	BRLO PC+3
	JMP _0xC4
; 0000 0266     {
; 0000 0267      if(sek0!=0 || time>=600){if(x !=y ) {ekran [temp   ] =  (   (simvol [y ][temp]<<Shift_zn)  +   (simvol [x ][temp]>>(8-Shift_zn))   );}   else  {  if(sek0!=0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [45 ][temp]);} }
	LDS  R26,_sek0
	CPI  R26,LOW(0x0)
	BRNE _0xC6
	CALL SUBOPT_0x21
	BRLO _0xC5
_0xC6:
	CP   R21,R17
	BREQ _0xC8
	CALL SUBOPT_0x22
	MOVW R22,R30
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	PUSH R31
	PUSH R30
	LDI  R26,LOW(5)
	MUL  R21,R26
	MOVW R30,R0
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
	CALL SUBOPT_0x22
	CALL SUBOPT_0x25
	POP  R26
	POP  R27
	RJMP _0x2FE
_0xC8:
	LDS  R26,_sek0
	CPI  R26,LOW(0x0)
	BRNE _0xCB
	CALL SUBOPT_0x21
	BRLO _0xCA
_0xCB:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x26
	CALL SUBOPT_0x27
	RJMP _0x2FE
_0xCA:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x28
_0x2FE:
	ST   X,R30
; 0000 0268                           }
; 0000 0269     if(x1!=y1) {ekran [temp+ 6] =  (   (simvol [y1][temp]<<Shift_zn)  +   (simvol [x1][temp]>>(8-Shift_zn))   );}   else  { if(temp==4 & mig_vrem & budilnik & !mig) {ekran [temp+ 6]=(simvol [x1][temp])+128;}
_0xC5:
	CP   R20,R16
	BREQ _0xCE
	CALL SUBOPT_0x22
	MOVW R22,R30
	__ADDW1MN _ekran,6
	PUSH R31
	PUSH R30
	LDI  R26,LOW(5)
	MUL  R20,R26
	MOVW R30,R0
	CALL SUBOPT_0x23
	CALL SUBOPT_0x29
	CALL SUBOPT_0x22
	CALL SUBOPT_0x25
	POP  R26
	POP  R27
	RJMP _0x2FF
_0xCE:
	CALL SUBOPT_0x2A
	BREQ _0xD0
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2C
	RJMP _0x300
; 0000 026A                                                                                                                              else  {ekran [temp+ 6]=(simvol [x1][temp]); } }
_0xD0:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2B
	ADD  R26,R24
	ADC  R27,R25
	LD   R30,X
_0x300:
	MOVW R26,R22
_0x2FF:
	ST   X,R30
; 0000 026B     if(x2!=y2) {ekran [temp+13] =  (   (simvol [y2][temp]<<Shift_zn)  +   (simvol [x2][temp]>>(8-Shift_zn))   );}   else  { if(temp==0 & mig_vrem & budilnik & mig) {ekran [temp+13]=(simvol [x2][temp])+128;}
	LDD  R30,Y+8
	CP   R30,R19
	BREQ _0xD2
	CALL SUBOPT_0x22
	MOVW R22,R30
	__ADDW1MN _ekran,13
	PUSH R31
	PUSH R30
	LDD  R30,Y+8
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	CALL SUBOPT_0x23
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x22
	CALL SUBOPT_0x25
	POP  R26
	POP  R27
	RJMP _0x301
_0xD2:
	CALL SUBOPT_0x2E
	BREQ _0xD4
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2C
	RJMP _0x302
; 0000 026C                                                                                                                              else  {ekran [temp+13]=(simvol [x2][temp]);} }
_0xD4:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2F
	ADD  R26,R24
	ADC  R27,R25
	LD   R30,X
_0x302:
	MOVW R26,R22
_0x301:
	ST   X,R30
; 0000 026D                 ekran [temp+19] =  (   (simvol [y3][temp]<<Shift_zn)  +   (simvol [x3][temp]>>(8-Shift_zn))   );
	CALL SUBOPT_0x22
	MOVW R22,R30
	__ADDW1MN _ekran,19
	PUSH R31
	PUSH R30
	LDD  R30,Y+7
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	CALL SUBOPT_0x23
	MUL  R18,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	CALL SUBOPT_0x22
	CALL SUBOPT_0x25
	POP  R26
	POP  R27
	ST   X,R30
; 0000 026E 
; 0000 026F     }
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0xC3
_0xC4:
; 0000 0270     }
; 0000 0271 
; 0000 0272 }
; 0000 0273 else
	RJMP _0xD6
_0xBF:
; 0000 0274 {
; 0000 0275    for (temp=0; temp<5; temp++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
_0xD8:
	LDD  R26,Y+6
	CPI  R26,LOW(0x5)
	BRLO PC+3
	JMP _0xD9
; 0000 0276     {
; 0000 0277     if(sek0!=0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [45 ][temp]);}                 // 0    .
	LDS  R26,_sek0
	CPI  R26,LOW(0x0)
	BRNE _0xDB
	CALL SUBOPT_0x21
	BRLO _0xDA
_0xDB:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x26
	CALL SUBOPT_0x27
	RJMP _0x303
_0xDA:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x28
_0x303:
	ST   X,R30
; 0000 0278 
; 0000 0279 
; 0000 027A    if(temp==4 & mig_vrem & budilnik & !mig) {ekran [temp+ 6]=(simvol [x1][temp])+128;}
	CALL SUBOPT_0x2A
	BREQ _0xDE
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x2C
	RJMP _0x304
; 0000 027B                                  else  {ekran [temp+ 6]=(simvol [x1][temp]); }
_0xDE:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2B
	ADD  R26,R24
	ADC  R27,R25
	LD   R30,X
_0x304:
	MOVW R26,R22
	ST   X,R30
; 0000 027C    if(temp==0 & mig_vrem & budilnik & mig) {ekran [temp+13]=(simvol [x2][temp])+128;}
	CALL SUBOPT_0x2E
	BREQ _0xE0
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2C
	RJMP _0x305
; 0000 027D                                 else  {ekran [temp+13]=(simvol [x2][temp]);}
_0xE0:
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2F
	ADD  R26,R24
	ADC  R27,R25
	LD   R30,X
_0x305:
	MOVW R26,R22
	ST   X,R30
; 0000 027E     ekran [temp+19]=(simvol [x3][temp]);
	CALL SUBOPT_0x22
	MOVW R24,R30
	__ADDW1MN _ekran,19
	MOVW R22,R30
	LDI  R26,LOW(5)
	MUL  R18,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	CALL SUBOPT_0x27
	ST   X,R30
; 0000 027F     }
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0xD8
_0xD9:
; 0000 0280 
; 0000 0281 
; 0000 0282     Interval_2=0;
	LDI  R30,LOW(0)
	STS  _Interval_2,R30
	STS  _Interval_2+1,R30
; 0000 0283 }
_0xD6:
; 0000 0284 
; 0000 0285 
; 0000 0286 ///      
; 0000 0287 
; 0000 0288  /*
; 0000 0289   if(mig_vrem) {      if (TCNT2<128)  {if (budilnik){ekran [12]=128; ekran [11]=128;}  else  {ekran [12]=0;  ekran [11]=0;  }}       //     
; 0000 028A                          else   {if (budilnik){ekran [12]=0;     ekran [11]=0;}  else  {ekran [12]=0;  ekran [11]=128;}}
; 0000 028B 
; 0000 028C                 }
; 0000 028D 
; 0000 028E 
; 0000 028F if (data != data1)                                                                                             //     -  
; 0000 0290 {
; 0000 0291     if (Interval_2>40){Interval_2=0; Shift_zn++;  if(Shift_zn==8) {Shift_zn=0;data1=data;}   }
; 0000 0292     {    mig_vrem=0;
; 0000 0293 
; 0000 0294     for (temp=0; temp<5; temp++)
; 0000 0295     {
; 0000 0296      if(sek0!=0 || time>=600){if(x !=y ) {ekran [temp   ] =  (   (simvol [y ][temp]<<Shift_zn)  +   (simvol [x ][temp]>>(8-Shift_zn))   );}   else  {  if(sek0!=0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [45 ][temp]);} }
; 0000 0297                           }
; 0000 0298     if(x1!=y1) {ekran [temp+ 6] =  (   (simvol [y1][temp]<<Shift_zn)  +   (simvol [x1][temp]>>(8-Shift_zn))   );}   else  {  ekran [temp+ 6]=(simvol [x1][temp]); }
; 0000 0299 
; 0000 029A     if(x2!=y2) {ekran [temp+13] =  (   (simvol [y2][temp]<<Shift_zn)  +   (simvol [x2][temp]>>(8-Shift_zn))   );}   else   {ekran [temp+13]=(simvol [x2][temp]);}
; 0000 029B 
; 0000 029C                 ekran [temp+19] =  (   (simvol [y3][temp]<<Shift_zn)  +   (simvol [x3][temp]>>(8-Shift_zn))   );
; 0000 029D 
; 0000 029E     }
; 0000 029F     }
; 0000 02A0 
; 0000 02A1 }
; 0000 02A2 else
; 0000 02A3 {
; 0000 02A4    for (temp=0; temp<5; temp++)
; 0000 02A5     {
; 0000 02A6     if(sek0!=0 || time>=600) {ekran [temp   ]=(simvol [x ][temp]);} else  {ekran [temp   ]=(simvol [45 ][temp]);}                 // 0    .
; 0000 02A7     ekran [temp+ 6]=(simvol [x1][temp]);
; 0000 02A8     ekran [temp+13]=(simvol [x2][temp]);
; 0000 02A9     ekran [temp+19]=(simvol [x3][temp]);
; 0000 02AA     }
; 0000 02AB 
; 0000 02AC 
; 0000 02AD     Interval_2=0;
; 0000 02AE }
; 0000 02AF  */
; 0000 02B0 }
	CALL __LOADLOCR6
	ADIW R28,11
	RET
;
;
;
;
;
;//___________________________     1 _________________________________
; void ekran_1_figure (unsigned char x,unsigned char x1,unsigned char x2,)
; 0000 02B8 {
_ekran_1_figure:
; 0000 02B9    unsigned char temp;
; 0000 02BA    for (temp=0; temp<5; temp++)
	ST   -Y,R17
;	x -> Y+3
;	x1 -> Y+2
;	x2 -> Y+1
;	temp -> R17
	LDI  R17,LOW(0)
_0xE3:
	CPI  R17,5
	BRSH _0xE4
; 0000 02BB    {
; 0000 02BC    if (simvol [x][temp]==0xAA) return;
	CALL SUBOPT_0x30
	LD   R26,X
	CPI  R26,LOW(0xAA)
	BRNE _0xE5
	RJMP _0x2020005
; 0000 02BD    if((mig1)&&( but_on)&&(x2!=0)){ekran [temp+x1]=0;} else{ ekran [temp+x1]=(simvol [x][temp]); };
_0xE5:
	SBRS R2,3
	RJMP _0xE7
	SBRS R3,4
	RJMP _0xE7
	LDD  R26,Y+1
	CPI  R26,LOW(0x0)
	BRNE _0xE8
_0xE7:
	RJMP _0xE6
_0xE8:
	CALL SUBOPT_0x31
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RJMP _0xE9
_0xE6:
	CALL SUBOPT_0x31
	MOVW R22,R30
	CALL SUBOPT_0x30
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
_0xE9:
; 0000 02BE 
; 0000 02BF    }
	SUBI R17,-1
	RJMP _0xE3
_0xE4:
; 0000 02C0 }
	RJMP _0x2020005
;
;//_______________________________________  __________________________________________________
;void ochistka (void)
; 0000 02C4 {
_ochistka:
; 0000 02C5 unsigned char temp;
; 0000 02C6 for (temp=0;  temp<24; temp++) {ekran[temp]=0  ;}
	ST   -Y,R17
;	temp -> R17
	LDI  R17,LOW(0)
_0xEB:
	CPI  R17,24
	BRSH _0xEC
	CALL SUBOPT_0x1
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	SUBI R17,-1
	RJMP _0xEB
_0xEC:
; 0000 02C7 }
	LD   R17,Y+
	RET
;
;//_________________________________________!__2_____________________________________________
;  unsigned  char ystanovki_2 (unsigned  char x,unsigned  char x1,unsigned  char x2)
; 0000 02CB   {
_ystanovki_2:
; 0000 02CC 
; 0000 02CD   unsigned  char temp;
; 0000 02CE 
; 0000 02CF            if ((x==0) && (x1==15))x=1;
	ST   -Y,R17
;	x -> Y+3
;	x1 -> Y+2
;	x2 -> Y+1
;	temp -> R17
	LDD  R26,Y+3
	CPI  R26,LOW(0x0)
	BRNE _0xEE
	LDD  R26,Y+2
	CPI  R26,LOW(0xF)
	BREQ _0xEF
_0xEE:
	RJMP _0xED
_0xEF:
	LDI  R30,LOW(1)
	STD  Y+3,R30
; 0000 02D0         while ( (button_read() != 2)  &&  POWER )  // POWER
_0xED:
_0xF0:
	RCALL _button_read
	CPI  R30,LOW(0x2)
	BREQ _0xF3
	SBRC R3,6
	RJMP _0xF4
_0xF3:
	RJMP _0xF2
_0xF4:
; 0000 02D1         {        if(time_meny== RET_CLOCK) { ochistka();meny=10;return x;} ;
	LDS  R26,_time_meny
	LDS  R27,_time_meny+1
	SBIW R26,60
	BRNE _0xF5
	RCALL _ochistka
	LDI  R30,LOW(10)
	MOV  R6,R30
	RJMP _0x2020004
_0xF5:
; 0000 02D2         if (BUT_OK ) {x++;  if (x>x1) { if ( ( x1==12 )|| (x1==31)){x=1;}  else { x=0;}  } ;    }                   //       snm 
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0xF6
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	LDD  R30,Y+2
	LDD  R26,Y+3
	CP   R30,R26
	BRSH _0xF7
	LDD  R26,Y+2
	CPI  R26,LOW(0xC)
	BREQ _0xF9
	CPI  R26,LOW(0x1F)
	BRNE _0xF8
_0xF9:
	LDI  R30,LOW(1)
	RJMP _0x306
_0xF8:
	LDI  R30,LOW(0)
_0x306:
	STD  Y+3,R30
_0xF7:
; 0000 02D3                        for (temp=0; temp<5; temp++){   if((mig1)&&( but_on)) {ekran [temp+x2]  =0; ekran [temp+x2+6]=0;} else {    ekran [temp+x2]  =(simvol [x/10][temp]); ekran [temp+x2+6] =(simvol [x%10][temp]);}};
_0xF6:
	LDI  R17,LOW(0)
_0xFD:
	CPI  R17,5
	BRSH _0xFE
	SBRS R2,3
	RJMP _0x100
	SBRC R3,4
	RJMP _0x101
_0x100:
	RJMP _0xFF
_0x101:
	CALL SUBOPT_0x32
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	CALL SUBOPT_0x32
	__ADDW1MN _ekran,6
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RJMP _0x102
_0xFF:
	CALL SUBOPT_0x32
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	MOVW R22,R30
	LDD  R26,Y+3
	CALL SUBOPT_0x33
	CALL SUBOPT_0x34
	CALL SUBOPT_0x32
	__ADDW1MN _ekran,6
	MOVW R22,R30
	LDD  R26,Y+3
	CALL SUBOPT_0x35
	CALL SUBOPT_0x34
_0x102:
	SUBI R17,-1
	RJMP _0xFD
_0xFE:
; 0000 02D4         }
	RJMP _0xF0
_0xF2:
; 0000 02D5   ochistka();
	RCALL _ochistka
; 0000 02D6 
; 0000 02D7 
; 0000 02D8                                   return x;
_0x2020004:
	LDD  R30,Y+3
_0x2020005:
	LDD  R17,Y+0
	ADIW R28,4
	RET
; 0000 02D9   }
;
;//_________________________________________________________________________________________________
;  unsigned  int ystanovki_23_59 (unsigned  int x)
; 0000 02DD   {
_ystanovki_23_59:
; 0000 02DE   ochistka();
;	x -> Y+0
	RCALL _ochistka
; 0000 02DF 
; 0000 02E0   ekran_1_figure((x%60)/10,13,1);  ekran_1_figure(x%10,19,1);
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x36
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x37
; 0000 02E1   x = (x%60)+   (ystanovki_2 ((x/60),23, 0))*60;
	CALL SUBOPT_0x38
	CALL __MODW21U
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x38
	CALL __DIVW21U
	ST   -Y,R30
	LDI  R30,LOW(23)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _ystanovki_2
	LDI  R26,LOW(60)
	MUL  R30,R26
	MOVW R30,R0
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   Y,R30
	STD  Y+1,R31
; 0000 02E2   ekran_1_figure(x/600,0,1);  ekran_1_figure((x/60)%10,6,1);
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x39
	CALL SUBOPT_0x38
	CALL __DIVW21U
	MOVW R26,R30
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x3A
; 0000 02E3   x = (x/60*60)+(ystanovki_2 ((x%60),59,13));
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3B
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x38
	CALL __MODW21U
	ST   -Y,R30
	LDI  R30,LOW(59)
	CALL SUBOPT_0x3C
	LDI  R31,0
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	ST   Y,R30
	STD  Y+1,R31
; 0000 02E4 
; 0000 02E5   return x;
	ADIW R28,2
	RET
; 0000 02E6   }
;
;//_________________________________________ ___________________________________________________
;unsigned char beg_stroka (unsigned char x[],)
; 0000 02EA {
_beg_stroka:
; 0000 02EB   unsigned char temp;
; 0000 02EC                     for (temp=0; temp<23; temp++)  {ekran[temp]=ekran[temp+1];}
	ST   -Y,R17
;	x -> Y+1
;	temp -> R17
	LDI  R17,LOW(0)
_0x104:
	CPI  R17,23
	BRSH _0x105
	CALL SUBOPT_0x3D
	__ADDW1MN _ekran,1
	LD   R30,Z
	ST   X,R30
	SUBI R17,-1
	RJMP _0x104
_0x105:
; 0000 02ED   if ((z==5)||(simvol[x[z1]][z]==0xAA)) {ekran[23]=0;z=0; z1++; if (x[z1]==255) {z1=0; for (temp=23; temp>0; temp--)  { ekran[temp] = ekran[temp-1]; } ;ekran[0]=0; return 255;} }
	LDS  R26,_z
	CPI  R26,LOW(0x5)
	BREQ _0x107
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3F
	LD   R26,X
	CPI  R26,LOW(0xAA)
	BRNE _0x106
_0x107:
	LDI  R30,LOW(0)
	__PUTB1MN _ekran,23
	CALL SUBOPT_0x40
	CALL SUBOPT_0x3E
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BRNE _0x109
	LDI  R30,LOW(0)
	STS  _z1,R30
	LDI  R17,LOW(23)
_0x10B:
	CPI  R17,1
	BRLO _0x10C
	CALL SUBOPT_0x3D
	SBIW R30,1
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LD   R30,Z
	ST   X,R30
	SUBI R17,1
	RJMP _0x10B
_0x10C:
	LDI  R30,LOW(0)
	STS  _ekran,R30
	LDI  R30,LOW(255)
	RJMP _0x2020003
_0x109:
; 0000 02EE                   else  {ekran[23]=simvol[x[z1]][z]; z++;}
	RJMP _0x10D
_0x106:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3F
	LD   R30,X
	__PUTB1MN _ekran,23
	LDS  R30,_z
	SUBI R30,-LOW(1)
	STS  _z,R30
_0x10D:
; 0000 02EF 
; 0000 02F0 }
	RJMP _0x2020003
; //_________________________________________       ___________________________________________________
;unsigned char beg_stroka_revers (unsigned char x[],)
; 0000 02F3 {
_beg_stroka_revers:
; 0000 02F4 unsigned char temp,;
; 0000 02F5 
; 0000 02F6                 if  (simvol[x[z1]][4-z]==0xAA)  {z=4;};
	ST   -Y,R17
;	x -> Y+1
;	temp -> R17
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x41
	LD   R26,X
	CPI  R26,LOW(0xAA)
	BRNE _0x10E
	LDI  R30,LOW(4)
	STS  _z,R30
_0x10E:
; 0000 02F7                  if ((z==4) && (x[z1+1]==255)) { ekran[0]=0;z1=0; return 255;};
	LDS  R26,_z
	CPI  R26,LOW(0x4)
	BRNE _0x110
	LDS  R30,_z1
	LDI  R31,0
	ADIW R30,1
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0xFF)
	BREQ _0x111
_0x110:
	RJMP _0x10F
_0x111:
	LDI  R30,LOW(0)
	STS  _ekran,R30
	STS  _z1,R30
	LDI  R30,LOW(255)
	RJMP _0x2020003
_0x10F:
; 0000 02F8 
; 0000 02F9                 if (z==5) {ekran[0]=0;z=0; z1++; }
	LDS  R26,_z
	CPI  R26,LOW(0x5)
	BRNE _0x112
	LDI  R30,LOW(0)
	STS  _ekran,R30
	CALL SUBOPT_0x40
; 0000 02FA                     else  {ekran[0]=simvol[x[z1]][4-z]; z++;}
	RJMP _0x113
_0x112:
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x41
	LD   R30,X
	STS  _ekran,R30
	LDS  R30,_z
	SUBI R30,-LOW(1)
	STS  _z,R30
_0x113:
; 0000 02FB           for (temp=23; temp>0; temp--)  { ekran[temp] = ekran[temp-1]; }
	LDI  R17,LOW(23)
_0x115:
	CPI  R17,1
	BRLO _0x116
	CALL SUBOPT_0x3D
	SBIW R30,1
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	LD   R30,Z
	ST   X,R30
	SUBI R17,1
	RJMP _0x115
_0x116:
; 0000 02FC 
; 0000 02FD 
; 0000 02FE }
_0x2020003:
	LDD  R17,Y+0
	ADIW R28,3
	RET
;//__________________________________  _______________________________________________
;
;
;void font_cifri (void)
; 0000 0303 {
_font_cifri:
; 0000 0304             unsigned char temp,temp_srift;
; 0000 0305 
; 0000 0306 
; 0000 0307                            //______________________________________   Flash   
; 0000 0308         for (temp=10; temp<55; temp++)
	ST   -Y,R17
	ST   -Y,R16
;	temp -> R17
;	temp_srift -> R16
	LDI  R17,LOW(10)
_0x118:
	CPI  R17,55
	BRSH _0x119
; 0000 0309                  { for (i=0; i<5; i++){simvol [temp] [i]= simvol_buk[temp-10] [i];} }
	LDI  R30,LOW(0)
	STS  _i_G000,R30
_0x11B:
	LDS  R26,_i_G000
	CPI  R26,LOW(0x5)
	BRSH _0x11C
	CALL SUBOPT_0x42
	CALL SUBOPT_0x43
	MOVW R22,R30
	CALL SUBOPT_0x1
	SBIW R30,10
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
	SUBI R30,LOW(-_simvol_buk*2)
	SBCI R31,HIGH(-_simvol_buk*2)
	CALL SUBOPT_0x43
	LPM  R30,Z
	MOVW R26,R22
	ST   X,R30
	LDS  R30,_i_G000
	SUBI R30,-LOW(1)
	STS  _i_G000,R30
	RJMP _0x11B
_0x11C:
	SUBI R17,-1
	RJMP _0x118
_0x119:
; 0000 030A 
; 0000 030B 
; 0000 030C 
; 0000 030D                             if(font_==0){     for (temp=0; temp<10; temp++)
	LDS  R30,_font_
	CPI  R30,0
	BRNE _0x11D
	LDI  R17,LOW(0)
_0x11F:
	CPI  R17,10
	BRSH _0x120
; 0000 030E                                              { for (temp_srift=0; temp_srift<5; temp_srift++) {simvol [temp] [temp_srift]=simvol_0[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x122:
	CPI  R16,5
	BRSH _0x123
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_0*2)
	SBCI R31,HIGH(-_simvol_0*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x122
_0x123:
	SUBI R17,-1
	RJMP _0x11F
_0x120:
; 0000 030F                                         }
; 0000 0310                             if(font_==1){ for (temp=0; temp<10; temp++)
_0x11D:
	LDS  R26,_font_
	CPI  R26,LOW(0x1)
	BRNE _0x124
	LDI  R17,LOW(0)
_0x126:
	CPI  R17,10
	BRSH _0x127
; 0000 0311                                                 {for (temp_srift=0; temp_srift<5; temp_srift++) {simvol [temp] [temp_srift]=simvol_1[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x129:
	CPI  R16,5
	BRSH _0x12A
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_1*2)
	SBCI R31,HIGH(-_simvol_1*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x129
_0x12A:
	SUBI R17,-1
	RJMP _0x126
_0x127:
; 0000 0312                                         }
; 0000 0313                             if(font_==2){ for (temp=0; temp<10; temp++)
_0x124:
	LDS  R26,_font_
	CPI  R26,LOW(0x2)
	BRNE _0x12B
	LDI  R17,LOW(0)
_0x12D:
	CPI  R17,10
	BRSH _0x12E
; 0000 0314                                                 {for (temp_srift=0; temp_srift<5; temp_srift++){simvol [temp] [temp_srift]=simvol_2[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x130:
	CPI  R16,5
	BRSH _0x131
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_2*2)
	SBCI R31,HIGH(-_simvol_2*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x130
_0x131:
	SUBI R17,-1
	RJMP _0x12D
_0x12E:
; 0000 0315                                         }
; 0000 0316 
; 0000 0317                             if(font_==3){     for (temp=0; temp<10; temp++)
_0x12B:
	LDS  R26,_font_
	CPI  R26,LOW(0x3)
	BRNE _0x132
	LDI  R17,LOW(0)
_0x134:
	CPI  R17,10
	BRSH _0x135
; 0000 0318                                                 {for (temp_srift=0; temp_srift<5; temp_srift++)  {simvol [temp] [temp_srift]=simvol_3[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x137:
	CPI  R16,5
	BRSH _0x138
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_3*2)
	SBCI R31,HIGH(-_simvol_3*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x137
_0x138:
	SUBI R17,-1
	RJMP _0x134
_0x135:
; 0000 0319                                          }
; 0000 031A 
; 0000 031B                             if(font_==4){     for (temp=0; temp<10; temp++)
_0x132:
	LDS  R26,_font_
	CPI  R26,LOW(0x4)
	BRNE _0x139
	LDI  R17,LOW(0)
_0x13B:
	CPI  R17,10
	BRSH _0x13C
; 0000 031C                                                 { for (temp_srift=0; temp_srift<5; temp_srift++)  {simvol [temp] [temp_srift]=simvol_4[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x13E:
	CPI  R16,5
	BRSH _0x13F
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_4*2)
	SBCI R31,HIGH(-_simvol_4*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x13E
_0x13F:
	SUBI R17,-1
	RJMP _0x13B
_0x13C:
; 0000 031D                                          }
; 0000 031E 
; 0000 031F                             if(font_==5){     for (temp=0; temp<10; temp++)
_0x139:
	LDS  R26,_font_
	CPI  R26,LOW(0x5)
	BRNE _0x140
	LDI  R17,LOW(0)
_0x142:
	CPI  R17,10
	BRSH _0x143
; 0000 0320                                                 { for (temp_srift=0; temp_srift<5; temp_srift++) {simvol [temp] [temp_srift]=simvol_5[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x145:
	CPI  R16,5
	BRSH _0x146
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_5*2)
	SBCI R31,HIGH(-_simvol_5*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x145
_0x146:
	SUBI R17,-1
	RJMP _0x142
_0x143:
; 0000 0321                                         }
; 0000 0322 
; 0000 0323                             if(font_==6){     for (temp=0; temp<10; temp++)
_0x140:
	LDS  R26,_font_
	CPI  R26,LOW(0x6)
	BRNE _0x147
	LDI  R17,LOW(0)
_0x149:
	CPI  R17,10
	BRSH _0x14A
; 0000 0324                                                 { for (temp_srift=0; temp_srift<5; temp_srift++){simvol [temp] [temp_srift]=simvol_6[temp] [temp_srift];}}
	LDI  R16,LOW(0)
_0x14C:
	CPI  R16,5
	BRSH _0x14D
	CALL SUBOPT_0x42
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x44
	SUBI R30,LOW(-_simvol_6*2)
	SBCI R31,HIGH(-_simvol_6*2)
	MOVW R26,R30
	CALL SUBOPT_0x0
	CALL SUBOPT_0x45
	SUBI R16,-1
	RJMP _0x14C
_0x14D:
	SUBI R17,-1
	RJMP _0x149
_0x14A:
; 0000 0325                                          }
; 0000 0326 
; 0000 0327 
; 0000 0328 }
_0x147:
	LD   R16,Y+
	LD   R17,Y+
	RET
;//*****************************************************************************************************************//
;//*****************************************************************************************************************//
;//*****************************************************************************************************************//
;//*****************************************************************************************************************//
;void main(void)
; 0000 032E {
_main:
; 0000 032F PORTA=0x00; DDRA=0xFF;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
	LDI  R30,LOW(255)
	OUT  0x1A,R30
; 0000 0330 PORTB=0x00; DDRB=0xE3;
	LDI  R30,LOW(0)
	OUT  0x18,R30
	LDI  R30,LOW(227)
	OUT  0x17,R30
; 0000 0331 PORTC=0x00; DDRC=0x3F;
	LDI  R30,LOW(0)
	OUT  0x15,R30
	LDI  R30,LOW(63)
	OUT  0x14,R30
; 0000 0332 PORTD=0x00; DDRD=0xFF;
	LDI  R30,LOW(0)
	OUT  0x12,R30
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 0333 
; 0000 0334 TCCR0=0x03;           //  0 125,000 kHz   (8000000/64)
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 0335 OCR0=254;             //
	LDI  R30,LOW(254)
	OUT  0x3C,R30
; 0000 0336 
; 0000 0337 TCCR1B=0x0C;          //  1 125,000 kHz   (8000000/64)
	LDI  R30,LOW(12)
	OUT  0x2E,R30
; 0000 0338 OCR1A=20;
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 0339 
; 0000 033A ASSR=0x08;            //    TOSC1,2    32768
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 033B TCCR2=0x05;           // 32768/128=256
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 033C OCR1A=127;            //
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	OUT  0x2A+1,R31
	OUT  0x2A,R30
; 0000 033D 
; 0000 033E TIMSK=0xC3;           //    
	LDI  R30,LOW(195)
	OUT  0x39,R30
; 0000 033F 
; 0000 0340 ACSR= 0x48;           // .
	LDI  R30,LOW(72)
	OUT  0x8,R30
; 0000 0341 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0342 
; 0000 0343 MCUCR|=0b00110000;    //     - Power Sawe
	IN   R30,0x35
	ORI  R30,LOW(0x30)
	OUT  0x35,R30
; 0000 0344 
; 0000 0345 ADCSRA=0b10000011;    //  .    - 1.
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 0346 ADMUX= 0b01100111;    // -AVcc.     7,  
	LDI  R30,LOW(103)
	OUT  0x7,R30
; 0000 0347 
; 0000 0348 #asm                                //     1 Wire
; 0000 0349    .equ __w1_port=0x18 ;PORTB       //     
   .equ __w1_port=0x18 ;PORTB       //     
; 0000 034A    .equ __w1_bit=4                  //  4
   .equ __w1_bit=4                  //  4
; 0000 034B #endasm
; 0000 034C 
; 0000 034D for (temp=0;temp<9;temp++){budilnik_time [temp] = budilnik_Install [temp] = 0; if(temp<4)budilnik_raz[temp]= 1;}  bud_flg=0; budilnik=0 ; // ""  
	LDI  R30,LOW(0)
	STS  _temp,R30
_0x14F:
	LDS  R26,_temp
	CPI  R26,LOW(0x9)
	BRSH _0x150
	LDS  R30,_temp
	CALL SUBOPT_0x46
	MOVW R0,R30
	LDS  R26,_temp
	LDI  R27,0
	SUBI R26,LOW(-_budilnik_Install)
	SBCI R27,HIGH(-_budilnik_Install)
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R26,R0
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
	LDS  R26,_temp
	CPI  R26,LOW(0x4)
	BRSH _0x151
	CALL SUBOPT_0x47
	CALL SUBOPT_0x48
_0x151:
	CALL SUBOPT_0x49
	RJMP _0x14F
_0x150:
	CLT
	BLD  R2,4
	BLD  R2,5
; 0000 034E den_nedeli=Day_week ();             //   
	CALL _Day_week
	MOV  R9,R30
; 0000 034F devices=w1_search(0xf0,rom_code);   //   DS18B20,      
	CALL SUBOPT_0xC
; 0000 0350 if (devices==1)
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRNE _0x152
; 0000 0351                { if (ds1820_d!=0)ds1820_d=0; if(ds1820_y!=1)ds1820_y=1;}
	CALL SUBOPT_0xD
	SBIW R30,0
	BREQ _0x153
	CALL SUBOPT_0xE
_0x153:
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ _0x154
	CALL SUBOPT_0x10
_0x154:
; 0000 0352 
; 0000 0353 if (devices==2)
_0x152:
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRNE _0x155
; 0000 0354                  {if (ds1820_d<0 || ds1820_d>255) ds1820_d=0; if(ds1820_y<0 || ds1820_y>255)ds1820_y=1; }
	LDI  R26,LOW(_ds1820_d+1)
	LDI  R27,HIGH(_ds1820_d+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x157
	CALL SUBOPT_0xD
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x156
_0x157:
	CALL SUBOPT_0xE
_0x156:
	LDI  R26,LOW(_ds1820_y+1)
	LDI  R27,HIGH(_ds1820_y+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x15A
	CALL SUBOPT_0xF
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x159
_0x15A:
	CALL SUBOPT_0x10
_0x159:
; 0000 0355 
; 0000 0356 
; 0000 0357 //**********     .
; 0000 0358 PORTB.6=1;                      //      Z  (     )
_0x155:
	SBI  0x18,6
; 0000 0359 PORTA.7=0; DDRA.7=0;            //  .7   ,         ,
	CBI  0x1B,7
	CBI  0x1A,7
; 0000 035A ADCSRA=0b11000011;              //   (   )
	LDI  R30,LOW(195)
	OUT  0x6,R30
; 0000 035B while (ADCSRA&0b01000000){}     //     
_0x162:
	SBIC 0x6,6
	RJMP _0x162
; 0000 035C DDRA.7=1;                       //  .7   
	SBI  0x1A,7
; 0000 035D if (ADCH>5) {foto_r=1; if(brigh_up>255 || brigh_up<=0)brigh_up=254;} //else brigh_up=9;   //
	IN   R30,0x5
	CPI  R30,LOW(0x6)
	BRLO _0x167
	LDI  R30,LOW(1)
	STS  _foto_r,R30
	CALL SUBOPT_0x4A
	MOV  R0,R30
	MOV  R26,R30
	LDI  R30,LOW(255)
	CP   R30,R26
	BRLO _0x169
	MOV  R30,R0
	CPI  R30,LOW(0x1)
	BRSH _0x168
_0x169:
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	LDI  R30,LOW(254)
	CALL __EEPROMWRB
_0x168:
; 0000 035E ochistka();  //   
_0x167:
	RCALL _ochistka
; 0000 035F //#asm("cli")
; 0000 0360 #asm("sei")
	sei
; 0000 0361 if(font_epp<0 || font_epp>6) font_epp=5;
	LDI  R26,LOW(_font_epp+1)
	LDI  R27,HIGH(_font_epp+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x16C
	LDI  R26,LOW(_font_epp)
	LDI  R27,HIGH(_font_epp)
	CALL __EEPROMRDW
	SBIW R30,7
	BRLT _0x16B
_0x16C:
	LDI  R26,LOW(_font_epp)
	LDI  R27,HIGH(_font_epp)
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL __EEPROMWRW
; 0000 0362 if( speed<1 || speed>65) speed=24;
_0x16B:
	CALL SUBOPT_0x4B
	MOVW R26,R30
	SBIW R30,1
	BRLT _0x16F
	MOVW R30,R26
	CPI  R30,LOW(0x42)
	LDI  R26,HIGH(0x42)
	CPC  R31,R26
	BRLT _0x16E
_0x16F:
	LDI  R26,LOW(_speed)
	LDI  R27,HIGH(_speed)
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CALL __EEPROMWRW
; 0000 0363 if( td10<0 ||  td10>255)  td10=0;
_0x16E:
	LDI  R26,LOW(_td10+1)
	LDI  R27,HIGH(_td10+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x172
	CALL SUBOPT_0x4C
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x171
_0x172:
	LDI  R26,LOW(_td10)
	LDI  R27,HIGH(_td10)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
; 0000 0364 if( tu10<0 ||  tu10>255)  tu10=1;
_0x171:
	LDI  R26,LOW(_tu10+1)
	LDI  R27,HIGH(_tu10+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x175
	CALL SUBOPT_0x4D
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x174
_0x175:
	LDI  R26,LOW(_tu10)
	LDI  R27,HIGH(_tu10)
	CALL SUBOPT_0x4E
; 0000 0365 if( sek_ind<0 ||  sek_ind>2)  sek_ind=1;
_0x174:
	LDI  R26,LOW(_sek_ind+1)
	LDI  R27,HIGH(_sek_ind+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x178
	CALL SUBOPT_0x4F
	SBIW R30,3
	BRLT _0x177
_0x178:
	LDI  R26,LOW(_sek_ind)
	LDI  R27,HIGH(_sek_ind)
	CALL SUBOPT_0x4E
; 0000 0366 if (str_period <0 || str_period >255) str_period =15;
_0x177:
	LDI  R26,LOW(_str_period+1)
	LDI  R27,HIGH(_str_period+1)
	CALL __EEPROMRDB
	TST  R30
	BRMI _0x17B
	CALL SUBOPT_0x18
	CPI  R30,LOW(0x100)
	LDI  R26,HIGH(0x100)
	CPC  R31,R26
	BRLT _0x17A
_0x17B:
	LDI  R26,LOW(_str_period)
	LDI  R27,HIGH(_str_period)
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL __EEPROMWRW
; 0000 0367 font_=font_epp;
_0x17A:
	LDI  R26,LOW(_font_epp)
	LDI  R27,HIGH(_font_epp)
	CALL __EEPROMRDB
	STS  _font_,R30
; 0000 0368 font_cifri();
	RCALL _font_cifri
; 0000 0369 str_sec=0;
	LDI  R30,LOW(0)
	STS  _str_sec,R30
; 0000 036A 
; 0000 036B 
; 0000 036C //*****************************************************************************************************************//
; 0000 036D //*****************************************************************************************************************//
; 0000 036E while (1)
_0x17D:
; 0000 036F {
; 0000 0370 button_read();   //  
	CALL _button_read
; 0000 0371 if( time_meny== RET_CLOCK) { time_meny=0; ochistka(); meny=10;}            //     RET_CLOCK  .
	LDS  R26,_time_meny
	LDS  R27,_time_meny+1
	SBIW R26,60
	BRNE _0x180
	CALL SUBOPT_0x8
	RCALL _ochistka
	LDI  R30,LOW(10)
	MOV  R6,R30
; 0000 0372 
; 0000 0373 
; 0000 0374 switch (meny)
_0x180:
	MOV  R30,R6
	LDI  R31,0
; 0000 0375         {
; 0000 0376         case 10: //______ 
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x184
; 0000 0377 
; 0000 0378          mig_vrem=1;
	SET
	BLD  R2,1
; 0000 0379                  ekran_cifri(time);  //  
	CALL SUBOPT_0x50
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ekran_cifri
; 0000 037A 
; 0000 037B 
; 0000 037C                 //______ 
; 0000 037D                  if ( ( flg_ds18b20 ) && ( bud_flg == 0 ) )                                                                                 //   
	SBRS R4,1
	RJMP _0x186
	LDI  R26,0
	SBRC R2,4
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BREQ _0x187
_0x186:
	RJMP _0x185
_0x187:
; 0000 037E                         {
; 0000 037F                         flg_ds18b20=0;
	CLT
	BLD  R4,1
; 0000 0380                         for (i=0;i<devices;i++)
	LDI  R30,LOW(0)
	STS  _i_G000,R30
_0x189:
	LDS  R30,_devices_G000
	LDS  R26,_i_G000
	CP   R26,R30
	BRLO PC+3
	JMP _0x18A
; 0000 0381                                 {
; 0000 0382                                error_ds18b20[i]++;                                                               //      DS18B20
	LDI  R27,0
	SUBI R26,LOW(-_error_ds18b20)
	SBCI R27,HIGH(-_error_ds18b20)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
; 0000 0383                                 temperature_temp=ds18b20_read_temp (&rom_code[i][0]);                             //    DS18B20
	CALL SUBOPT_0x51
	CALL _ds18b20_read_temp
	STS  _temperature_temp,R30
	STS  _temperature_temp+1,R31
	STS  _temperature_temp+2,R22
	STS  _temperature_temp+3,R23
; 0000 0384                                 if (temperature_temp!=(-9999))                                                    //    ,    "temperature"
	CALL SUBOPT_0x52
	__CPD2N 0xC61C3C00
	BREQ _0x18B
; 0000 0385                                                             {
; 0000 0386                                                             temperature[i]=temperature_temp*10;
	CALL SUBOPT_0x53
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x52
	__GETD1N 0x41200000
	CALL __MULF12
	POP  R26
	POP  R27
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
; 0000 0387                                                             // temperature[i]+=5;                                 //      "temperature" + 0,5 C
; 0000 0388                                                             error_ds18b20[i]=0;                                   //      DS18B20
	CALL SUBOPT_0x54
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 0389                                                             }
; 0000 038A                                 if(error_ds18b20[i]==255)  temperature[i]=-999;                                   //   DS18B20  5     ,    (  -99,9 )
_0x18B:
	CALL SUBOPT_0x54
	LD   R26,Z
	CPI  R26,LOW(0xFF)
	BRNE _0x18C
	CALL SUBOPT_0x53
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(64537)
	LDI  R31,HIGH(64537)
	ST   X+,R30
	ST   X,R31
; 0000 038B                                 ds18b20_convert_temp(&rom_code[i][0]);                                            //    
_0x18C:
	CALL SUBOPT_0x51
	CALL _ds18b20_convert_temp
; 0000 038C                                 }
	LDS  R30,_i_G000
	SUBI R30,-LOW(1)
	STS  _i_G000,R30
	RJMP _0x189
_0x18A:
; 0000 038D                         }
; 0000 038E 
; 0000 038F                 if ((str_sec==str_period)  && (str != 0) &&  (mig_vrem))  {  temp2=str;                                                      //          
_0x185:
	CALL SUBOPT_0x18
	CALL SUBOPT_0x19
	BRNE _0x18E
	CALL SUBOPT_0x55
	CPI  R30,0
	BREQ _0x18E
	SBRC R2,1
	RJMP _0x18F
_0x18E:
	RJMP _0x18D
_0x18F:
	CALL SUBOPT_0x55
	STS  _temp2,R30
; 0000 0390                                                    if (( (temp2 & 0x01) || (temp2 & 0x02) || (temp2 & 0x04) ||                               //          
; 0000 0391                                                         ((temp2 & 0x08) && (devices>0)) || ((temp2 & 0x10) && (devices>0))
; 0000 0392                                                       ) )
	ANDI R30,LOW(0x1)
	BRNE _0x191
	LDS  R30,_temp2
	ANDI R30,LOW(0x2)
	BRNE _0x191
	LDS  R30,_temp2
	ANDI R30,LOW(0x4)
	BRNE _0x191
	LDS  R30,_temp2
	ANDI R30,LOW(0x8)
	BREQ _0x192
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x191
_0x192:
	LDS  R30,_temp2
	ANDI R30,LOW(0x10)
	BREQ _0x194
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x191
_0x194:
	RJMP _0x190
_0x191:
; 0000 0393                                                          {  z=0; z1=0;temp=0; if(devices>0){enable_date++;} else {enable_date=1;};full_str=0; meny=15 ; temp2=str;  mig_vrem=1;}
	CALL SUBOPT_0x56
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRLO _0x197
	LDI  R30,LOW(64)
	EOR  R2,R30
	RJMP _0x198
_0x197:
	SET
	BLD  R2,6
_0x198:
	CLT
	BLD  R3,2
	LDI  R30,LOW(15)
	MOV  R6,R30
	CALL SUBOPT_0x55
	STS  _temp2,R30
	SET
	BLD  R2,1
; 0000 0394 
; 0000 0395 
; 0000 0396                                                 }
_0x190:
; 0000 0397              if (sek_ind) { if ((sek!=0)&& (sek%10==0) && (str != 0) && (mig_vrem) )  { z=0; z1=0;temp=0; meny=12 ; temp2=str;mig_vrem=0; }};    //       
_0x18D:
	CALL SUBOPT_0x4F
	SBIW R30,0
	BREQ _0x199
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ _0x19B
	MOV  R26,R5
	CALL SUBOPT_0x35
	SBIW R30,0
	BRNE _0x19B
	CALL SUBOPT_0x55
	CPI  R30,0
	BREQ _0x19B
	SBRC R2,1
	RJMP _0x19C
_0x19B:
	RJMP _0x19A
_0x19C:
	CALL SUBOPT_0x56
	LDI  R30,LOW(12)
	MOV  R6,R30
	CALL SUBOPT_0x55
	STS  _temp2,R30
	CLT
	BLD  R2,1
_0x19A:
_0x199:
; 0000 0398                mig_vrem=0;
	CLT
	BLD  R2,1
; 0000 0399 
; 0000 039A                 if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;   meny=30;  bud_flg=0;data1=(((time-(time/60*60))*60)+sek);}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x19D
	CALL SUBOPT_0x57
	CLT
	BLD  R2,4
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
	CALL SUBOPT_0x20
; 0000 039B                 if (BUT_OK)   {  meny=20 ;z=0; z1=0;}                //     
_0x19D:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x19E
	LDI  R30,LOW(20)
	CALL SUBOPT_0x5A
; 0000 039C         break;
_0x19E:
	JMP  _0x183
; 0000 039D         case 12:  //_________//______        
_0x184:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x19F
; 0000 039E                  mig_vrem=0;
	CLT
	BLD  R2,1
; 0000 039F                       if(enable_write_buf){                                                 //       1 
	SBRS R2,7
	RJMP _0x1A0
; 0000 03A0                             t=0; temp1=0;
	CALL SUBOPT_0x5B
; 0000 03A1                             beg_info[t]=0;
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x5D
; 0000 03A2                             beg_info[t++]=44;
	CALL SUBOPT_0x5E
; 0000 03A3                             beg_info[t++]= (sek%60)/10;            //      
	MOV  R26,R5
	CLR  R27
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL SUBOPT_0x5F
; 0000 03A4                             beg_info[t++]= sek%10;                 //      
	MOV  R26,R5
	CALL SUBOPT_0x35
	CALL SUBOPT_0x60
; 0000 03A5                             beg_info[t++]=255;                     //      " "
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 03A6                             enable_write_buf=0;
	CLT
	BLD  R2,7
; 0000 03A7                                           };
_0x1A0:
; 0000 03A8                 if (Interval >= speed)  {Interval=0; if (beg_stroka (beg_info)==255) {delay_ms(1000); z=0; z1=0; t=0; temp1=0; enable_write_buf=1;  meny=13;}}   //
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x1A1
	CALL SUBOPT_0x62
	RCALL _beg_stroka
	CPI  R30,LOW(0xFF)
	BRNE _0x1A2
	CALL SUBOPT_0x63
	SET
	BLD  R2,7
	LDI  R30,LOW(13)
	MOV  R6,R30
_0x1A2:
; 0000 03A9                 if (BUT_STEP) {ochistka();  z=0; z1=0; t=0; temp1=0; meny=30; }
_0x1A1:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1A3
	CALL SUBOPT_0x57
; 0000 03AA                 if (BUT_OK)   { ochistka();meny=20;}
_0x1A3:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1A4
	RCALL _ochistka
	LDI  R30,LOW(20)
	MOV  R6,R30
; 0000 03AB 
; 0000 03AC          break;
_0x1A4:
	JMP  _0x183
; 0000 03AD         case 13:   //______          
_0x19F:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1A5
; 0000 03AE                 mig_vrem=0;
	CLT
	BLD  R2,1
; 0000 03AF 
; 0000 03B0                                            t=0; temp1=0;
	CALL SUBOPT_0x5B
; 0000 03B1                                            beg_info[t++]=53;
	CALL SUBOPT_0x64
	LDI  R26,LOW(53)
	STD  Z+0,R26
; 0000 03B2                                            beg_info[t++]=(time%600)/60;                            //     
	CALL SUBOPT_0x64
	MOVW R22,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1C
	MOVW R26,R22
	ST   X,R30
; 0000 03B3                                             if (time/600!=0) { beg_info[t++]=time/600;}              //     
	CALL SUBOPT_0x65
	SBIW R30,0
	BREQ _0x1A6
	CALL SUBOPT_0x64
	MOVW R22,R30
	CALL SUBOPT_0x65
	MOVW R26,R22
	ST   X,R30
; 0000 03B4                                                       else   {beg_info[t++]=45;}
	RJMP _0x1A7
_0x1A6:
	CALL SUBOPT_0x64
	LDI  R26,LOW(45)
	STD  Z+0,R26
_0x1A7:
; 0000 03B5                                            beg_info[t++]=255;                                        //      " "
	CALL SUBOPT_0x64
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 03B6 
; 0000 03B7                     if (Interval >= speed)  {Interval=0; if (beg_stroka_revers(beg_info)==255) { meny=10; z=0; z1=0;  t=0; temp1=0;  ochistka();break;}}        //    
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x1A8
	CALL SUBOPT_0x62
	RCALL _beg_stroka_revers
	CPI  R30,LOW(0xFF)
	BRNE _0x1A9
	LDI  R30,LOW(10)
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x5B
	RCALL _ochistka
	JMP  _0x183
_0x1A9:
; 0000 03B8                     if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;   meny=30; }
_0x1A8:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1AA
	CALL SUBOPT_0x57
; 0000 03B9                     if (BUT_OK)   {ochistka();meny=20;}
_0x1AA:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1AB
	RCALL _ochistka
	LDI  R30,LOW(20)
	MOV  R6,R30
; 0000 03BA         break;
_0x1AB:
	JMP  _0x183
; 0000 03BB 
; 0000 03BC         //*******  .        . **********
; 0000 03BD         case 15: //______    .
_0x1A5:
	CPI  R30,LOW(0xF)
	LDI  R26,HIGH(0xF)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1AC
; 0000 03BE 
; 0000 03BF                  mig_vrem=0;
	CLT
	BLD  R2,1
; 0000 03C0 
; 0000 03C1                                             t=0; temp1=0;
	CALL SUBOPT_0x5B
; 0000 03C2                                             den_nedeli=Day_week ();
	CALL _Day_week
	MOV  R9,R30
; 0000 03C3                                             beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;            // 3    
	CALL SUBOPT_0x64
	MOVW R22,R30
	CALL SUBOPT_0x64
	MOVW R0,R30
	CALL SUBOPT_0x64
	CALL SUBOPT_0x66
	MOVW R26,R22
	ST   X,R30
; 0000 03C4 
; 0000 03C5 
; 0000 03C6                                     if(temp2 & enable_date) {                                                //   
	LDI  R30,0
	SBRC R2,6
	LDI  R30,1
	LDS  R26,_temp2
	AND  R30,R26
	BRNE PC+3
	JMP _0x1AD
; 0000 03C7                                              if (temp2 & 0x01)                                              //  " "  
	LDS  R30,_temp2
	ANDI R30,LOW(0x1)
	BREQ _0x1AE
; 0000 03C8                                                              {
; 0000 03C9                         while (den_nedeli_txt[den_nedeli][t-3] != 255)         //
_0x1AF:
	CALL SUBOPT_0x67
	CALL SUBOPT_0x5C
	SBIW R30,3
	ADD  R30,R26
	ADC  R31,R27
	LPM  R26,Z
	CPI  R26,LOW(0xFF)
	BREQ _0x1B1
; 0000 03CA                                 {                                              //
; 0000 03CB                                 beg_info[t]=den_nedeli_txt[den_nedeli][t++-3]; //
	CALL SUBOPT_0x5C
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	MOVW R22,R30
	CALL SUBOPT_0x67
	CALL SUBOPT_0x68
	SBIW R30,3
	CALL SUBOPT_0x45
; 0000 03CC                                 } beg_info[t++] = 42;                          //  
	RJMP _0x1AF
_0x1B1:
	CALL SUBOPT_0x64
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03CD                         }
; 0000 03CE                                             if (temp2 & 0x02)                                              //   ""  
_0x1AE:
	LDS  R30,_temp2
	ANDI R30,LOW(0x2)
	BREQ _0x1B2
; 0000 03CF                                                              {                                                      //
; 0000 03D0                         if (chislo>9) {beg_info[t++]=chislo/10;}               //     9,  "" 
	LDI  R30,LOW(9)
	CP   R30,R8
	BRSH _0x1B3
	CALL SUBOPT_0x64
	MOVW R22,R30
	MOV  R26,R8
	CALL SUBOPT_0x33
	MOVW R26,R22
	ST   X,R30
; 0000 03D1                         beg_info[t++]=chislo%10;                               //   "" 
_0x1B3:
	CALL SUBOPT_0x64
	MOVW R22,R30
	MOV  R26,R8
	CALL SUBOPT_0x35
	CALL SUBOPT_0x60
; 0000 03D2                         beg_info[t++]=42;                                      //  
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03D3                         temp1=t;
	LDS  R30,_t
	STS  _temp1,R30
; 0000 03D4                         while (name_mesec_txt[mesec-1][(t-temp1)] != 255)      //   
_0x1B4:
	MOV  R30,R7
	CALL SUBOPT_0x2
	CALL SUBOPT_0x69
	LDS  R26,_t
	CLR  R27
	CALL SUBOPT_0x6A
	LPM  R26,Z
	CPI  R26,LOW(0xFF)
	BREQ _0x1B6
; 0000 03D5                                 {
; 0000 03D6                                 beg_info[t]=name_mesec_txt[mesec-1][t++-temp1];
	CALL SUBOPT_0x5C
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	MOVW R24,R30
	MOV  R30,R7
	CALL SUBOPT_0x2
	CALL SUBOPT_0x69
	CALL SUBOPT_0x68
	MOVW R26,R30
	CALL SUBOPT_0x6A
	LPM  R30,Z
	MOVW R26,R24
	ST   X,R30
; 0000 03D7                                 } beg_info[t++] = 42;                          // 
	RJMP _0x1B4
_0x1B6:
	CALL SUBOPT_0x64
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03D8                         }
; 0000 03D9                                             if (temp2 & 0x04 )                                              //   ""  
_0x1B2:
	LDS  R30,_temp2
	ANDI R30,LOW(0x4)
	BREQ _0x1B7
; 0000 03DA                                                              {
; 0000 03DB                         beg_info[t++]=2;                                       // ""  (2)
	CALL SUBOPT_0x64
	LDI  R26,LOW(2)
	STD  Z+0,R26
; 0000 03DC                         beg_info[t++]=0;                                       // ""   (0)
	CALL SUBOPT_0x68
	CALL SUBOPT_0x5D
; 0000 03DD                         beg_info[t++]=(god%100)/10;                            // "" 
	MOVW R22,R30
	MOV  R26,R10
	CLR  R27
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0x5F
; 0000 03DE                         beg_info[t++]=god%10;                                  // "" 
	MOV  R26,R10
	CALL SUBOPT_0x35
	CALL SUBOPT_0x60
; 0000 03DF                         beg_info[t++]=13;                                      // ""
	LDI  R26,LOW(13)
	STD  Z+0,R26
; 0000 03E0                         beg_info[t++]=42; beg_info[t++]=42;                    // 2 
	CALL SUBOPT_0x64
	CALL SUBOPT_0x6B
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03E1                         }
; 0000 03E2 
; 0000 03E3                                             if((full_str  && (devices>0) )) {goto TEMPER1;}; //     ,  
_0x1B7:
	SBRS R3,2
	RJMP _0x1B9
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x1BA
_0x1B9:
	RJMP _0x1B8
_0x1BA:
	RJMP _0x1BB
_0x1B8:
; 0000 03E4                                                             }
; 0000 03E5 
; 0000 03E6                                     else{
	RJMP _0x1BC
_0x1AD:
; 0000 03E7                                   TEMPER1:
_0x1BB:
; 0000 03E8 
; 0000 03E9                                             if (  (temp2 & 0x08) && (devices>0) )                                 //   "  "  
	LDS  R30,_temp2
	ANDI R30,LOW(0x8)
	BREQ _0x1BE
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x1BF
_0x1BE:
	RJMP _0x1BD
_0x1BF:
; 0000 03EA                                                              {
; 0000 03EB                                                             beg_info[t++]=42;                                                    // 
	CALL SUBOPT_0x64
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03EC                                             if ((temp2 & 0x10) && (devices>1)) {
	LDS  R30,_temp2
	ANDI R30,LOW(0x10)
	BREQ _0x1C1
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRSH _0x1C2
_0x1C1:
	RJMP _0x1C0
_0x1C2:
; 0000 03ED                                                             beg_info[t++]=14;  beg_info[t++]=24;   //  ""
	CALL SUBOPT_0x64
	LDI  R26,LOW(14)
	STD  Z+0,R26
	CALL SUBOPT_0x64
	CALL SUBOPT_0x6C
; 0000 03EE                                                             beg_info[t++]=22;  beg_info[t++]=10;   //  ""
	LDI  R26,LOW(22)
	STD  Z+0,R26
	CALL SUBOPT_0x64
	CALL SUBOPT_0x6D
; 0000 03EF                                                             beg_info[t++]=42;                      // 
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03F0                                                             }
; 0000 03F1                         beg_info[t++]=44;                                                    //  
_0x1C0:
	CALL SUBOPT_0x64
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 03F2                          if (temperature[ds1820_d]!=0){
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	SBIW R30,0
	BREQ _0x1C3
; 0000 03F3                          if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;              //     -   ,    -  
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	TST  R31
	BRPL _0x1C4
	CALL SUBOPT_0x64
	LDI  R26,LOW(51)
	RJMP _0x307
_0x1C4:
	CALL SUBOPT_0x64
	LDI  R26,LOW(47)
_0x307:
	STD  Z+0,R26
; 0000 03F4                                                       };
_0x1C3:
; 0000 03F5                         if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x1C6
	CALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	POP  R26
	POP  R27
	ST   X,R30
; 0000 03F6                         if (td10==0){if (abs(temperature[ds1820_d]%10)>=5) {if (temperature[ds1820_d]<0){temperature[ds1820_d]-=1;}else{temperature[ds1820_d]+=1;}}}  //  1          0.5 C
_0x1C6:
	CALL SUBOPT_0x4C
	SBIW R30,0
	BRNE _0x1C7
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x71
	CALL SUBOPT_0x6F
	SBIW R30,5
	BRLT _0x1C8
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	TST  R31
	BRPL _0x1C9
	CALL SUBOPT_0xD
	CALL SUBOPT_0x72
	SBIW R30,1
	RJMP _0x308
_0x1C9:
	CALL SUBOPT_0xD
	CALL SUBOPT_0x72
	ADIW R30,1
_0x308:
	ST   -X,R31
	ST   -X,R30
_0x1C8:
; 0000 03F7                         beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                   //  " "
_0x1C7:
	CALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x73
	POP  R26
	POP  R27
	ST   X,R30
; 0000 03F8                         //______________________________________________________     ____________________________________
; 0000 03F9                         if (td10==1){beg_info[t++]=43;                                                 //  
	CALL SUBOPT_0x4C
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1CB
	CALL SUBOPT_0x64
	CALL SUBOPT_0x74
; 0000 03FA                                    beg_info[t++]=abs(temperature[ds1820_d])%10;                      //   .
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xD
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x71
	POP  R26
	POP  R27
	ST   X,R30
; 0000 03FB                                   }
; 0000 03FC                         //____________________________________________________________________________________________________________________________
; 0000 03FD                         beg_info[t++]=48;                                                    //  
_0x1CB:
	CALL SUBOPT_0x64
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 03FE                         beg_info[t++]=42;                                                    // 
	CALL SUBOPT_0x64
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 03FF                         }
; 0000 0400                                             if (  (temp2 & 0x10) && (devices>1) )                                  //   "  "  
_0x1BD:
	LDS  R30,_temp2
	ANDI R30,LOW(0x10)
	BREQ _0x1CD
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRSH _0x1CE
_0x1CD:
	RJMP _0x1CC
_0x1CE:
; 0000 0401                                                              {
; 0000 0402                          beg_info[t++]=23;  beg_info[t++]=10;                                 //   ""
	CALL SUBOPT_0x64
	LDI  R26,LOW(23)
	STD  Z+0,R26
	CALL SUBOPT_0x64
	CALL SUBOPT_0x6D
; 0000 0403                          beg_info[t++]=42;                                                    // 
	CALL SUBOPT_0x6B
; 0000 0404                         beg_info[t++]=29;  beg_info[t++]=21;                                 //   ""
	LDI  R26,LOW(29)
	STD  Z+0,R26
	CALL SUBOPT_0x64
	LDI  R26,LOW(21)
	STD  Z+0,R26
; 0000 0405                         beg_info[t++]=18;  beg_info[t++]=32;  beg_info[t++]=15;              //   ""
	CALL SUBOPT_0x64
	LDI  R26,LOW(18)
	STD  Z+0,R26
	CALL SUBOPT_0x64
	LDI  R26,LOW(32)
	STD  Z+0,R26
	CALL SUBOPT_0x64
	CALL SUBOPT_0x75
; 0000 0406                          beg_info[t++]=42;                                                    //  
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0407                         if (temperature[ds1820_y]!=0){
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	SBIW R30,0
	BREQ _0x1CF
; 0000 0408                         if (temperature[ds1820_y]<0) beg_info[t++]=51;     else beg_info[t++]=47;          //     -   
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	TST  R31
	BRPL _0x1D0
	CALL SUBOPT_0x64
	LDI  R26,LOW(51)
	RJMP _0x309
_0x1D0:
	CALL SUBOPT_0x64
	LDI  R26,LOW(47)
_0x309:
	STD  Z+0,R26
; 0000 0409                                                       };
_0x1CF:
; 0000 040A                         if (abs(temperature[ds1820_y])>99){beg_info[t++]=(abs(temperature[ds1820_y])/100);}//    >10,   ""  
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x1D2
	CALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	POP  R26
	POP  R27
	ST   X,R30
; 0000 040B                         if (tu10==0){if (abs(temperature[ds1820_y]%10)>=5) { if (temperature[ds1820_y]<0){temperature[ds1820_y]-=1;}else{temperature[ds1820_y]+=1;}}}  //  1          0.5 C
_0x1D2:
	CALL SUBOPT_0x4D
	SBIW R30,0
	BRNE _0x1D3
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x71
	CALL SUBOPT_0x6F
	SBIW R30,5
	BRLT _0x1D4
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	TST  R31
	BRPL _0x1D5
	CALL SUBOPT_0xF
	CALL SUBOPT_0x72
	SBIW R30,1
	RJMP _0x30A
_0x1D5:
	CALL SUBOPT_0xF
	CALL SUBOPT_0x72
	ADIW R30,1
_0x30A:
	ST   -X,R31
	ST   -X,R30
_0x1D4:
; 0000 040C                         beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                 //  " "
_0x1D3:
	CALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x73
	POP  R26
	POP  R27
	ST   X,R30
; 0000 040D                         //         -    
; 0000 040E                         if (tu10==1){ beg_info[t++]=43;                                                 //  
	CALL SUBOPT_0x4D
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1D7
	CALL SUBOPT_0x64
	CALL SUBOPT_0x74
; 0000 040F                                    beg_info[t++]=abs(temperature[ds1820_y])%10;                      //   .
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xF
	CALL SUBOPT_0x6E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x71
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0410                                   }
; 0000 0411                         beg_info[t++]=48;                                                    //  
_0x1D7:
	CALL SUBOPT_0x64
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 0412                         beg_info[t++]=42;  beg_info[t++]=42;                                 // 
	CALL SUBOPT_0x64
	CALL SUBOPT_0x6B
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0413                         }
; 0000 0414 
; 0000 0415                                         };
_0x1CC:
_0x1BC:
; 0000 0416 
; 0000 0417                                             if (time/600!=0) { beg_info[t++]=time/600;} else beg_info[t++]=42;    //     
	CALL SUBOPT_0x65
	SBIW R30,0
	BREQ _0x1D8
	CALL SUBOPT_0x64
	MOVW R22,R30
	CALL SUBOPT_0x65
	MOVW R26,R22
	ST   X,R30
	RJMP _0x1D9
_0x1D8:
	CALL SUBOPT_0x64
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0418                                             beg_info[t++]=(time%600)/60;                                          //     
_0x1D9:
	CALL SUBOPT_0x64
	MOVW R22,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x60
; 0000 0419                                             beg_info[t++]=44;                                                     //     
	CALL SUBOPT_0x5E
; 0000 041A                                             beg_info[t++]=(time%60)/10;                                           //     
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x60
; 0000 041B                                             beg_info[t++]=time%10;                                                //     
	MOVW R22,R30
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x1E
	CALL SUBOPT_0x60
; 0000 041C                                             beg_info[t++]=255;                                                    //      " "
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 041D 
; 0000 041E                 if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) {str_sec=0;if (temp==255)  ochistka();  meny=10; z=0; z1=0;  t=0; temp1=0;}}
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x1DA
	CALL SUBOPT_0x62
	RCALL _beg_stroka
	CPI  R30,LOW(0xFF)
	BRNE _0x1DB
	LDI  R30,LOW(0)
	STS  _str_sec,R30
	LDS  R26,_temp
	CPI  R26,LOW(0xFF)
	BRNE _0x1DC
	CALL _ochistka
_0x1DC:
	LDI  R30,LOW(10)
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x5B
_0x1DB:
; 0000 041F                if (BUT_STEP) { ochistka();  z=0; z1=0;  t=0; temp1=0;   meny=30;}
_0x1DA:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1DD
	CALL SUBOPT_0x57
; 0000 0420                if (BUT_OK)   { ochistka();  z=0; z1=0;  t=0; temp1=0;   meny=10;}
_0x1DD:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1DE
	CALL SUBOPT_0x76
	LDI  R30,LOW(10)
	MOV  R6,R30
; 0000 0421         break;
_0x1DE:
	JMP  _0x183
; 0000 0422         case 20: //*********************************************************************
_0x1AC:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1DF
; 0000 0423         sek0=1;                                                                                 //   0   
	LDI  R30,LOW(1)
	STS  _sek0,R30
; 0000 0424         ekran [12]=0;  ekran [11]=128;
	LDI  R30,LOW(0)
	__PUTB1MN _ekran,12
	LDI  R30,LOW(128)
	__PUTB1MN _ekran,11
; 0000 0425         ekran_cifri(((time-(time/60*60))*60)+sek);
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
	ST   -Y,R31
	ST   -Y,R30
	CALL _ekran_cifri
; 0000 0426         sek0=0;                                                                                 //       
	LDI  R30,LOW(0)
	STS  _sek0,R30
; 0000 0427         if (BUT_STEP)  {if (sek>40) {time++; if (time==1440) time=0;}  sek=0; TCNT2=0;  temp=10; str_sec=0;}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1E0
	LDI  R30,LOW(40)
	CP   R30,R5
	BRSH _0x1E1
	LDI  R26,LOW(_time)
	LDI  R27,HIGH(_time)
	CALL SUBOPT_0x7
	CALL SUBOPT_0x1A
	CPI  R26,LOW(0x5A0)
	LDI  R30,HIGH(0x5A0)
	CPC  R27,R30
	BRNE _0x1E2
	LDI  R30,LOW(0)
	STS  _time,R30
	STS  _time+1,R30
_0x1E2:
_0x1E1:
	CLR  R5
	LDI  R30,LOW(0)
	OUT  0x24,R30
	LDI  R30,LOW(10)
	STS  _temp,R30
	LDI  R30,LOW(0)
	STS  _str_sec,R30
; 0000 0428         if (BUT_OK)    {  z=0; z1=0;  t=0; temp1=0;  data1=time;  ochistka();full_str=1; enable_date =1; temp2=0xFF;  meny=15; }     //   
_0x1E0:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1E3
	CALL SUBOPT_0x77
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x78
	CALL _ochistka
	SET
	BLD  R3,2
	BLD  R2,6
	LDI  R30,LOW(255)
	STS  _temp2,R30
	LDI  R30,LOW(15)
	MOV  R6,R30
; 0000 0429         break;
_0x1E3:
	JMP  _0x183
; 0000 042A 
; 0000 042B         //**************************** ***********************************
; 0000 042C         case 30: //     - ""
_0x1DF:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0x1E4
; 0000 042D             if (Interval>=speed)  {Interval=0; beg_stroka(budilnik_txt);}
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x1E5
	CALL SUBOPT_0x79
	LDI  R30,LOW(_budilnik_txt)
	LDI  R31,HIGH(_budilnik_txt)
	CALL SUBOPT_0x7A
; 0000 042E             if (BUT_STEP)         {  t=0; temp1=0; meny=40;z=0; z1=0;ochistka();}
_0x1E5:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1E6
	CALL SUBOPT_0x5B
	LDI  R30,LOW(40)
	CALL SUBOPT_0x5A
	CALL _ochistka
; 0000 042F             if (BUT_OK)           {ochistka(); bud=0; temp=0; meny=32;}
_0x1E6:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1E7
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _bud,R30
	STS  _temp,R30
	LDI  R30,LOW(32)
	MOV  R6,R30
; 0000 0430         break;
_0x1E7:
	JMP  _0x183
; 0000 0431         case 32: //    
_0x1E4:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x1E8
; 0000 0432             if (BUT_STEP) {meny=34;}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1E9
	LDI  R30,LOW(34)
	MOV  R6,R30
; 0000 0433             if (BUT_OK  ) {bud++; if (bud==9) bud=0;  }
_0x1E9:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1EA
	LDS  R30,_bud
	SUBI R30,-LOW(1)
	STS  _bud,R30
	LDS  R26,_bud
	CPI  R26,LOW(0x9)
	BRNE _0x1EB
	LDI  R30,LOW(0)
	STS  _bud,R30
_0x1EB:
; 0000 0434             ekran_1_figure(11,1,0); line=1; ekran_1_figure(bud+1,7,1); line=0; ekran_1_figure(((budilnik_Install[bud] & 0x80) ? (47):(46)),17,0);
_0x1EA:
	CALL SUBOPT_0x7B
	SET
	BLD  R3,5
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x7D
	CALL SUBOPT_0x7E
	BREQ _0x1EC
	LDI  R30,LOW(47)
	RJMP _0x1ED
_0x1EC:
	LDI  R30,LOW(46)
_0x1ED:
	ST   -Y,R30
	LDI  R30,LOW(17)
	CALL SUBOPT_0x7F
; 0000 0435         break;
	JMP  _0x183
; 0000 0436         case 34: //     .    -    ""
_0x1E8:
	CPI  R30,LOW(0x22)
	LDI  R26,HIGH(0x22)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x1EF
; 0000 0437             if (BUT_STEP)
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1F0
; 0000 0438                     {
; 0000 0439                     if (budilnik_Install[bud] & 0x80)    //    
	CALL SUBOPT_0x7E
	BREQ _0x1F1
; 0000 043A                         {
; 0000 043B                         budilnik_time[bud]= ystanovki_23_59 (budilnik_time[bud]);     //    
	LDS  R30,_bud
	CALL SUBOPT_0x46
	PUSH R31
	PUSH R30
	LDS  R30,_bud
	CALL SUBOPT_0x80
	CALL SUBOPT_0x81
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
; 0000 043C                             if (bud<3){budilnik_Install[bud] = 0xFF; ochistka(); z=0; z1=0;  t=0; temp1=0;meny=38; }        //   1-3   "  "  ,         
	LDS  R26,_bud
	CPI  R26,LOW(0x3)
	BRSH _0x1F2
	CALL SUBOPT_0x82
	LDI  R26,LOW(255)
	STD  Z+0,R26
	CALL SUBOPT_0x76
	LDI  R30,LOW(38)
	RJMP _0x30B
; 0000 043D                             else {temp=0;  meny=36;}                                  //   4-9          
_0x1F2:
	LDI  R30,LOW(0)
	STS  _temp,R30
	LDI  R30,LOW(36)
_0x30B:
	MOV  R6,R30
; 0000 043E                         }
; 0000 043F                     else { ochistka(); z=0; z1=0;  t=0; temp1=0; meny=10;}   ochistka();  break;                      //     -    ""
	RJMP _0x1F4
_0x1F1:
	CALL SUBOPT_0x76
	LDI  R30,LOW(10)
	MOV  R6,R30
_0x1F4:
	CALL _ochistka
	JMP  _0x183
; 0000 0440                     }
; 0000 0441             if (BUT_OK )  {budilnik_Install[bud] ^= 0x80;}                     //    /   (/  1 7)
_0x1F0:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1F5
	CALL SUBOPT_0x82
	MOVW R0,R30
	LD   R26,Z
	LDI  R30,LOW(128)
	EOR  R30,R26
	MOVW R26,R0
	ST   X,R30
; 0000 0442             ekran_1_figure(11,1,0); ekran_1_figure(bud+1,7,0); line=1; ekran_1_figure(((budilnik_Install[bud] & 0x80) ? (47):(46)),17,1); line=0;
_0x1F5:
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x7C
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _ekran_1_figure
	SET
	BLD  R3,5
	CALL SUBOPT_0x7E
	BREQ _0x1F6
	LDI  R30,LOW(47)
	RJMP _0x1F7
_0x1F6:
	LDI  R30,LOW(46)
_0x1F7:
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	CALL SUBOPT_0x7D
; 0000 0443         break;
	JMP  _0x183
; 0000 0444         case 36:  //        , .
_0x1EF:
	CPI  R30,LOW(0x24)
	LDI  R26,HIGH(0x24)
	CPC  R31,R26
	BRNE _0x1F9
; 0000 0445             ekran_1_figure (den_nedeli_letter[temp][0],0,0);  ekran_1_figure (den_nedeli_letter[temp][1],6,0);                 //    . ( "beg_info"    )
	CALL SUBOPT_0x83
	LPM  R30,Z
	CALL SUBOPT_0x84
	CALL SUBOPT_0x83
	ADIW R30,1
	LPM  R30,Z
	CALL SUBOPT_0x85
; 0000 0446             ekran_1_figure (((budilnik_Install[bud] & (1 << temp)) ? 47:46),17,1);                                             //   "+"  "-"    ./. .
	CALL SUBOPT_0x82
	LD   R1,Z
	LDS  R30,_temp
	CALL SUBOPT_0x86
	BREQ _0x1FA
	LDI  R30,LOW(47)
	RJMP _0x1FB
_0x1FA:
	LDI  R30,LOW(46)
_0x1FB:
	ST   -Y,R30
	LDI  R30,LOW(17)
	CALL SUBOPT_0x87
; 0000 0447 
; 0000 0448             if (BUT_STEP) {temp++;  ochistka(); z=0; z1=0;  t=0; temp1=0;                                                      // ""     
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x1FD
	CALL SUBOPT_0x49
	CALL SUBOPT_0x76
; 0000 0449                           if (temp==7){ ochistka(); z=0; z1=0;  t=0; temp1=0;meny=10; break;  }           //      ,     .
	LDS  R26,_temp
	CPI  R26,LOW(0x7)
	BRNE _0x1FE
	CALL SUBOPT_0x76
	LDI  R30,LOW(10)
	MOV  R6,R30
	JMP  _0x183
; 0000 044A                           }
_0x1FE:
; 0000 044B             if (BUT_OK){(budilnik_Install[bud]) ^= (1 << temp);}                                                               // /     .
_0x1FD:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x1FF
	CALL SUBOPT_0x82
	MOVW R22,R30
	LD   R1,Z
	LDS  R30,_temp
	LDI  R26,LOW(1)
	CALL __LSLB12
	EOR  R30,R1
	MOVW R26,R22
	ST   X,R30
; 0000 044C         break;
_0x1FF:
	JMP  _0x183
; 0000 044D          case 38: //*********************    *********************************//
_0x1F9:
	CPI  R30,LOW(0x26)
	LDI  R26,HIGH(0x26)
	CPC  R31,R26
	BRNE _0x200
; 0000 044E                if (Interval>=speed)  {Interval=0;  if ( beg_stroka( budilnik_raz_txt)==255) {ochistka(); z=0; z1=0;  t=0; temp1=0;meny=39; break;}} ;
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x201
	CALL SUBOPT_0x79
	LDI  R30,LOW(_budilnik_raz_txt)
	LDI  R31,HIGH(_budilnik_raz_txt)
	CALL SUBOPT_0x7A
	CPI  R30,LOW(0xFF)
	BRNE _0x202
	CALL SUBOPT_0x76
	LDI  R30,LOW(39)
	MOV  R6,R30
	JMP  _0x183
_0x202:
_0x201:
; 0000 044F 
; 0000 0450         break;
	JMP  _0x183
; 0000 0451         case 39:
_0x200:
	CPI  R30,LOW(0x27)
	LDI  R26,HIGH(0x27)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x203
; 0000 0452           if(budilnik_raz[bud]==0) budilnik_raz[bud]=1;
	CALL SUBOPT_0x88
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LD   R30,Z
	CPI  R30,0
	BRNE _0x204
	CALL SUBOPT_0x88
	CALL SUBOPT_0x48
; 0000 0453           if((budilnik_raz[bud]==2)||(budilnik_raz[bud]==3)||(budilnik_raz[bud]==4))
_0x204:
	CALL SUBOPT_0x88
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LD   R26,Z
	CPI  R26,LOW(0x2)
	BREQ _0x206
	CPI  R26,LOW(0x3)
	BREQ _0x206
	CPI  R26,LOW(0x4)
	BRNE _0x205
_0x206:
; 0000 0454                      {
; 0000 0455                        ekran_1_figure((( budilnik_raz[bud])),2,1);
	CALL SUBOPT_0x88
	CALL SUBOPT_0x89
; 0000 0456                        ekran_1_figure(26,8,0); ekran_1_figure(10,12,0); ekran_1_figure(16,16,0);ekran_1_figure(10,20,0);
	LDI  R30,LOW(26)
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x7F
	LDI  R30,LOW(10)
	CALL SUBOPT_0x8A
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL SUBOPT_0x7F
	LDI  R30,LOW(10)
	RJMP _0x30C
; 0000 0457                      }
; 0000 0458                   else     {
_0x205:
; 0000 0459                               ekran_1_figure((( budilnik_raz[bud])),2,1);
	CALL SUBOPT_0x88
	CALL SUBOPT_0x89
; 0000 045A                               ekran_1_figure(26,9,0); ekran_1_figure(10,15,0); ekran_1_figure(16,20,0);
	LDI  R30,LOW(26)
	CALL SUBOPT_0x8B
	LDI  R30,LOW(10)
	CALL SUBOPT_0x8C
	LDI  R30,LOW(16)
_0x30C:
	ST   -Y,R30
	LDI  R30,LOW(20)
	CALL SUBOPT_0x7F
; 0000 045B                            } ;
; 0000 045C                  if (BUT_STEP) { ochistka(); z=0; z1=0;  t=0; temp1=0;meny=10;break; }
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x209
	CALL SUBOPT_0x76
	LDI  R30,LOW(10)
	MOV  R6,R30
	RJMP _0x183
; 0000 045D                  if (BUT_OK)   {  ochistka();budilnik_raz[bud]+=1;  if( budilnik_raz[bud]>9) budilnik_raz[bud]=1;};
_0x209:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x20A
	CALL _ochistka
	LDS  R26,_bud
	CALL SUBOPT_0x8D
	SUBI R30,-LOW(1)
	ST   X,R30
	CALL SUBOPT_0x88
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LD   R26,Z
	CPI  R26,LOW(0xA)
	BRLO _0x20B
	CALL SUBOPT_0x88
	CALL SUBOPT_0x48
_0x20B:
_0x20A:
; 0000 045E         break;
	RJMP _0x183
; 0000 045F 
; 0000 0460          case 40: //*********************   ****************************
_0x203:
	CPI  R30,LOW(0x28)
	LDI  R26,HIGH(0x28)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x20C
; 0000 0461 
; 0000 0462                 if (Interval>=speed)  {Interval=0; beg_stroka(nastroiki_txt);}
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x20D
	CALL SUBOPT_0x79
	LDI  R30,LOW(_nastroiki_txt)
	LDI  R31,HIGH(_nastroiki_txt)
	CALL SUBOPT_0x7A
; 0000 0463                 if (BUT_STEP) {meny=50; z=0; z1=0; ochistka();}
_0x20D:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x20E
	LDI  R30,LOW(50)
	CALL SUBOPT_0x5A
	CALL _ochistka
; 0000 0464                 if (BUT_OK)
_0x20E:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x20F
; 0000 0465                         {
; 0000 0466                         time   =ystanovki_23_59(time);
	CALL SUBOPT_0x50
	CALL SUBOPT_0x81
	STS  _time,R30
	STS  _time+1,R31
; 0000 0467                         ochistka();
	CALL _ochistka
; 0000 0468                         ekran_1_figure(33,1,1);          ekran_1_figure(43,6,1);
	LDI  R30,LOW(33)
	CALL SUBOPT_0x8E
	CALL SUBOPT_0x3A
; 0000 0469                         chislo =ystanovki_2 (chislo,31, 13);
	ST   -Y,R8
	LDI  R30,LOW(31)
	CALL SUBOPT_0x3C
	MOV  R8,R30
; 0000 046A                         ekran_1_figure(22,1,1);          ekran_1_figure(43,7,1);
	LDI  R30,LOW(22)
	CALL SUBOPT_0x8E
	ST   -Y,R30
	LDI  R30,LOW(7)
	CALL SUBOPT_0x87
; 0000 046B                         mesec  =ystanovki_2 (mesec, 12, 13);
	ST   -Y,R7
	LDI  R30,LOW(12)
	CALL SUBOPT_0x3C
	MOV  R7,R30
; 0000 046C                         ekran_1_figure(13,1,1);          ekran_1_figure(43,5,1);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x8E
	ST   -Y,R30
	LDI  R30,LOW(5)
	CALL SUBOPT_0x87
; 0000 046D                         god    =ystanovki_2 (god,   99, 13);
	ST   -Y,R10
	LDI  R30,LOW(99)
	CALL SUBOPT_0x3C
	MOV  R10,R30
; 0000 046E                         button=0;ochistka(); temp=0 ;meny=10;data1=time;
	CLR  R14
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _temp,R30
	LDI  R30,LOW(10)
	MOV  R6,R30
	CALL SUBOPT_0x78
; 0000 046F                         }
; 0000 0470         break;
_0x20F:
	RJMP _0x183
; 0000 0471 
; 0000 0472         case 50: //    - ""
_0x20C:
	CPI  R30,LOW(0x32)
	LDI  R26,HIGH(0x32)
	CPC  R31,R26
	BRNE _0x210
; 0000 0473                if (Interval>=speed)  {Interval=0;   beg_stroka(nastr_stroki_txt);}
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x211
	CALL SUBOPT_0x79
	LDI  R30,LOW(_nastr_stroki_txt)
	LDI  R31,HIGH(_nastr_stroki_txt)
	CALL SUBOPT_0x7A
; 0000 0474                if (BUT_STEP) { z=0; z1=0; ochistka();meny=60;}
_0x211:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x212
	CALL SUBOPT_0x77
	CALL _ochistka
	LDI  R30,LOW(60)
	MOV  R6,R30
; 0000 0475                if (BUT_OK)   {z=0; z1=0;temp=0;meny=51; ochistka(); }
_0x212:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x213
	CALL SUBOPT_0x56
	LDI  R30,LOW(51)
	MOV  R6,R30
	CALL _ochistka
; 0000 0476         break;
_0x213:
	RJMP _0x183
; 0000 0477         case 51:
_0x210:
	CPI  R30,LOW(0x33)
	LDI  R26,HIGH(0x33)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x214
; 0000 0478                 if (BUT_STEP) {temp++;z=0; z1=0;  t=0; temp1=0; ochistka();}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x215
	CALL SUBOPT_0x49
	CALL SUBOPT_0x77
	CALL SUBOPT_0x5B
	CALL _ochistka
; 0000 0479                 switch (temp)
_0x215:
	CALL SUBOPT_0x47
; 0000 047A                         {
; 0000 047B                         case 0:  if (BUT_OK){str ^= (1 << 0);}      ekran_1_figure(14,0,0); ekran_1_figure(15,6,0); ekran_1_figure(23,10,0); ekran_1_figure(38,15,0);  ekran_1_figure (((str & 0x01) ? 47:46),19,1);            break;
	SBIW R30,0
	BRNE _0x219
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x21A
	CALL SUBOPT_0x55
	LDI  R26,LOW(1)
	CALL SUBOPT_0x8F
_0x21A:
	LDI  R30,LOW(14)
	CALL SUBOPT_0x84
	LDI  R30,LOW(15)
	CALL SUBOPT_0x85
	LDI  R30,LOW(23)
	CALL SUBOPT_0x90
	LDI  R30,LOW(38)
	CALL SUBOPT_0x8C
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x1)
	BREQ _0x21B
	LDI  R30,LOW(47)
	RJMP _0x21C
_0x21B:
	LDI  R30,LOW(46)
_0x21C:
	CALL SUBOPT_0x37
	RJMP _0x218
; 0000 047C                         case 1:  if (BUT_OK){str ^= (1 << 1);}      ekran_1_figure(14,0,0); ekran_1_figure(10,6,0); ekran_1_figure(28,10,0); ekran_1_figure(10,13,0);  ekran_1_figure (((str & 0x02) ? 47:46),19,1);            break;
_0x219:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x21E
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x21F
	CALL SUBOPT_0x55
	LDI  R26,LOW(2)
	CALL SUBOPT_0x8F
_0x21F:
	LDI  R30,LOW(14)
	CALL SUBOPT_0x84
	LDI  R30,LOW(10)
	CALL SUBOPT_0x85
	LDI  R30,LOW(28)
	CALL SUBOPT_0x90
	LDI  R30,LOW(10)
	ST   -Y,R30
	LDI  R30,LOW(13)
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x2)
	BREQ _0x220
	LDI  R30,LOW(47)
	RJMP _0x221
_0x220:
	LDI  R30,LOW(46)
_0x221:
	CALL SUBOPT_0x37
	RJMP _0x218
; 0000 047D                         case 2:  if (BUT_OK){str ^= (1 << 2);}      ekran_1_figure(13,0,0); ekran_1_figure(24,4,0); ekran_1_figure(14,9,0);   ekran_1_figure (((str & 0x04) ? 47:46),19,1);            break;
_0x21E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x223
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x224
	CALL SUBOPT_0x55
	LDI  R26,LOW(4)
	CALL SUBOPT_0x8F
_0x224:
	LDI  R30,LOW(13)
	CALL SUBOPT_0x84
	LDI  R30,LOW(24)
	CALL SUBOPT_0x91
	LDI  R30,LOW(14)
	CALL SUBOPT_0x8B
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x4)
	BREQ _0x225
	LDI  R30,LOW(47)
	RJMP _0x226
_0x225:
	LDI  R30,LOW(46)
_0x226:
	CALL SUBOPT_0x37
	RJMP _0x218
; 0000 047E                         case 3:  if (BUT_OK){if(sek_ind!=0){sek_ind=0;} else sek_ind=1;      }      ekran_1_figure (((sek_ind) ? 47:46),19,1);      ekran_1_figure(27,0,0); ekran_1_figure(15,5,0); ekran_1_figure(20,9,0); ekran_1_figure(43,15,0); break;
_0x223:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x228
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x229
	CALL SUBOPT_0x4F
	SBIW R30,0
	BREQ _0x22A
	LDI  R26,LOW(_sek_ind)
	LDI  R27,HIGH(_sek_ind)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x30D
_0x22A:
	LDI  R26,LOW(_sek_ind)
	LDI  R27,HIGH(_sek_ind)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x30D:
	CALL __EEPROMWRW
_0x229:
	CALL SUBOPT_0x4F
	SBIW R30,0
	BREQ _0x22C
	LDI  R30,LOW(47)
	RJMP _0x22D
_0x22C:
	LDI  R30,LOW(46)
_0x22D:
	CALL SUBOPT_0x37
	LDI  R30,LOW(27)
	CALL SUBOPT_0x84
	LDI  R30,LOW(15)
	CALL SUBOPT_0x92
	LDI  R30,LOW(20)
	CALL SUBOPT_0x8B
	LDI  R30,LOW(43)
	CALL SUBOPT_0x8C
	RJMP _0x218
; 0000 047F                         case 4:  if (BUT_OK){zv_chs++;       }      ekran_1_figure (((zv_chs) ? 47:46),19,1);       ekran_1_figure(16,0,0); ekran_1_figure(12,5,0); ekran_1_figure(43,9,0); ekran_1_figure(33,10,0); ekran_1_figure(27,14,0); break;
_0x228:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x22F
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x230
	LDI  R30,LOW(8)
	EOR  R3,R30
_0x230:
	SBRS R3,3
	RJMP _0x231
	LDI  R30,LOW(47)
	RJMP _0x232
_0x231:
	LDI  R30,LOW(46)
_0x232:
	CALL SUBOPT_0x37
	LDI  R30,LOW(16)
	CALL SUBOPT_0x84
	LDI  R30,LOW(12)
	CALL SUBOPT_0x92
	LDI  R30,LOW(43)
	CALL SUBOPT_0x8B
	LDI  R30,LOW(33)
	CALL SUBOPT_0x90
	LDI  R30,LOW(27)
	CALL SUBOPT_0x93
	RJMP _0x218
; 0000 0480                         case 5:  if (BUT_OK){zv_kn++;        }      ekran_1_figure (((zv_kn)  ? 47:46),19,1);       ekran_1_figure(16,0,0); ekran_1_figure(12,5,0); ekran_1_figure(43,9,0); ekran_1_figure(20,10,0); ekran_1_figure(23,14,0); break;
_0x22F:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x234
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x235
	LDI  R30,LOW(2)
	EOR  R3,R30
_0x235:
	SBRS R3,1
	RJMP _0x236
	LDI  R30,LOW(47)
	RJMP _0x237
_0x236:
	LDI  R30,LOW(46)
_0x237:
	CALL SUBOPT_0x37
	LDI  R30,LOW(16)
	CALL SUBOPT_0x84
	LDI  R30,LOW(12)
	CALL SUBOPT_0x92
	LDI  R30,LOW(43)
	CALL SUBOPT_0x8B
	LDI  R30,LOW(20)
	CALL SUBOPT_0x90
	LDI  R30,LOW(23)
	CALL SUBOPT_0x93
	RJMP _0x218
; 0000 0481                         case 6:  if (devices==2){if (Interval>=speed)  {Interval=0;   beg_stroka(perenazna_datchik);};if (BUT_OK){ochistka();meny=53;};} else {temp++;} break;
_0x234:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x239
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRNE _0x23A
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x23B
	CALL SUBOPT_0x79
	LDI  R30,LOW(_perenazna_datchik)
	LDI  R31,HIGH(_perenazna_datchik)
	CALL SUBOPT_0x7A
_0x23B:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x23C
	CALL _ochistka
	LDI  R30,LOW(53)
	MOV  R6,R30
_0x23C:
	RJMP _0x23D
_0x23A:
	CALL SUBOPT_0x49
_0x23D:
	RJMP _0x218
; 0000 0482                         case 7:  if (devices==1){ if (BUT_OK){str ^= (1 << 3); }     ekran_1_figure (((str & 0x08) ? 47:46),19,1);   ekran_1_figure(50,0,0); ekran_1_figure(48,4,0);break;}
_0x239:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x23E
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRNE _0x23F
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x240
	CALL SUBOPT_0x55
	LDI  R26,LOW(8)
	CALL SUBOPT_0x8F
_0x240:
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x8)
	BREQ _0x241
	LDI  R30,LOW(47)
	RJMP _0x242
_0x241:
	LDI  R30,LOW(46)
_0x242:
	CALL SUBOPT_0x37
	LDI  R30,LOW(50)
	CALL SUBOPT_0x84
	LDI  R30,LOW(48)
	CALL SUBOPT_0x91
	RJMP _0x218
; 0000 0483                         else    {if (devices>1){  if (BUT_OK){str ^= (1 << 3); }     ekran_1_figure (((str & 0x08) ? 47:46),19,1);   ekran_1_figure(50,0,0); ekran_1_figure(48,4,0); ekran_1_figure(14,10,0);} else {temp++;} break;}        //  
_0x23F:
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRLO _0x245
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x246
	CALL SUBOPT_0x55
	LDI  R26,LOW(8)
	CALL SUBOPT_0x8F
_0x246:
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x8)
	BREQ _0x247
	LDI  R30,LOW(47)
	RJMP _0x248
_0x247:
	LDI  R30,LOW(46)
_0x248:
	CALL SUBOPT_0x37
	LDI  R30,LOW(50)
	CALL SUBOPT_0x84
	LDI  R30,LOW(48)
	CALL SUBOPT_0x91
	LDI  R30,LOW(14)
	CALL SUBOPT_0x90
	RJMP _0x24A
_0x245:
	CALL SUBOPT_0x49
_0x24A:
	RJMP _0x218
; 0000 0484                         case 8:  if ((str & 0x08) && (devices>0))  { z=0; z1=0;meny=57;} else {temp++;}  break;
_0x23E:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x24C
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x8)
	BREQ _0x24E
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x1)
	BRSH _0x24F
_0x24E:
	RJMP _0x24D
_0x24F:
	CALL SUBOPT_0x77
	LDI  R30,LOW(57)
	MOV  R6,R30
	RJMP _0x250
_0x24D:
	CALL SUBOPT_0x49
_0x250:
	RJMP _0x218
; 0000 0485                         case 9:  if (devices>1){if (BUT_OK){str ^= (1 << 4);}      ekran_1_figure (((str & 0x10) ? 47:46),19,1);   ekran_1_figure(50,0,0); ekran_1_figure(48,4,0); ekran_1_figure(29,10,0);} else {temp++;}  break;       //   
_0x24C:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x251
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRLO _0x252
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x253
	CALL SUBOPT_0x55
	LDI  R26,LOW(16)
	CALL SUBOPT_0x8F
_0x253:
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x10)
	BREQ _0x254
	LDI  R30,LOW(47)
	RJMP _0x255
_0x254:
	LDI  R30,LOW(46)
_0x255:
	RCALL SUBOPT_0x37
	LDI  R30,LOW(50)
	CALL SUBOPT_0x84
	LDI  R30,LOW(48)
	CALL SUBOPT_0x91
	LDI  R30,LOW(29)
	CALL SUBOPT_0x90
	RJMP _0x257
_0x252:
	CALL SUBOPT_0x49
_0x257:
	RJMP _0x218
; 0000 0486                         case 10: if ((str & 0x10) && (devices>1))  {z=0; z1=0; meny=58;} else {temp++;}  break;
_0x251:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x258
	CALL SUBOPT_0x55
	ANDI R30,LOW(0x10)
	BREQ _0x25A
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRSH _0x25B
_0x25A:
	RJMP _0x259
_0x25B:
	CALL SUBOPT_0x77
	LDI  R30,LOW(58)
	MOV  R6,R30
	RJMP _0x25C
_0x259:
	CALL SUBOPT_0x49
_0x25C:
	RJMP _0x218
; 0000 0487                         case 11: if (BUT_OK){ochistka();z=0; z1=0;meny=48;break;}  ; ekran_1_figure(34,0,0); ekran_1_figure(26,6,0); ekran_1_figure(18,11,0); ekran_1_figure(30,16,0);ekran_1_figure(28,21,0); break;
_0x258:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x25D
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x25E
	CALL _ochistka
	CALL SUBOPT_0x77
	LDI  R30,LOW(48)
	MOV  R6,R30
	RJMP _0x218
_0x25E:
	LDI  R30,LOW(34)
	CALL SUBOPT_0x84
	LDI  R30,LOW(26)
	CALL SUBOPT_0x85
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(11)
	CALL SUBOPT_0x7F
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(16)
	CALL SUBOPT_0x7F
	LDI  R30,LOW(28)
	ST   -Y,R30
	LDI  R30,LOW(21)
	CALL SUBOPT_0x7F
	RJMP _0x218
; 0000 0488                         case 12: if (BUT_OK){ochistka();z=0; z1=0;temp=str_period;meny=46;break;}  ;  if (Interval>=speed)  {Interval=0; beg_stroka(interval_txt);} break;
_0x25D:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x25F
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x260
	CALL _ochistka
	CALL SUBOPT_0x77
	LDI  R26,LOW(_str_period)
	LDI  R27,HIGH(_str_period)
	CALL __EEPROMRDB
	STS  _temp,R30
	LDI  R30,LOW(46)
	MOV  R6,R30
	RJMP _0x218
_0x260:
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x261
	CALL SUBOPT_0x79
	LDI  R30,LOW(_interval_txt)
	LDI  R31,HIGH(_interval_txt)
	CALL SUBOPT_0x7A
_0x261:
	RJMP _0x218
; 0000 0489                         case 13: z=0; z1=0; meny=52; temp=speed; break;
_0x25F:
	CPI  R30,LOW(0xD)
	LDI  R26,HIGH(0xD)
	CPC  R31,R26
	BRNE _0x218
	CALL SUBOPT_0x77
	LDI  R30,LOW(52)
	MOV  R6,R30
	LDI  R26,LOW(_speed)
	LDI  R27,HIGH(_speed)
	CALL __EEPROMRDB
	STS  _temp,R30
; 0000 048A                         }
_0x218:
; 0000 048B         break;
	RJMP _0x183
; 0000 048C          case 46: //    
_0x214:
	CPI  R30,LOW(0x2E)
	LDI  R26,HIGH(0x2E)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x263
; 0000 048D             if (BUT_STEP)   {z=0; z1=0;if(str_period!=temp)str_period=temp; ochistka();temp=13; meny=51;break; }
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x264
	CALL SUBOPT_0x77
	RCALL SUBOPT_0x18
	MOVW R26,R30
	RCALL SUBOPT_0x47
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x265
	LDS  R30,_temp
	LDI  R26,LOW(_str_period)
	LDI  R27,HIGH(_str_period)
	CALL SUBOPT_0x94
_0x265:
	CALL _ochistka
	LDI  R30,LOW(13)
	CALL SUBOPT_0x95
	RJMP _0x183
; 0000 048E             if (BUT_OK)  { ochistka();temp++;  }
_0x264:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x266
	CALL _ochistka
	RCALL SUBOPT_0x49
; 0000 048F             if (temp>180)temp=5;
_0x266:
	LDS  R26,_temp
	CPI  R26,LOW(0xB5)
	BRLO _0x267
	LDI  R30,LOW(5)
	STS  _temp,R30
; 0000 0490             ekran_1_figure(temp/100,0,1); ekran_1_figure(((temp/10)%10),6,1);
_0x267:
	LDS  R26,_temp
	LDI  R27,0
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	RCALL SUBOPT_0x39
	LDS  R26,_temp
	RCALL SUBOPT_0x33
	CALL SUBOPT_0x71
	RCALL SUBOPT_0x3A
; 0000 0491              ekran_1_figure(temp%10,12,1); ekran_1_figure(27,19,0);
	LDS  R26,_temp
	RCALL SUBOPT_0x35
	ST   -Y,R30
	LDI  R30,LOW(12)
	CALL SUBOPT_0x87
	CALL SUBOPT_0x96
; 0000 0492          break;
	RJMP _0x183
; 0000 0493 
; 0000 0494 
; 0000 0495         case 48: //  
_0x263:
	CPI  R30,LOW(0x30)
	LDI  R26,HIGH(0x30)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x268
; 0000 0496             if (Interval>=speed)  {Interval=0; beg_stroka( font_zifr_txt);}
	RCALL SUBOPT_0x4B
	CALL SUBOPT_0x61
	BRLO _0x269
	CALL SUBOPT_0x79
	LDI  R30,LOW(_font_zifr_txt)
	LDI  R31,HIGH(_font_zifr_txt)
	CALL SUBOPT_0x7A
; 0000 0497             if (BUT_STEP)   {z=0; z1=0; ochistka();temp=12; if(font_epp!=font_)font_epp=font_; meny=51;break; }
_0x269:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x26A
	CALL SUBOPT_0x77
	CALL _ochistka
	LDI  R30,LOW(12)
	STS  _temp,R30
	LDI  R26,LOW(_font_epp)
	LDI  R27,HIGH(_font_epp)
	CALL __EEPROMRDW
	MOVW R26,R30
	LDS  R30,_font_
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x26B
	LDS  R30,_font_
	LDI  R26,LOW(_font_epp)
	LDI  R27,HIGH(_font_epp)
	CALL SUBOPT_0x94
_0x26B:
	LDI  R30,LOW(51)
	MOV  R6,R30
	RJMP _0x183
; 0000 0498             if (BUT_OK)  { ochistka();font_++;  if (font_>6) font_=0;
_0x26A:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x26C
	CALL _ochistka
	LDS  R30,_font_
	SUBI R30,-LOW(1)
	STS  _font_,R30
	LDS  R26,_font_
	CPI  R26,LOW(0x7)
	BRLO _0x26D
	LDI  R30,LOW(0)
	STS  _font_,R30
; 0000 0499                            font_cifri ();ekran_1_figure(font_,10,0); delay_ms(1000);z=0; z1=0;  t=0; temp1=0; ochistka();
_0x26D:
	CALL _font_cifri
	LDS  R30,_font_
	CALL SUBOPT_0x90
	CALL SUBOPT_0x63
	CALL _ochistka
; 0000 049A                              } break;
_0x26C:
	RJMP _0x183
; 0000 049B 
; 0000 049C         break;
; 0000 049D         case 52: //    
_0x268:
	CPI  R30,LOW(0x34)
	LDI  R26,HIGH(0x34)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x26E
; 0000 049E             if (Interval>=temp)  {Interval=0; beg_stroka(speed_txt);}
	LDS  R30,_temp
	LDS  R26,_Interval
	LDS  R27,_Interval+1
	LDI  R31,0
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x26F
	CALL SUBOPT_0x79
	LDI  R30,LOW(_speed_txt)
	LDI  R31,HIGH(_speed_txt)
	CALL SUBOPT_0x7A
; 0000 049F             if (BUT_OK)  {temp+=3;  if (temp>=57) {temp=18;} ochistka();ekran_1_figure((((60-temp)/3)/10),8,0); ekran_1_figure((((60-temp)/3)%10),14,0);delay_ms(1000);z=0; z1=0;  t=0; temp1=0; ochistka(); }
_0x26F:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x270
	LDS  R30,_temp
	SUBI R30,-LOW(3)
	STS  _temp,R30
	LDS  R26,_temp
	CPI  R26,LOW(0x39)
	BRLO _0x271
	LDI  R30,LOW(18)
	STS  _temp,R30
_0x271:
	CALL _ochistka
	RCALL SUBOPT_0x47
	CALL SUBOPT_0x97
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x7F
	RCALL SUBOPT_0x47
	CALL SUBOPT_0x97
	CALL SUBOPT_0x71
	CALL SUBOPT_0x93
	CALL SUBOPT_0x63
	CALL _ochistka
; 0000 04A0             if (BUT_STEP)   {if (speed!=temp)speed=temp; ochistka(); if(foto_r)meny=56; else meny=54;} //    ,     .
_0x270:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x272
	RCALL SUBOPT_0x4B
	MOVW R26,R30
	RCALL SUBOPT_0x47
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x273
	LDS  R30,_temp
	LDI  R26,LOW(_speed)
	LDI  R27,HIGH(_speed)
	CALL SUBOPT_0x94
_0x273:
	CALL _ochistka
	LDS  R30,_foto_r
	CPI  R30,0
	BREQ _0x274
	LDI  R30,LOW(56)
	RJMP _0x30E
_0x274:
	LDI  R30,LOW(54)
_0x30E:
	MOV  R6,R30
; 0000 04A1                                                                                                                         //   ,            .
; 0000 04A2         break;
_0x272:
	RJMP _0x183
; 0000 04A3         case 53: //    ds18m20 (  2 )
_0x26E:
	CPI  R30,LOW(0x35)
	LDI  R26,HIGH(0x35)
	CPC  R31,R26
	BRNE _0x276
; 0000 04A4 
; 0000 04A5             ekran_1_figure (14,0,0);
	LDI  R30,LOW(14)
	CALL SUBOPT_0x84
; 0000 04A6             ekran_1_figure (((temperature[temp5]<0) ? 51:47),8,1);
	CALL SUBOPT_0x98
	TST  R31
	BRPL _0x277
	LDI  R30,LOW(51)
	RJMP _0x278
_0x277:
	LDI  R30,LOW(47)
_0x278:
	ST   -Y,R30
	LDI  R30,LOW(8)
	CALL SUBOPT_0x87
; 0000 04A7             ekran_1_figure ((abs(temperature[temp5])/100),13,1);
	CALL SUBOPT_0x98
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x70
	RCALL SUBOPT_0x36
; 0000 04A8             ekran_1_figure (((abs(temperature[temp5])%100)/10),19,1);
	CALL SUBOPT_0x98
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x73
	RCALL SUBOPT_0x37
; 0000 04A9             if (BUT_OK)  {temp5++;}
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x27A
	LDI  R30,LOW(128)
	EOR  R3,R30
; 0000 04AA             if (BUT_STEP)   { ochistka();z=0; z1=0;  t=0; temp1=0;   if (temp5)  {ds1820_d=1; ds1820_y=0;}  else {ds1820_d=0; ds1820_y=1;} ;{ochistka(); temp=7; meny=51;}} ;
_0x27A:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x27B
	CALL SUBOPT_0x76
	SBRS R3,7
	RJMP _0x27C
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	RCALL SUBOPT_0x4E
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x30F
_0x27C:
	RCALL SUBOPT_0xE
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x30F:
	CALL __EEPROMWRW
	CALL _ochistka
	LDI  R30,LOW(7)
	CALL SUBOPT_0x95
_0x27B:
; 0000 04AB         break;
	RJMP _0x183
; 0000 04AC 
; 0000 04AD 
; 0000 04AE         case 57:  // __________________________    ________________________________________________________
_0x276:
	CPI  R30,LOW(0x39)
	LDI  R26,HIGH(0x39)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x27E
; 0000 04AF            t=0; temp1=0;
	RCALL SUBOPT_0x5B
; 0000 04B0                  beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;   beg_info[t++]=44;
	RCALL SUBOPT_0x64
	MOVW R22,R30
	RCALL SUBOPT_0x64
	MOVW R0,R30
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x60
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 04B1                  if (td10==0){
	RCALL SUBOPT_0x4C
	SBIW R30,0
	BRNE _0x27F
; 0000 04B2                                 beg_info[t++]=11; beg_info[t++]=15;
	RCALL SUBOPT_0x64
	LDI  R26,LOW(11)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	CALL SUBOPT_0x75
; 0000 04B3                                 beg_info[t++]=16; beg_info[t++]=42;
	LDI  R26,LOW(16)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
; 0000 04B4                                 beg_info[t++]=28; beg_info[t++]=24;   //  "T"
	CALL SUBOPT_0x99
	RCALL SUBOPT_0x6C
; 0000 04B5                                 beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	CALL SUBOPT_0x9A
	CALL SUBOPT_0x9B
; 0000 04B6                                 beg_info[t++]=18;                     //  ""
	LDI  R26,LOW(18)
	RJMP _0x310
; 0000 04B7                              }
; 0000 04B8 
; 0000 04B9             else {
_0x27F:
; 0000 04BA                       beg_info[t++]=27;                     //       ""
	RCALL SUBOPT_0x64
	LDI  R26,LOW(27)
	STD  Z+0,R26
; 0000 04BB                       beg_info[t++]=42;
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
; 0000 04BC                       beg_info[t++]=28; beg_info[t++]=24;   //  "T"
	CALL SUBOPT_0x99
	RCALL SUBOPT_0x6C
; 0000 04BD                       beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	CALL SUBOPT_0x9A
	CALL SUBOPT_0x9B
; 0000 04BE                       beg_info[t++]=24;  beg_info[t++]=19;   //  ""
	RCALL SUBOPT_0x6C
	LDI  R26,LOW(19)
_0x310:
	STD  Z+0,R26
; 0000 04BF                   }
; 0000 04C0                  beg_info[t++]=42;  beg_info[t++]=50;   //  " t"
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
	LDI  R26,LOW(50)
	STD  Z+0,R26
; 0000 04C1                  beg_info[t++]=42;
	RCALL SUBOPT_0x64
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 04C2                 if (devices>1) {   beg_info[t++]=14;  beg_info[t++]=24;   //  ""
	LDS  R26,_devices_G000
	CPI  R26,LOW(0x2)
	BRLO _0x281
	RCALL SUBOPT_0x64
	LDI  R26,LOW(14)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6C
; 0000 04C3                                     beg_info[t++]=22;  beg_info[t++]=10;   //  ""
	LDI  R26,LOW(22)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6D
; 0000 04C4                                     beg_info[t++]=42;
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 04C5                                  }
; 0000 04C6          if (td10==0){
_0x281:
	RCALL SUBOPT_0x4C
	SBIW R30,0
	BRNE _0x282
; 0000 04C7                         if (temperature[ds1820_d]!=0){
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	SBIW R30,0
	BREQ _0x283
; 0000 04C8                          if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	TST  R31
	BRPL _0x284
	RCALL SUBOPT_0x64
	LDI  R26,LOW(51)
	RJMP _0x311
_0x284:
	RCALL SUBOPT_0x64
	LDI  R26,LOW(47)
_0x311:
	STD  Z+0,R26
; 0000 04C9                               };
_0x283:
; 0000 04CA                         if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x286
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x70
	POP  R26
	POP  R27
	ST   X,R30
; 0000 04CB                         if (abs(temperature[ds1820_d]%10)>=5) {if (temperature[ds1820_d]<0){temperature[ds1820_d]-=1;}else{temperature[ds1820_d]+=1;}}  //  1          0.5 C
_0x286:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x6F
	SBIW R30,5
	BRLT _0x287
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	TST  R31
	BRPL _0x288
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x72
	SBIW R30,1
	RJMP _0x312
_0x288:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x72
	ADIW R30,1
_0x312:
	ST   -X,R31
	ST   -X,R30
; 0000 04CC                         beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                   //  " "
_0x287:
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	POP  R26
	POP  R27
	RJMP _0x313
; 0000 04CD                         beg_info[t++]=48;                                                    //  
; 0000 04CE                         beg_info[t]=255;
; 0000 04CF                      }
; 0000 04D0           else {
_0x282:
; 0000 04D1                         if (temperature[ds1820_d]!=0){
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	SBIW R30,0
	BREQ _0x28B
; 0000 04D2                         if (temperature[ds1820_d]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	TST  R31
	BRPL _0x28C
	RCALL SUBOPT_0x64
	LDI  R26,LOW(51)
	RJMP _0x314
_0x28C:
	RCALL SUBOPT_0x64
	LDI  R26,LOW(47)
_0x314:
	STD  Z+0,R26
; 0000 04D3                                                      };
_0x28B:
; 0000 04D4                         if (abs(temperature[ds1820_d])>99) {beg_info[t++]=(abs(temperature[ds1820_d])/100);}//   >10,   ""  
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x28E
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x70
	POP  R26
	POP  R27
	ST   X,R30
; 0000 04D5                         beg_info[t++]=(abs(temperature[ds1820_d])%100)/10;                                  //  " "
_0x28E:
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	POP  R26
	POP  R27
	ST   X,R30
; 0000 04D6                         beg_info[t++]=43;                                                                   //  
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x74
; 0000 04D7                         beg_info[t++]=abs(temperature[ds1820_d])%10;                                        //   .
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x71
	POP  R26
	POP  R27
_0x313:
	ST   X,R30
; 0000 04D8                         beg_info[t++]=48;
	RCALL SUBOPT_0x64
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 04D9                         beg_info[t]=255;
	RCALL SUBOPT_0x5C
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 04DA                }
; 0000 04DB            if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) ;}
	RCALL SUBOPT_0x4B
	RCALL SUBOPT_0x61
	BRLO _0x28F
	RCALL SUBOPT_0x62
	CALL _beg_stroka
; 0000 04DC 
; 0000 04DD          if (BUT_OK) { ochistka(); z=0; z1=0;temp=0; if (td10==0){td10=1;}
_0x28F:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x291
	CALL _ochistka
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x4C
	SBIW R30,0
	BRNE _0x292
	LDI  R26,LOW(_td10)
	LDI  R27,HIGH(_td10)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x315
; 0000 04DE                              else  td10=0;
_0x292:
	LDI  R26,LOW(_td10)
	LDI  R27,HIGH(_td10)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x315:
	CALL __EEPROMWRW
; 0000 04DF                              meny=57;
	LDI  R30,LOW(57)
	MOV  R6,R30
; 0000 04E0                      }
; 0000 04E1          if (BUT_STEP) {ochistka(); temp=9; meny=51;}                                     //         .
_0x291:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x294
	CALL _ochistka
	LDI  R30,LOW(9)
	CALL SUBOPT_0x95
; 0000 04E2 
; 0000 04E3         break;
_0x294:
	RJMP _0x183
; 0000 04E4          case 58:  // __________________________    ________________________________________________________
_0x27E:
	CPI  R30,LOW(0x3A)
	LDI  R26,HIGH(0x3A)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x295
; 0000 04E5            t=0; temp1=0;
	RCALL SUBOPT_0x5B
; 0000 04E6 
; 0000 04E7 
; 0000 04E8                  beg_info[t++] = beg_info[t++] = beg_info[t++] = 42;   beg_info[t++]=44;
	RCALL SUBOPT_0x64
	MOVW R22,R30
	RCALL SUBOPT_0x64
	MOVW R0,R30
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x66
	RCALL SUBOPT_0x60
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 04E9                  if (tu10==0){
	RCALL SUBOPT_0x4D
	SBIW R30,0
	BRNE _0x296
; 0000 04EA                                 beg_info[t++]=11; beg_info[t++]=15;
	RCALL SUBOPT_0x64
	LDI  R26,LOW(11)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x75
; 0000 04EB                                 beg_info[t++]=16; beg_info[t++]=42;
	LDI  R26,LOW(16)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
; 0000 04EC                                 beg_info[t++]=28; beg_info[t++]=24;    //  "T"
	CALL SUBOPT_0x99
	RCALL SUBOPT_0x6C
; 0000 04ED                                 beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	CALL SUBOPT_0x9A
	CALL SUBOPT_0x9B
; 0000 04EE                                 beg_info[t++]=18;                      //  ""
	LDI  R26,LOW(18)
	RJMP _0x316
; 0000 04EF                              }
; 0000 04F0 
; 0000 04F1             else {
_0x296:
; 0000 04F2                       beg_info[t++]=27;                     //       ""
	RCALL SUBOPT_0x64
	LDI  R26,LOW(27)
	STD  Z+0,R26
; 0000 04F3                       beg_info[t++]=42;
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
; 0000 04F4                       beg_info[t++]=28; beg_info[t++]=24;   //  "T"
	RCALL SUBOPT_0x99
	RCALL SUBOPT_0x6C
; 0000 04F5                       beg_info[t++]=33;  beg_info[t++]=20;   //  ""
	RCALL SUBOPT_0x9A
	RCALL SUBOPT_0x9B
; 0000 04F6                       beg_info[t++]=24;  beg_info[t++]=19;   //  ""
	RCALL SUBOPT_0x6C
	LDI  R26,LOW(19)
_0x316:
	STD  Z+0,R26
; 0000 04F7                   }
; 0000 04F8 
; 0000 04F9                  beg_info[t++] = 42; beg_info[t++]=50;   //  " t"
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
	LDI  R26,LOW(50)
	STD  Z+0,R26
; 0000 04FA                  beg_info[t++] = 42;
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6B
; 0000 04FB                  beg_info[t++]=23;  beg_info[t++]=10;                                                        //   ""
	LDI  R26,LOW(23)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x6D
; 0000 04FC                  beg_info[t++]=42;                                                                           // 
	RCALL SUBOPT_0x6B
; 0000 04FD                  beg_info[t++]=29;  beg_info[t++]=21;                                                        //   ""
	LDI  R26,LOW(29)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	LDI  R26,LOW(21)
	STD  Z+0,R26
; 0000 04FE                  beg_info[t++]=18;  beg_info[t++]=32;  beg_info[t++]=15;                                     //   ""
	RCALL SUBOPT_0x64
	LDI  R26,LOW(18)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	LDI  R26,LOW(32)
	STD  Z+0,R26
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x75
; 0000 04FF                  beg_info[t++]=42;
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 0500          if (tu10==0){
	RCALL SUBOPT_0x4D
	SBIW R30,0
	BRNE _0x298
; 0000 0501                         if (temperature[ds1820_y]!=0){
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	SBIW R30,0
	BREQ _0x299
; 0000 0502                         if (temperature[ds1820_y]<0) beg_info[t++]=51;  else beg_info[t++]=47;               //     -   ,    -  
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	TST  R31
	BRPL _0x29A
	RCALL SUBOPT_0x64
	LDI  R26,LOW(51)
	RJMP _0x317
_0x29A:
	RCALL SUBOPT_0x64
	LDI  R26,LOW(47)
_0x317:
	STD  Z+0,R26
; 0000 0503                                                        };
_0x299:
; 0000 0504                         if (abs(temperature[ds1820_y])>99) {beg_info[t++]=(abs(temperature[ds1820_y])/100);} //   >10,   ""  
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x29C
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x70
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0505                         if (abs(temperature[ds1820_y]%10)>=5) {if (temperature[ds1820_y]<0){temperature[ds1820_y]-=1;}else{temperature[ds1820_y]+=1;}}                    //  1          0.5 C
_0x29C:
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x6F
	SBIW R30,5
	BRLT _0x29D
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	TST  R31
	BRPL _0x29E
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x72
	SBIW R30,1
	RJMP _0x318
_0x29E:
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x72
	ADIW R30,1
_0x318:
	ST   -X,R31
	ST   -X,R30
; 0000 0506                         beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                   //  " "
_0x29D:
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	POP  R26
	POP  R27
	RJMP _0x319
; 0000 0507                         beg_info[t++]=48;                                                                    //  
; 0000 0508                         beg_info[t]=255;
; 0000 0509                      }
; 0000 050A           else {
_0x298:
; 0000 050B                          if (temperature[ds1820_y]!=0){
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	SBIW R30,0
	BREQ _0x2A1
; 0000 050C                          if (temperature[ds1820_y]<0) beg_info[t++]=51;  else beg_info[t++]=47;             //     -   ,    -  
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	TST  R31
	BRPL _0x2A2
	RCALL SUBOPT_0x64
	LDI  R26,LOW(51)
	RJMP _0x31A
_0x2A2:
	RCALL SUBOPT_0x64
	LDI  R26,LOW(47)
_0x31A:
	STD  Z+0,R26
; 0000 050D                                                        };
_0x2A1:
; 0000 050E                         if (abs(temperature[ds1820_y])>99) {beg_info[t++]=(abs(temperature[ds1820_y])/100);} //   >10,   ""  
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x2A4
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x70
	POP  R26
	POP  R27
	ST   X,R30
; 0000 050F 
; 0000 0510                         beg_info[t++]=(abs(temperature[ds1820_y])%100)/10;                                   //  " "
_0x2A4:
	RCALL SUBOPT_0x64
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0511                         beg_info[t++]=43;                                                                    //  
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x74
; 0000 0512                         beg_info[t++]=abs(temperature[ds1820_y])%10;                                         //   .
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x71
	POP  R26
	POP  R27
_0x319:
	ST   X,R30
; 0000 0513                         beg_info[t++]=48;
	RCALL SUBOPT_0x64
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 0514                         beg_info[t]=255;
	RCALL SUBOPT_0x5C
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	LDI  R26,LOW(255)
	STD  Z+0,R26
; 0000 0515                }
; 0000 0516            if (Interval >= speed)  {Interval=0; if (beg_stroka(beg_info)==255) ;}
	RCALL SUBOPT_0x4B
	RCALL SUBOPT_0x61
	BRLO _0x2A5
	RCALL SUBOPT_0x62
	CALL _beg_stroka
; 0000 0517 
; 0000 0518          if (BUT_OK) { ochistka();z=0; z1=0;temp=0;if (tu10==0){tu10=1;}
_0x2A5:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x2A7
	CALL _ochistka
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x4D
	SBIW R30,0
	BRNE _0x2A8
	LDI  R26,LOW(_tu10)
	LDI  R27,HIGH(_tu10)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x31B
; 0000 0519                              else  tu10=0;
_0x2A8:
	LDI  R26,LOW(_tu10)
	LDI  R27,HIGH(_tu10)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x31B:
	CALL __EEPROMWRW
; 0000 051A                              meny=58;
	LDI  R30,LOW(58)
	MOV  R6,R30
; 0000 051B                      }
; 0000 051C               if (BUT_STEP) {ochistka(); temp=11; meny=51;}
_0x2A7:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2AA
	CALL _ochistka
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x95
; 0000 051D 
; 0000 051E         break;
_0x2AA:
	RJMP _0x183
; 0000 051F         case 54: //        ()
_0x295:
	CPI  R30,LOW(0x36)
	LDI  R26,HIGH(0x36)
	CPC  R31,R26
	BRNE _0x2AB
; 0000 0520             TIMSK&=0x7F;         //   ""  .  (  ,    ""   )
	IN   R30,0x39
	ANDI R30,0x7F
	OUT  0x39,R30
; 0000 0521             brigh_down_time=ystanovki_23_59(brigh_down_time); //     
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x81
	LDI  R26,LOW(_brigh_down_time)
	LDI  R27,HIGH(_brigh_down_time)
	CALL __EEPROMWRW
; 0000 0522             ochistka();
	CALL _ochistka
; 0000 0523             brigh_up_time=ystanovki_23_59(brigh_up_time);     //     
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x81
	LDI  R26,LOW(_brigh_up_time)
	LDI  R27,HIGH(_brigh_up_time)
	CALL __EEPROMWRW
; 0000 0524             ochistka();
	CALL _ochistka
; 0000 0525             meny=55;
	LDI  R30,LOW(55)
	MOV  R6,R30
; 0000 0526         break;
	RJMP _0x183
; 0000 0527         case 55: //    
_0x2AB:
	CPI  R30,LOW(0x37)
	LDI  R26,HIGH(0x37)
	CPC  R31,R26
	BRNE _0x2AC
; 0000 0528             ekran_1_figure(41,0,0);
	LDI  R30,LOW(41)
	RCALL SUBOPT_0x84
; 0000 0529             ekran_1_figure(26,5,0);
	LDI  R30,LOW(26)
	RCALL SUBOPT_0x92
; 0000 052A             ekran_1_figure(20,10,0);
	LDI  R30,LOW(20)
	RCALL SUBOPT_0x90
; 0000 052B             ekran_1_figure(brigh_up,18,1);
	RCALL SUBOPT_0x4A
	ST   -Y,R30
	LDI  R30,LOW(18)
	RCALL SUBOPT_0x87
; 0000 052C             TIMSK|=0x02;                //    (    0)
	IN   R30,0x39
	ORI  R30,2
	OUT  0x39,R30
; 0000 052D             OCR0=(brigh_up)*23+5;       //         brigh_up
	RCALL SUBOPT_0x4A
	LDI  R26,LOW(23)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(5)
	OUT  0x3C,R30
; 0000 052E             if (BUT_OK)  {brigh_up++; if(brigh_up==10) brigh_up=0;} //
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x2AD
	RCALL SUBOPT_0x4A
	SUBI R30,-LOW(1)
	CALL __EEPROMWRB
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x4A
	CPI  R30,LOW(0xA)
	BRNE _0x2AE
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	LDI  R30,LOW(0)
	CALL __EEPROMWRB
_0x2AE:
; 0000 052F             if (BUT_STEP)   {  TIMSK|=0x80; ochistka();z=0; z1=0;  t=0; temp1=0;   data1=time; meny=10;}   //
_0x2AD:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2AF
	IN   R30,0x39
	ORI  R30,0x80
	OUT  0x39,R30
	RCALL SUBOPT_0x76
	RCALL SUBOPT_0x78
	LDI  R30,LOW(10)
	MOV  R6,R30
; 0000 0530         break;
_0x2AF:
	RJMP _0x183
; 0000 0531         case 56: //  
_0x2AC:
	CPI  R30,LOW(0x38)
	LDI  R26,HIGH(0x38)
	CPC  R31,R26
	BRNE _0x2B0
; 0000 0532             ekran_1_figure(ADCH/100,3,0);
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x70
	ST   -Y,R30
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x7F
; 0000 0533             ekran_1_figure((ADCH/10)%10,9,0);
	RCALL SUBOPT_0x11
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x8B
; 0000 0534             ekran_1_figure(ADCH%10,15,0);
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x8C
; 0000 0535          //   if (BUT_OK)  {brigh_up=ADCH;}  //         brigh_up
; 0000 0536             if (BUT_STEP)   {ochistka(); z=0; z1=0;  t=0; temp1=0;temp=0;data1=time;meny=10;}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2B1
	RCALL SUBOPT_0x76
	LDI  R30,LOW(0)
	STS  _temp,R30
	RCALL SUBOPT_0x78
	LDI  R30,LOW(10)
	MOV  R6,R30
; 0000 0537         break;
_0x2B1:
	RJMP _0x183
; 0000 0538         //**************************  *******************************
; 0000 0539         case 60: //    - ""
_0x2B0:
	CPI  R30,LOW(0x3C)
	LDI  R26,HIGH(0x3C)
	CPC  R31,R26
	BRNE _0x2B2
; 0000 053A             if (Interval>=speed)  {Interval=0;   beg_stroka(korekt_txt);}
	RCALL SUBOPT_0x4B
	RCALL SUBOPT_0x61
	BRLO _0x2B3
	RCALL SUBOPT_0x79
	LDI  R30,LOW(_korekt_txt)
	LDI  R31,HIGH(_korekt_txt)
	RCALL SUBOPT_0x7A
; 0000 053B             if (BUT_STEP) {ochistka(); z=0; z1=0;  t=0; temp1=0;temp=0; data1=time;meny=10;str_sec=0;break; }
_0x2B3:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2B4
	RCALL SUBOPT_0x76
	LDI  R30,LOW(0)
	STS  _temp,R30
	RCALL SUBOPT_0x78
	LDI  R30,LOW(10)
	MOV  R6,R30
	LDI  R30,LOW(0)
	STS  _str_sec,R30
	RJMP _0x183
; 0000 053C             if (BUT_OK)   {ochistka();meny=61;}
_0x2B4:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x2B5
	CALL _ochistka
	LDI  R30,LOW(61)
	MOV  R6,R30
; 0000 053D         break;
_0x2B5:
	RJMP _0x183
; 0000 053E         case 61: //  "" 
_0x2B2:
	CPI  R30,LOW(0x3D)
	LDI  R26,HIGH(0x3D)
	CPC  R31,R26
	BRNE _0x2B6
; 0000 053F              if (korr_den==0){ochistka();meny=62;}
	RCALL SUBOPT_0x9C
	SBIW R30,0
	BRNE _0x2B7
	CALL _ochistka
	LDI  R30,LOW(62)
	MOV  R6,R30
; 0000 0540             if (BUT_STEP) {meny=62;}
_0x2B7:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2B8
	LDI  R30,LOW(62)
	MOV  R6,R30
; 0000 0541             if (BUT_OK)   {korr_den = (korr_den * (-1));}
_0x2B8:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x2B9
	RCALL SUBOPT_0x9C
	LDI  R26,LOW(65535)
	LDI  R27,HIGH(65535)
	CALL __MULW12
	RCALL SUBOPT_0x9D
; 0000 0542               ekran [11]=192;line=1; ekran_1_figure(((korr_den<0)?46:47),0,1);
_0x2B9:
	LDI  R30,LOW(192)
	__PUTB1MN _ekran,11
	SET
	BLD  R3,5
	RCALL SUBOPT_0x3
	BRPL _0x2BA
	LDI  R30,LOW(46)
	RJMP _0x2BB
_0x2BA:
	LDI  R30,LOW(47)
_0x2BB:
	RCALL SUBOPT_0x39
; 0000 0543             line=0;/* ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,0);
	CLT
	BLD  R3,5
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x85
; 0000 0544              ekran_1_figure((abs(korr_den)%10),12,0);ekran_1_figure(27,19,0);   //   
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x8A
	RCALL SUBOPT_0x96
; 0000 0545         break;
	RJMP _0x183
; 0000 0546         case 62: //   
_0x2B6:
	CPI  R30,LOW(0x3E)
	LDI  R26,HIGH(0x3E)
	CPC  R31,R26
	BRNE _0x2BD
; 0000 0547             if (BUT_STEP) {meny=63;}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2BE
	LDI  R30,LOW(63)
	MOV  R6,R30
; 0000 0548             if (BUT_OK)   {korr_den=((korr_den<0)?(korr_den-=10):(korr_den+=10));if(abs(korr_den)>99){korr_den=korr_den%10;}}
_0x2BE:
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x2BF
	RCALL SUBOPT_0x3
	BRPL _0x2C0
	RCALL SUBOPT_0x9C
	SBIW R30,10
	RJMP _0x31C
_0x2C0:
	RCALL SUBOPT_0x9C
	ADIW R30,10
_0x31C:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMWRW
	RCALL SUBOPT_0x9D
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRLT _0x2C3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x9E
	RCALL SUBOPT_0x9D
_0x2C3:
; 0000 0549             ekran [11]=192; if (korr_den!=0){ ekran_1_figure(((korr_den<0)?46:47),0,0);} else ekran_1_figure(45,0,0);
_0x2BF:
	LDI  R30,LOW(192)
	__PUTB1MN _ekran,11
	RCALL SUBOPT_0x9C
	SBIW R30,0
	BREQ _0x2C4
	RCALL SUBOPT_0x3
	BRPL _0x2C5
	LDI  R30,LOW(46)
	RJMP _0x2C6
_0x2C5:
	LDI  R30,LOW(47)
_0x2C6:
	RJMP _0x31D
_0x2C4:
	LDI  R30,LOW(45)
_0x31D:
	ST   -Y,R30
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x7F
; 0000 054A             line=1; /*ekran_1_figure((abs((korr_den))/100),6);*/ ekran_1_figure(((abs(korr_den)%100)/10),6,1);
	SET
	BLD  R3,5
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x3A
; 0000 054B             line=0; ekran_1_figure((abs(korr_den)%10),12,0);ekran_1_figure(27,19,0);
	CLT
	BLD  R3,5
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x8A
	RCALL SUBOPT_0x96
; 0000 054C         break;
	RJMP _0x183
; 0000 054D         case 63: //     
_0x2BD:
	CPI  R30,LOW(0x3F)
	LDI  R26,HIGH(0x3F)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x183
; 0000 054E 
; 0000 054F             if (BUT_OK)   {if(korr_den<0){korr_den--;if(korr_den%10==0)korr_den+=10;}else{korr_den++;if(korr_den%10==0)korr_den-=10;}}
	LDI  R30,LOW(1)
	CP   R30,R14
	BRNE _0x2CA
	RCALL SUBOPT_0x3
	BRPL _0x2CB
	RCALL SUBOPT_0x9C
	SBIW R30,1
	CALL __EEPROMWRW
	ADIW R30,1
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x9E
	SBIW R30,0
	BRNE _0x2CC
	RCALL SUBOPT_0x9C
	ADIW R30,10
	RCALL SUBOPT_0x9D
_0x2CC:
	RJMP _0x2CD
_0x2CB:
	RCALL SUBOPT_0x9C
	ADIW R30,1
	CALL __EEPROMWRW
	SBIW R30,1
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x9E
	SBIW R30,0
	BRNE _0x2CE
	RCALL SUBOPT_0x9C
	SBIW R30,10
	RCALL SUBOPT_0x9D
_0x2CE:
_0x2CD:
; 0000 0550              ekran [11]=192;if (korr_den!=0){ ekran_1_figure(((korr_den<0)?46:47),0,0);} else ekran_1_figure(45,0,0);  ekran_1_figure(((abs(korr_den)%100)/10),6,0);
_0x2CA:
	LDI  R30,LOW(192)
	__PUTB1MN _ekran,11
	RCALL SUBOPT_0x9C
	SBIW R30,0
	BREQ _0x2CF
	RCALL SUBOPT_0x3
	BRPL _0x2D0
	LDI  R30,LOW(46)
	RJMP _0x2D1
_0x2D0:
	LDI  R30,LOW(47)
_0x2D1:
	RJMP _0x31E
_0x2CF:
	LDI  R30,LOW(45)
_0x31E:
	ST   -Y,R30
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0x85
; 0000 0551             line=1; ekran_1_figure((abs(korr_den)%10),12,1);ekran_1_figure(27,19,0);   line=0;
	SET
	BLD  R3,5
	RCALL SUBOPT_0x9C
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x71
	ST   -Y,R30
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x87
	RCALL SUBOPT_0x96
	CLT
	BLD  R3,5
; 0000 0552               if (BUT_STEP) { z=0; z1=0;  t=0; temp1=0;ochistka(); data1=time; meny=10; break;}
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x2D4
	RCALL SUBOPT_0x77
	RCALL SUBOPT_0x5B
	CALL _ochistka
	RCALL SUBOPT_0x78
	LDI  R30,LOW(10)
	MOV  R6,R30
; 0000 0553         break;
_0x2D4:
; 0000 0554         }
_0x183:
; 0000 0555 
; 0000 0556 //****************************************************   *******************************************
; 0000 0557 if (flg_min)
	SBRS R2,2
	RJMP _0x2D5
; 0000 0558 {
; 0000 0559 
; 0000 055A         //_____________________ 
; 0000 055B         for (bud_temp=0; bud_temp<9; bud_temp++)
	CLR  R12
_0x2D7:
	LDI  R30,LOW(9)
	CP   R12,R30
	BRSH _0x2D8
; 0000 055C         {
; 0000 055D 
; 0000 055E                 if  (    // ( time>=budilnik_time[bud_temp]&& ( time<=budilnik_time[bud_temp] +  budilnik_Interval[bud_temp])  )
; 0000 055F                     ( time==budilnik_time[bud_temp] )                                 //      
; 0000 0560                 &&  ( budilnik_Install[bud_temp] & 0x80)                              //      ( )
; 0000 0561                 &&  ( budilnik_Install[bud_temp] & (1 << den_nedeli) )                //        
; 0000 0562                 )
	RCALL SUBOPT_0x9
	BRNE _0x2DA
	RCALL SUBOPT_0xA
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	LD   R30,Z
	ANDI R30,LOW(0x80)
	BREQ _0x2DA
	RCALL SUBOPT_0xA
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	LD   R1,Z
	MOV  R30,R9
	RCALL SUBOPT_0x86
	BRNE _0x2DB
_0x2DA:
	RJMP _0x2D9
_0x2DB:
; 0000 0563                 {bud_flg=1;budilnik_raz[bud_temp]-=1;}                                                            //    
	SET
	BLD  R2,4
	MOV  R26,R12
	RCALL SUBOPT_0x8D
	RCALL SUBOPT_0x2
	ST   X,R30
; 0000 0564 
; 0000 0565         //______________________ 
; 0000 0566                 if ( time==budilnik_time[bud_temp] + DLITEL_ZVONKA)    //    ""  ( 1  15 )
_0x2D9:
	MOV  R30,R12
	RCALL SUBOPT_0x80
	ADIW R30,10
	RCALL SUBOPT_0x1A
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x2DC
; 0000 0567                 {
; 0000 0568                 bud_flg=0;                                                            //    
	CLT
	BLD  R2,4
; 0000 0569                 if ((bud_temp<3)&&(budilnik_raz[bud_temp]==0))  {budilnik_Install[bud_temp] = 0;}                    //     "" ( 1-3),     
	LDI  R30,LOW(3)
	CP   R12,R30
	BRSH _0x2DE
	RCALL SUBOPT_0xA
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LD   R26,Z
	CPI  R26,LOW(0x0)
	BREQ _0x2DF
_0x2DE:
	RJMP _0x2DD
_0x2DF:
	RCALL SUBOPT_0xA
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0000 056A                 }
_0x2DD:
; 0000 056B 
; 0000 056C         }
_0x2DC:
	INC  R12
	RJMP _0x2D7
_0x2D8:
; 0000 056D         //______________________ 
; 0000 056E         if ( (time%60==0)&&( (time > 479) && (time <1261) )&&(zv_chs) ) {  but_flg=1;   TIMSK|=0x10;    but_pause=0;  }    //     ( 08-00  21-00   )
	RCALL SUBOPT_0x1A
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21U
	SBIW R30,0
	BRNE _0x2E1
	RCALL SUBOPT_0x1A
	CPI  R26,LOW(0x1E0)
	LDI  R30,HIGH(0x1E0)
	CPC  R27,R30
	BRLO _0x2E2
	RCALL SUBOPT_0x1A
	CPI  R26,LOW(0x4ED)
	LDI  R30,HIGH(0x4ED)
	CPC  R27,R30
	BRLO _0x2E3
_0x2E2:
	RJMP _0x2E1
_0x2E3:
	SBRC R3,3
	RJMP _0x2E4
_0x2E1:
	RJMP _0x2E0
_0x2E4:
	SET
	BLD  R3,0
	IN   R30,0x39
	ORI  R30,0x10
	OUT  0x39,R30
	CLR  R13
; 0000 056F flg_min=0;
_0x2E0:
	CLT
	BLD  R2,2
; 0000 0570 }
; 0000 0571 
; 0000 0572 
; 0000 0573 if ( ((bud_flg)&&(mig))  ||  (but_flg) )   { TIMSK|=0x10;}    //     ""  1 ( . )
_0x2D5:
	SBRS R2,4
	RJMP _0x2E6
	SBRC R2,0
	RJMP _0x2E8
_0x2E6:
	SBRS R3,0
	RJMP _0x2E5
_0x2E8:
	IN   R30,0x39
	ORI  R30,0x10
	RJMP _0x31F
; 0000 0574 
; 0000 0575 else  {PORTB.5=0; TIMSK&=0xEF;}
_0x2E5:
	CBI  0x18,5
	IN   R30,0x39
	ANDI R30,0xEF
_0x31F:
	OUT  0x39,R30
; 0000 0576 
; 0000 0577 
; 0000 0578 //****************************************************************************************************************************
; 0000 0579 while (POWER == OFF )   //    ,       -  
_0x2ED:
	SBRC R3,6
	RJMP _0x2EF
; 0000 057A     {
; 0000 057B     ACSR=0x80;          //         (   )
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 057C     #asm("sleep")       // ......
	sleep
; 0000 057D     ACSR=0x4b;          //  ,  .
	LDI  R30,LOW(75)
	OUT  0x8,R30
; 0000 057E     }
	RJMP _0x2ED
_0x2EF:
; 0000 057F //****************************************************************************************************************************
; 0000 0580 };
	JMP  _0x17D
; 0000 0581 }
_0x2F0:
	RJMP _0x2F0

	.CSEG
_ds18b20_select:
	ST   -Y,R17
	CALL _w1_init
	CPI  R30,0
	BRNE _0x2000003
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x2000003:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	SBIW R30,0
	BREQ _0x2000004
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
_0x2000006:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	ST   -Y,R30
	CALL _w1_write
	SUBI R17,-LOW(1)
	CPI  R17,8
	BRLO _0x2000006
	RJMP _0x2000008
_0x2000004:
	LDI  R30,LOW(204)
	ST   -Y,R30
	CALL _w1_write
_0x2000008:
	LDI  R30,LOW(1)
	RJMP _0x2020001
_ds18b20_read_spd:
	CALL __SAVELOCR4
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RCALL SUBOPT_0x9F
	CPI  R30,0
	BRNE _0x2000009
	LDI  R30,LOW(0)
	RJMP _0x2020002
_0x2000009:
	LDI  R30,LOW(190)
	ST   -Y,R30
	CALL _w1_write
	LDI  R17,LOW(0)
	__POINTWRM 18,19,___ds18b20_scratch_pad
_0x200000B:
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	CALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-LOW(1)
	CPI  R17,9
	BRLO _0x200000B
	LDI  R30,LOW(___ds18b20_scratch_pad)
	LDI  R31,HIGH(___ds18b20_scratch_pad)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(9)
	ST   -Y,R30
	CALL _w1_dow_crc8
	CALL __LNEGB1
_0x2020002:
	CALL __LOADLOCR4
	ADIW R28,6
	RET
_ds18b20_convert_temp:
	RCALL SUBOPT_0xA0
	RCALL SUBOPT_0xA1
	LDI  R26,LOW(0)
	CALL __EQB12
	LDI  R30,LOW(68)
	ST   -Y,R30
	CALL _w1_write
	RJMP _0x2020001
_ds18b20_read_temp:
	RCALL SUBOPT_0xA0
	CPI  R30,0
	BRNE _0x200000D
	RCALL SUBOPT_0xA2
	RJMP _0x2020001
_0x200000D:
	RCALL SUBOPT_0xA1
	CPI  R30,0
	BRNE _0x200000E
	RCALL SUBOPT_0xA2
	RJMP _0x2020001
_0x200000E:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ds18b20_read_spd
	CPI  R30,0
	BRNE _0x200000F
	RCALL SUBOPT_0xA2
	RJMP _0x2020001
_0x200000F:
	CALL _w1_init
	MOV  R30,R17
	LDI  R26,LOW(_bit_mask_G100*2)
	LDI  R27,HIGH(_bit_mask_G100*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	LDS  R26,___ds18b20_scratch_pad
	LDS  R27,___ds18b20_scratch_pad+1
	AND  R30,R26
	AND  R31,R27
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3D800000
	CALL __MULF12
_0x2020001:
	LDD  R17,Y+0
	ADIW R28,3
	RET

	.DSEG
___ds18b20_scratch_pad:
	.BYTE 0x9
_z:
	.BYTE 0x1
_z1:
	.BYTE 0x1
_bud:
	.BYTE 0x1
_temp:
	.BYTE 0x1
_temp1:
	.BYTE 0x1
_temp2:
	.BYTE 0x1
_t:
	.BYTE 0x1
_flg_korr:
	.BYTE 0x1
_foto_r:
	.BYTE 0x1
_str_sec:
	.BYTE 0x1
_font_:
	.BYTE 0x1
_sek0:
	.BYTE 0x1
_mig1_pause:
	.BYTE 0x1
_ekran:
	.BYTE 0x18
_beg_info:
	.BYTE 0x96
_rom_code:
	.BYTE 0x12
_budilnik_Install:
	.BYTE 0x9
_budilnik_raz:
	.BYTE 0x4
_budilnik_time:
	.BYTE 0x12
_budilnik_txt:
	.BYTE 0xB
_korekt_txt:
	.BYTE 0xC
_nastroiki_txt:
	.BYTE 0xB
_nastr_stroki_txt:
	.BYTE 0xB
_speed_txt:
	.BYTE 0x19
_perenazna_datchik:
	.BYTE 0x19
_budilnik_raz_txt:
	.BYTE 0xD
_interval_txt:
	.BYTE 0x19
_font_zifr_txt:
	.BYTE 0xC
_time:
	.BYTE 0x2
_Interval:
	.BYTE 0x2
_Interval_2:
	.BYTE 0x2
_data1:
	.BYTE 0x2
_time_meny:
	.BYTE 0x2
_temperature_temp:
	.BYTE 0x4

	.ESEG
_korr_den:
	.BYTE 0x2
_brigh_up_time:
	.BYTE 0x2
_brigh_down_time:
	.BYTE 0x2
_str_period:
	.BYTE 0x2
_td10:
	.BYTE 0x2
_tu10:
	.BYTE 0x2
_speed:
	.BYTE 0x2
_font_epp:
	.BYTE 0x2
_sek_ind:
	.DW  0x1
_ds1820_d:
	.BYTE 0x2
_ds1820_y:
	.BYTE 0x2
_brigh_up:
	.BYTE 0x1
_str:
	.DB  0x1B

	.DSEG
_devices_G000:
	.BYTE 0x1
_i_G000:
	.BYTE 0x1
_temperature_G000:
	.BYTE 0x1C
_error_ds18b20:
	.BYTE 0x2
_simvol:
	.BYTE 0x113
_dl_1_S0000007000:
	.BYTE 0x1
_dl_2_S0000007000:
	.BYTE 0x1
_Shift_zn_S000000A000:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x0:
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1:
	MOV  R30,R17
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	LDI  R31,0
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(_korr_den+1)
	LDI  R27,HIGH(_korr_den+1)
	CALL __EEPROMRDB
	TST  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x4:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMRDW
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	LDI  R26,LOW(25)
	MULS R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(0)
	STS  _time_meny,R30
	STS  _time_meny+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x9:
	MOV  R30,R12
	LDI  R26,LOW(_budilnik_time)
	LDI  R27,HIGH(_budilnik_time)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	LDS  R26,_time
	LDS  R27,_time+1
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA:
	MOV  R30,R12
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R30,LOW(_rom_code)
	LDI  R31,HIGH(_rom_code)
	ST   -Y,R31
	ST   -Y,R30
	CALL _w1_search
	STS  _devices_G000,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 29 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xE:
	LDI  R26,LOW(_ds1820_d)
	LDI  R27,HIGH(_ds1820_d)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 29 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0xF:
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(_ds1820_y)
	LDI  R27,HIGH(_ds1820_y)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x11:
	IN   R30,0x5
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	MOVW R26,R30
	IN   R30,0x3C
	LDI  R31,0
	SUB  R26,R30
	SBC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	IN   R30,0x3C
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x14:
	LDI  R26,LOW(_brigh_down_time)
	LDI  R27,HIGH(_brigh_down_time)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x15:
	LDI  R26,LOW(_brigh_up_time)
	LDI  R27,HIGH(_brigh_up_time)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x16:
	LDS  R26,_time
	LDS  R27,_time+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x17:
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	CALL __EEPROMRDB
	LDI  R26,LOW(23)
	MULS R30,R26
	MOVW R30,R0
	SUBI R30,-LOW(1)
	OUT  0x3C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	LDI  R26,LOW(_str_period)
	LDI  R27,HIGH(_str_period)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x19:
	LDS  R26,_str_sec
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x1A:
	LDS  R26,_time
	LDS  R27,_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	CALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1E:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	LDS  R26,_data1
	LDS  R27,_data1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x20:
	STS  _data1,R30
	STS  _data1+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	RCALL SUBOPT_0x1A
	CPI  R26,LOW(0x258)
	LDI  R30,HIGH(0x258)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x22:
	LDD  R30,Y+6
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x23:
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	ADD  R26,R22
	ADC  R27,R23
	LD   R26,X
	LDS  R30,_Shift_zn_S000000A000
	CALL __LSLB12
	MOV  R24,R30
	LDI  R26,LOW(5)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:48 WORDS
SUBOPT_0x25:
	ADD  R26,R30
	ADC  R27,R31
	LD   R22,X
	CLR  R23
	LDS  R30,_Shift_zn_S000000A000
	LDI  R31,0
	LDI  R26,LOW(8)
	LDI  R27,HIGH(8)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	CALL __ASRW12
	ADD  R30,R24
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	MOVW R24,R30
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	MOVW R22,R30
	LDI  R26,LOW(5)
	RJMP SUBOPT_0x24

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	ADD  R26,R24
	ADC  R27,R25
	LD   R30,X
	MOVW R26,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x28:
	MOVW R22,R30
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	MOVW R0,R30
	__POINTW2MN _simvol,225
	ADD  R26,R22
	ADC  R27,R23
	LD   R30,X
	MOVW R26,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	MUL  R16,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2A:
	LDD  R26,Y+6
	LDI  R30,LOW(4)
	CALL __EQB12
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,5
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRS R2,0
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2B:
	MOVW R24,R30
	__ADDW1MN _ekran,6
	MOVW R22,R30
	LDI  R26,LOW(5)
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2C:
	ADD  R26,R24
	ADC  R27,R25
	LD   R30,X
	SUBI R30,-LOW(128)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2D:
	MUL  R19,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x2E:
	LDD  R26,Y+6
	LDI  R30,LOW(0)
	CALL __EQB12
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,5
	LDI  R30,1
	AND  R30,R26
	MOV  R26,R30
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	AND  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2F:
	MOVW R24,R30
	__ADDW1MN _ekran,13
	MOVW R22,R30
	LDI  R26,LOW(5)
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x30:
	LDD  R30,Y+3
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x31:
	MOV  R26,R17
	CLR  R27
	LDD  R30,Y+2
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	SUBI R30,LOW(-_ekran)
	SBCI R31,HIGH(-_ekran)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x32:
	MOV  R26,R17
	CLR  R27
	LDD  R30,Y+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x33:
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x34:
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	MOVW R26,R22
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x35:
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x36:
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x37:
	ST   -Y,R30
	LDI  R30,LOW(19)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x38:
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x39:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3A:
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3B:
	CALL __DIVW21U
	LDI  R26,LOW(60)
	LDI  R27,HIGH(60)
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3C:
	ST   -Y,R30
	LDI  R30,LOW(13)
	ST   -Y,R30
	JMP  _ystanovki_2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3D:
	MOV  R26,R17
	LDI  R27,0
	SUBI R26,LOW(-_ekran)
	SBCI R27,HIGH(-_ekran)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x3E:
	LDS  R30,_z1
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3F:
	LD   R30,X
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R26,R30
	LDS  R30,_z
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x40:
	LDI  R30,LOW(0)
	STS  _z,R30
	LDS  R30,_z1
	SUBI R30,-LOW(1)
	STS  _z1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x41:
	LD   R30,X
	LDI  R26,LOW(5)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	MOVW R22,R30
	LDS  R30,_z
	LDI  R31,0
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R26,R22
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x42:
	LDI  R26,LOW(5)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_simvol)
	SBCI R31,HIGH(-_simvol)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x43:
	MOVW R26,R30
	LDS  R30,_i_G000
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x44:
	ADD  R30,R26
	ADC  R31,R27
	MOVW R22,R30
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x45:
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	MOVW R26,R22
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x46:
	LDI  R26,LOW(_budilnik_time)
	LDI  R27,HIGH(_budilnik_time)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x47:
	LDS  R30,_temp
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x48:
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LDI  R26,LOW(1)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x49:
	LDS  R30,_temp
	SUBI R30,-LOW(1)
	STS  _temp,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4A:
	LDI  R26,LOW(_brigh_up)
	LDI  R27,HIGH(_brigh_up)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x4B:
	LDI  R26,LOW(_speed)
	LDI  R27,HIGH(_speed)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4C:
	LDI  R26,LOW(_td10)
	LDI  R27,HIGH(_td10)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4D:
	LDI  R26,LOW(_tu10)
	LDI  R27,HIGH(_tu10)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4F:
	LDI  R26,LOW(_sek_ind)
	LDI  R27,HIGH(_sek_ind)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x50:
	LDS  R30,_time
	LDS  R31,_time+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x51:
	LDS  R30,_i_G000
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_rom_code)
	SBCI R31,HIGH(-_rom_code)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x52:
	LDS  R26,_temperature_temp
	LDS  R27,_temperature_temp+1
	LDS  R24,_temperature_temp+2
	LDS  R25,_temperature_temp+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x53:
	LDS  R30,_i_G000
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x54:
	LDS  R30,_i_G000
	LDI  R31,0
	SUBI R30,LOW(-_error_ds18b20)
	SBCI R31,HIGH(-_error_ds18b20)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x55:
	LDI  R26,LOW(_str)
	LDI  R27,HIGH(_str)
	CALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	STS  _temp,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x57:
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	STS  _t,R30
	STS  _temp1,R30
	LDI  R30,LOW(30)
	MOV  R6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x58:
	RCALL SUBOPT_0x1A
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	RJMP SUBOPT_0x3B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x59:
	RCALL SUBOPT_0x1A
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MULW12U
	MOVW R26,R30
	MOV  R30,R5
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x5A:
	MOV  R6,R30
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 25 TIMES, CODE SIZE REDUCTION:93 WORDS
SUBOPT_0x5B:
	LDI  R30,LOW(0)
	STS  _t,R30
	STS  _temp1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x5C:
	LDS  R30,_t
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x5D:
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5E:
	LDI  R26,LOW(44)
	STD  Z+0,R26
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x5F:
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R22
	ST   X,R30
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:74 WORDS
SUBOPT_0x60:
	MOVW R26,R22
	ST   X,R30
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x61:
	LDS  R26,_Interval
	LDS  R27,_Interval+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x62:
	LDI  R30,LOW(0)
	STS  _Interval,R30
	STS  _Interval+1,R30
	LDI  R30,LOW(_beg_info)
	LDI  R31,HIGH(_beg_info)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x63:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 133 TIMES, CODE SIZE REDUCTION:1185 WORDS
SUBOPT_0x64:
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_beg_info)
	SBCI R31,HIGH(-_beg_info)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x65:
	RCALL SUBOPT_0x1A
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x66:
	MOVW R26,R30
	LDI  R30,LOW(42)
	ST   X,R30
	MOVW R26,R0
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x67:
	MOV  R30,R9
	LDI  R26,LOW(12)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_den_nedeli_txt*2)
	SBCI R31,HIGH(-_den_nedeli_txt*2)
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x68:
	LDS  R30,_t
	SUBI R30,-LOW(1)
	STS  _t,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x69:
	LDI  R26,LOW(9)
	LDI  R27,HIGH(9)
	CALL __MULW12U
	SUBI R30,LOW(-_name_mesec_txt*2)
	SBCI R31,HIGH(-_name_mesec_txt*2)
	MOVW R22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6A:
	LDS  R30,_temp1
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADD  R30,R22
	ADC  R31,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x6B:
	LDI  R26,LOW(42)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x6C:
	LDI  R26,LOW(24)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6D:
	LDI  R26,LOW(10)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 42 TIMES, CODE SIZE REDUCTION:243 WORDS
SUBOPT_0x6E:
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:65 WORDS
SUBOPT_0x6F:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _abs

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x70:
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x71:
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0x72:
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x73:
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __MODW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x74:
	LDI  R26,LOW(43)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x75:
	LDI  R26,LOW(15)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:77 WORDS
SUBOPT_0x76:
	CALL _ochistka
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RJMP SUBOPT_0x5B

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x77:
	LDI  R30,LOW(0)
	STS  _z,R30
	STS  _z1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x78:
	RCALL SUBOPT_0x50
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x79:
	LDI  R30,LOW(0)
	STS  _Interval,R30
	STS  _Interval+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7A:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _beg_stroka

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7B:
	LDI  R30,LOW(11)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7C:
	LDS  R30,_bud
	SUBI R30,-LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7D:
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _ekran_1_figure
	CLT
	BLD  R3,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x7E:
	LDS  R30,_bud
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	LD   R30,Z
	ANDI R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 54 TIMES, CODE SIZE REDUCTION:156 WORDS
SUBOPT_0x7F:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x80:
	LDI  R26,LOW(_budilnik_time)
	LDI  R27,HIGH(_budilnik_time)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x81:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _ystanovki_23_59

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x82:
	LDS  R30,_bud
	LDI  R31,0
	SUBI R30,LOW(-_budilnik_Install)
	SBCI R31,HIGH(-_budilnik_Install)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x83:
	LDS  R30,_temp
	LDI  R26,LOW(_den_nedeli_letter*2)
	LDI  R27,HIGH(_den_nedeli_letter*2)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x84:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x85:
	ST   -Y,R30
	LDI  R30,LOW(6)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x86:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	CALL __LSLW12
	MOV  R26,R1
	LDI  R27,0
	AND  R30,R26
	AND  R31,R27
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x87:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _ekran_1_figure

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x88:
	LDS  R30,_bud
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x89:
	SUBI R30,LOW(-_budilnik_raz)
	SBCI R31,HIGH(-_budilnik_raz)
	LD   R30,Z
	ST   -Y,R30
	LDI  R30,LOW(2)
	RJMP SUBOPT_0x87

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8A:
	ST   -Y,R30
	LDI  R30,LOW(12)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x8B:
	ST   -Y,R30
	LDI  R30,LOW(9)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8C:
	ST   -Y,R30
	LDI  R30,LOW(15)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8D:
	LDI  R27,0
	SUBI R26,LOW(-_budilnik_raz)
	SBCI R27,HIGH(-_budilnik_raz)
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8E:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R30
	CALL _ekran_1_figure
	LDI  R30,LOW(43)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x8F:
	EOR  R30,R26
	LDI  R26,LOW(_str)
	LDI  R27,HIGH(_str)
	CALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x90:
	ST   -Y,R30
	LDI  R30,LOW(10)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x91:
	ST   -Y,R30
	LDI  R30,LOW(4)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x92:
	ST   -Y,R30
	LDI  R30,LOW(5)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x93:
	ST   -Y,R30
	LDI  R30,LOW(14)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x94:
	LDI  R31,0
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x95:
	STS  _temp,R30
	LDI  R30,LOW(51)
	MOV  R6,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x96:
	LDI  R30,LOW(27)
	ST   -Y,R30
	LDI  R30,LOW(19)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x97:
	LDI  R26,LOW(60)
	LDI  R27,HIGH(60)
	SUB  R26,R30
	SBC  R27,R31
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x98:
	LDI  R30,0
	SBRC R3,7
	LDI  R30,1
	LDI  R26,LOW(_temperature_G000)
	LDI  R27,HIGH(_temperature_G000)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x99:
	LDI  R26,LOW(28)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9A:
	LDI  R26,LOW(33)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9B:
	LDI  R26,LOW(20)
	STD  Z+0,R26
	RJMP SUBOPT_0x64

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x9C:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMRDW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9D:
	LDI  R26,LOW(_korr_den)
	LDI  R27,HIGH(_korr_den)
	CALL __EEPROMWRW
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9E:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9F:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ds18b20_select

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA0:
	ST   -Y,R17
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ds18b20_read_spd

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA1:
	__GETB2MN ___ds18b20_scratch_pad,4
	LDI  R27,0
	LDI  R30,LOW(5)
	CALL __ASRW12
	ANDI R30,LOW(0x3)
	MOV  R17,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RJMP SUBOPT_0x9F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA2:
	__GETD1N 0xC61C3C00
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x3C0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x25
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0xCB
	sbis __w1_port-2,__w1_bit
	ldi  r30,1
	__DELAY_USW 0x30C
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x5
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x1D
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0xD5
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x5
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x23
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0xC8
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xD
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	ldd  r27,y+1
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+2
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,3
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
